#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=ClipSpirit-Pref.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Module de gestion des prfrences
#AutoIt3Wrapper_Res_Description=ClipSpirit - L'esprit de votre presse-papier
#AutoIt3Wrapper_Res_Fileversion=1.2.0.10
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ---------------------------------------------------------------------------

	ClipSpirit-Pref - Gestion des Prfrences de ClipSpirit
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Octobre 2010 - Octobre 2011

	BUG & Evolutions : A placer dans ClipSpirit.au3

#ce ---------------------------------------------------------------------------


#include <Color.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <FTPEx.au3>
#include <GuiButton.au3>
#include <GuiComboBox.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GuiListView.au3>
#include <GuiTab.au3>
#include <Math.au3>
#include <Misc.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <TabConstants.au3>
#include <WindowsConstants.au3>
#include "ClipSpiritLib.au3"
#include "ClipSpiritExec.au3"
#include "ClipSpiritDB.au3"


AutoItSetOption("MustDeclareVars", 1)
Opt("WinTitleMatchMode", 3) ;1=start, 2=subStr, 3=exact, 4=advanced, -1 to -4=Nocase

;----- Titre de la fentre ----------------------------------------------------
Global $sFenetreTitre = $scAppliTitreGeneral & " - Gestion des prfrences  v" & NumVerCourt($scVersion)
If Not @Compiled Then $sFenetreTitre &= " Test"
$sFenetreTitre &= " By Ahbadiane"

;----- Base de donnes --------------------------------------------------------
If DbOuvrir($scProgPreference) = "" Then Exit

;----- Variables globales -----------------------------------------------------
Global $idMsg, $sTemp, $sbEnregistrer, $iTabActif = -1
Global $sListToucheToutLibelle[79] = ["Aucune", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "", "", "", "", "", "(", ")", "'", '"', "_", "-", "*", "/", "=", ",", ".", ";", "", "$", "", "%", "?", "", "&", "F1"  , "F2"  , "F3"  , "F4"  , "F5"  , "F6"  , "F7"  , "F8"  , "F9"  , "F10"  , "F11"  , "F12"  , "Flche Droite", "Flche Gauche", "Flche Haut", "Flche Bas", "Page Prcdente", "Page Suivante", "Page Accueil", "Page Finale", "Espace" , "Suppr", "Inser", "Echap", "Pause" , "Impression Ecran", "Tabulation", "Retour Arrire"]
Global $sListToucheToutCode[79]    = [""      , "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "", "", "", "", "", "(", ")", "'", '"', "_", "-", "*", "/", "=", ",", ".", ";", "", "$", "", "%", "?", "", "&", "{F1}", "{F2}", "{F3}", "{F4}", "{F5}", "{F6}", "{F7}", "{F8}", "{F9}", "{F10}", "{F11}", "{F12}", "{RIGHT}"      , "{LEFT}"       , "{UP}"       , "{DOWN}"    , "{PGUP}"         , "{PGDN}"       , "{HOME}"      , "{END}"      , "{SPACE}", "{DEL}", "{INS}", "{ESC}", "{PAUSE}", "{PRINTSCREEN}"  , "{TAB}"     , "{BS}"          ]
Global $sListToucheFonctionPlusLibelle[15] = ["Aucune", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12", "Page Prcdente", "Page Suivante"]
Global $sListToucheFonctionPlusCode[15]    = [""      , "70", "71", "72", "73", "74", "75", "76", "77", "78", "79" , "7A" , "7B" , "21"             , "22"           ]
Global $sListFormatImage[5] = ["JPG", "PNG", "BMP", "TIF", "GIF"]
; Couleurs
Global Const $iNbCouleurTotal = 140
Global Const $sCouleursToutesLibelles[$iNbCouleurTotal] = ["Blanc", "Lin", "Argile", "Jaune de Naples", "Jaune soufre", "Coquille d'uf", "Bleu drage", "tain pur", "Beurre frais", "Jaune mimosa", "Bisque", "Jaune secondaire", "Topaze", "Flave", "Jaune poussin", "Jaune paille", "Beurre", "Jaune chartreuse", "Jaune imprial", "Vert d'eau", "Jaune aurolin", "Vert pistache", "Rose drage", "Papier bulle", "Aigue-marine", "Chair", "Pervenche", "Vert chartreuse", "Pche", "Sable", "Aurore", "Argent", "Bleu fume", "Jaune de Mars", "Vert lime", "Jaune d'or", "Vert opaline", "Vert anis", "Chartreuse", "Vert menthe  l'eau", "Ambre jaune", "Bleu turquoise", "Azur clair", "Parme", "Incarnadin", "Vert tilleul", "Jaune moutarde", "Mandarine", "Glycine", "Cyan clair secondaire", "Miel", "Bleu ciel", "Vert perroquet", "Vert lichen", "Saumon", "Vert printemps", "Melon", "Gris souris", "Vert prairie", "Incarnat", "Mauve", "Vert cladon", "Bleu cleste", "Tangerine", "Vert primaire", "Bleu lavande", "Orange", "Vert pomme", "Rose balais", "Carotte", "Rose bonbon", "Havane", "Poil de chameau", "Gris plomb", "Bleu roi", "Feu vif", "Cuivre", "Vert gazon", "Bistre", "Bleu bleuet", "Gris de Payne", "Bleu lectrique", "Rouge grenadine", "Mauve", "Bleu azur", "Cerise", "Corail", "Magenta secondaire", "Amthyste", "Vert avocat", "Tabac", "Roux", "Claro", "Feuille morte", "Rouge d'alizarine", "Rouge anglais", "Sinople", "Vert militaire", "Rouge framboise", "Rouge feu", "Fuchsia", "Bleu paon", "Rouge-violet", "Ambre rouge", "Lapis-lazuli", "Denim", "Garance", "Vert de vessie", "Violet d'vque", "Indigo chaud", "Rouge vermillon", "Bronze", "Lie de vin", "Rouge primaire", "Rouge cardinal", "Amarante", "carlate", "Caramel", "Vert bouteille", "Rouge coquelicot", "Gris taupe", "Bleu de cobalt", "Pourpre", "Indigo lectrique", "Bleu ptrole", "Vert de Hooker", "Rouge de Falun", "Vert imprial", "Magenta fonc", "Marron", "Caf", "Smalt", "Rouge bordeaux", "Rglisse", "Bleu marine", "Bleu primaire", "Bleu outremer", "Cassis", "Noir d'aniline", "Noir"]
Global Const $sCouleursToutesCodes[$iNbCouleurTotal] = ["FFFFFF","FAF0E6","EFEFEF","FFF0BC","FFFF6B","FDE9E0","DFF2FF","EDEDED","FFF48D","FEF86C","FFE4C4","FFFF00","FAEA73","E6E697","F7E35F","FEE347","F0E36B","DFFF00","FFE436","B0F2B6","FDEE00","BEF574","FEBFD2","EDD38C","79F8F8","FEC3AC","CCCCFF","C2F732","FDBFB7","E0CDA9","FFCB60","CECECE","BBD2E1","EED153","9EFD38","EFD807","97DFC6","9FE855","7FFF00","54F98D","F0C300","25FDE9","74D0F1","CFA0E9","FE96A0","A5D152","C7CF00","FEA347","C9A0DC","00FFFF","DAB30A","77B5FE","3AF24B","85C17E","F88E55","00FF7F","DE9816","9E9E9E","57D53B","FF6F7D","D473D4","83A697","26C4EC","FF7F00","00FF00","9683EC","ED7F10","34C924","C4698F","F4661B","F9429E","947F60","B67823","798081","318CE7","FF4901","B36700","3A9D23","856D4D","5472AE","677179","2C75FF","E9383F","965578","1E7FCB","DE3163","E73E01","FF00FF","884DA7","568203","9F551E","AD4F09","845A3B","99512B","E32636","F7230C","149414","596643","C72C48","FE1B00","F400A1","067790","C71585","AD390E","26619C","1560BD","EE1010","22780F","723E64","791CF8","DB1702","614E1A","AC1E44","FF0000","B82010","91283B","ED0000","7E3300","096A09","C60800","463F32","22427C","9E0E40","6F00FF","1D4851","1B4F08","801818","00561B","800080","582900","462E01","003399","6D071A","2D241E","03224C","0000FF","1B019B","3A020D","120D16","000000"]
Global $sCouleursChoisiesCodes[$iNbCouleurTotal + 1], $sCouleursChoisiesLibelles[$iNbCouleurTotal + 1]
Global $sCouleursRestantesCodes[$iNbCouleurTotal + 1], $sCouleursRestantesLibelles[$iNbCouleurTotal + 1]
Global $sSimulChaineCouleur
Global $sSimulTableauCouleurs[1]
; Scripting
Global Const $iParamScriptNbVarRW = 30 ; Read/Write
Global Const $sParamScriptVarRW[$iParamScriptNbVarRW] = ["%a%", "%b%", "%c%", "%d%", "%e%", "%f%", "%g%", "%h%", "%i%", "%j%", "%k%", "%l%", "%m%", "%n%", "%o%", "%p%", "%q%", "%r%", "%s%", "%t%", "%u%", "%v%", "%w%", "%x%", "%y%", "%z%", "%Titre%", "%Texte%", "%Commentaire%", "%Couleur%"]
Global Const $iParamScriptNbVarR = 2 ; Read uniquement
Global Const $sParamScriptVarR[$iParamScriptNbVarR] = ["%Provenance%", "%Extended%"] ; %Error% ne peut pas tre cr car dans l'excute si @Error <> 0 alors on arrte
Global Const $iParamScriptNbProcedure = 4
Global Const $sParamScriptProcedure[$iParamScriptNbProcedure] = ["PutToClipboard", "ContinueLoop", "ExitLoop", "Exit"]
Global $iItemSelectListViewProg, $sTypeScript
Global $iEtatScriptDetail = 0 ; 0=Visu, 1=Modif, 2=Cration
Global $bScriptEnregistre = False
Global $sSimulTitre = "Exemple de titre"
Global $sSimulTexte = "Texte du presse-papier" & @CRLF & "Ligne 2" & @CRLF & "Ligne 3"
Global $sSimulCommentaire = "Commentaire"
Global $sSimulProvenance = "Excel"
Global $sScriptEdFont
Global $sScriptEdFontNom = DbParamLireTexte("PrefScriptEdFontNom", "Courier")
Global $iScriptEdFontTaille = DbParamLireNum("PrefScriptEdFontTaille", 12)
Global $iScriptEdFontPoids = DbParamLireNum("PrefScriptEdFontPoids", 400)
Global $iScriptEdFontCouleur = DbParamLireNum("PrefScriptEdFontCouleur", 0)
Global $iScriptLigneEnErreur = 0
Global $scFicDebug = @ScriptDir & "\" & $scAppliTitreGeneral & "Debug.txt"
Global $sToucheAide = DbParamLireTexte("ToucheAide", "7B") ; Touche F12
Global $scFichierAide = @ScriptDir & "\" & $scAppliTitreGeneral & ".chm"
Global $sAideContexte
; Synchronisation
Global $iSynchroStepInit
; Divers
Global $iTemp


;----- Une seule instance -----------------------------------------------------
If _Singleton($sFenetreTitre,1) = 0 Then
	MsgBox(4144, $scMsgErreur, "La gestion des prfrences est dj lance !")
	Exit
EndIf


;----- Interface --------------------------------------------------------------
#Region ### START Koda GUI section ### Form=ClipSpirit-Pref.kxf
Global $FormClipSpiritPref = GUICreate("~Titre~", 803, 616, -1, -1)
Global $ButtonAide = GUICtrlCreateButton("Aide", 438, 582, 75, 25, $BS_NOTIFY)
Global $ButtonOK = GUICtrlCreateButton("Valider", 526, 582, 75, 25, $BS_NOTIFY)
Global $ButtonAnnuler = GUICtrlCreateButton("Annuler", 614, 582, 75, 25, $BS_NOTIFY)
Global $ButtonAppliquer = GUICtrlCreateButton("Appliquer", 702, 582, 75, 25, $BS_NOTIFY)
Global $TabSheet = GUICtrlCreateTab(8, 8, 788, 564, 0)
Global $TabSheetGeneral = GUICtrlCreateTabItem("      Gnral         ")
Global $Group1_1 = GUICtrlCreateGroup(" Touches utilises ", 21, 40, 760, 162)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label1_101 = GUICtrlCreateLabel("Touches d'activation de l'application", 30, 68, 213, 17, 0)
Global $CheckboxShift1_101 = GUICtrlCreateCheckbox("Shift", 477, 68, 42, 17)
Global $CheckboxCtrl1_101 = GUICtrlCreateCheckbox("Ctrl", 526, 68, 36, 17)
Global $CheckboxAlt1_101 = GUICtrlCreateCheckbox("Alt", 569, 68, 32, 17)
Global $CheckboxWin1_101 = GUICtrlCreateCheckbox("Win", 609, 68, 38, 17)
Global $ComboTouche1_101 = GUICtrlCreateCombo("", 656, 66, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label1_102 = GUICtrlCreateLabel("Touche pour afficher ou cacher l'diteur afin de voir ou masquer le dtail des items texte", 30, 95, 508, 17, 0)
Global $ComboTouche1_102 = GUICtrlCreateCombo("", 656, 93, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label1_103 = GUICtrlCreateLabel("Touche pour modifier ou valider le texte d'un item", 30, 122, 285, 17, 0)
Global $ComboTouche1_103 = GUICtrlCreateCombo("", 656, 120, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label1_104 = GUICtrlCreateLabel("Touche pour passer d'un onglet  un autre", 30, 149, 246, 17, 0)
Global $ComboTouche1_104 = GUICtrlCreateCombo("", 656, 147, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label1_105 = GUICtrlCreateLabel("Touche pour afficher l'aide", 30, 176, 157, 17, 0)
Global $ComboTouche1_105 = GUICtrlCreateCombo("", 656, 174, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group1_2 = GUICtrlCreateGroup(" Taille ", 21, 208, 760, 108)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label1_201 = GUICtrlCreateLabel("Hauteur en pixel de l'application", 30, 236, 154, 17, 0)
Global $Label1_201b = GUICtrlCreateLabel("(avec les bords de la fentre, l'application occupera 34 pixels en plus)", 190, 236, 397, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input1_201 = GUICtrlCreateInput("", 711, 234, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label1_202 = GUICtrlCreateLabel("Largeur en pixel de la partie liste", 30, 263, 154, 17, 0)
Global $Label1_202b = GUICtrlCreateLabel("(avec les bords de la fentre, l'application occupera 20 pixels en plus)", 190, 263, 403, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input1_202 = GUICtrlCreateInput("", 711, 261, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label1_203 = GUICtrlCreateLabel("Largeur en pixel de la partie diteur des items", 30, 290, 263, 17, 0)
Global $Input1_203 = GUICtrlCreateInput("", 711, 288, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group1_3 = GUICtrlCreateGroup(" Comportement ", 21, 323, 760, 110)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox1_301 = GUICtrlCreateCheckbox("La croix systme, en haut  gauche de la fentre, ferme l'application mais ne l'iconise pas", 30, 351, 545, 17)
Global $Checkbox1_302 = GUICtrlCreateCheckbox("La touche Echap ferme l'application mais ne l'iconise pas ", 30, 378, 545, 17)
Global $Checkbox1_303 = GUICtrlCreateCheckbox("La fentre s'ouvre et reste par dfaut au dessus des autres", 30, 405, 300, 17)
Global $Label1_303b = GUICtrlCreateLabel("(ce choix pourra tre modifi dans l'application)", 331, 407, 273, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group1_4 = GUICtrlCreateGroup(" Backup ", 21, 441, 760, 121)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label1_401 = GUICtrlCreateLabel("Mode de backup de vos donnes", 30, 469, 193, 17, 0)
Global $Checkbox1_401a = GUICtrlCreateCheckbox("Manuellement", 227, 469, 106, 17)
Global $Checkbox1_401b = GUICtrlCreateCheckbox("Automatiquement chaque jour", 385, 469, 186, 17)
Global $Checkbox1_401c = GUICtrlCreateCheckbox("Au dmarrage de l'application", 599, 469, 178, 17)
Global $Label1_402 = GUICtrlCreateLabel("Nombre maximum de backups  conserver", 30, 496, 218, 17, 0)
Global $Label1_402b = GUICtrlCreateLabel("(Notez 0 pour conserver un nombre infini de backups)", 251, 496, 309, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input1_402 = GUICtrlCreateInput("", 711, 494, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 3)
Global $Label1_403 = GUICtrlCreateLabel("Dossier de dpt des backups", 30, 523, 176, 17, 0)
Global $Input1_403 = GUICtrlCreateInput("", 226, 521, 454, 21, $GUI_SS_DEFAULT_INPUT)
Global $Button1_403 = GUICtrlCreateButton("Chercher", 693, 520, 75, 23, $BS_NOTIFY)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetOngletTexte = GUICtrlCreateTabItem("   Onglet Texte    ")
Global $Group2_1 = GUICtrlCreateGroup(" Gnral ", 21, 40, 760, 200)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label2_101 = GUICtrlCreateLabel("Titre de l'onglet Texte", 30, 68, 129, 17, 0)
Global $Input2_101 = GUICtrlCreateInput("", 544, 66, 225, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
Global $Label2_101b = GUICtrlCreateLabel("(Ce titre peut comporter des espaces en dbut et fin pour largir la taille de l'onglet)", 141, 68, 480, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Label2_102 = GUICtrlCreateLabel("Nombre maximum de lignes conserves", 30, 95, 225, 17, 0)
Global $Label2_102b = GUICtrlCreateLabel("(Au-del de cette valeur, les lignes les plus anciennes seront supprimes automatiquement)", 227, 95, 521, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input2_102 = GUICtrlCreateInput("", 712, 93, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 3)
Global $Label2_103 = GUICtrlCreateLabel("Touches permettant de coller les items de texte slectionns sans ouvrir l'application", 30, 122, 430, 17, 0)
Global $CheckboxShift2_103 = GUICtrlCreateCheckbox("Shift", 471, 122, 46, 17)
Global $CheckboxCtrl2_103 = GUICtrlCreateCheckbox("Ctrl", 526, 122, 36, 17)
Global $CheckboxAlt2_103 = GUICtrlCreateCheckbox("Alt", 569, 122, 32, 17)
Global $CheckboxWin2_103 = GUICtrlCreateCheckbox("Win", 609, 122, 38, 17)
Global $ComboTouche2_103 = GUICtrlCreateCombo("", 656, 120, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label2_301b = GUICtrlCreateLabel("(Il est ncessaire de choisir une combinaison de touches inutilises par vos autres applications Windows car cette combinaison de touches sera appelle hors de ClipSpirit)", 30, 141, 420, 33, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Checkbox2_104 = GUICtrlCreateCheckbox("Afficher la totalit du texte de l'item survol par la souris dans une infobulle", 30, 180, 460, 17)
Global $Label2_105 = GUICtrlCreateLabel("Laps de temps avant l'affichage de la totalit du texte de l'item survol par la souris", 30, 207, 479, 17, 0)
Global $Label2_105a = GUICtrlCreateLabel("(en millisecondes)", 595, 207, 105, 17, $SS_RIGHT)
GUICtrlSetColor(-1, 0x646464)
Global $Input2_105 = GUICtrlCreateInput("", 712, 205, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 5)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group2_2 = GUICtrlCreateGroup(" Confirmation ", 21, 252, 760, 89)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox2_201 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer une seule ligne", 30, 280, 385, 17)
Global $Checkbox2_202 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer plusieurs lignes en mme temps", 30, 307, 460, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group2_3 = GUICtrlCreateGroup(" Comportement ", 21, 353, 760, 108)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox2_301 = GUICtrlCreateCheckbox("Lorsqu'un item est pass de la liste au presse-papier, cet item est remont en premier dans la liste", 30, 381, 577, 17)
Global $Checkbox2_302 = GUICtrlCreateCheckbox("Lorsqu'un item est insr dans la liste (par un couper ou coller d'une autre application), l'onglet Texte est affich au dtriment des autres onglets", 30, 408, 716, 17)
Global $Checkbox2_303 = GUICtrlCreateCheckbox("Lorsqu'un item est pass en Favoris, cet item est supprim de sa liste d'origine", 30, 435, 460, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetOngletFavoris = GUICtrlCreateTabItem("  Onglet Favoris  ")
Global $Group3_1 = GUICtrlCreateGroup(" Gnral ", 21, 40, 760, 60)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label3_101 = GUICtrlCreateLabel("Titre de l'onglet Favoris", 30, 68, 114, 17, 0)
Global $Input3_101 = GUICtrlCreateInput("", 544, 66, 225, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
Global $Label3_101b = GUICtrlCreateLabel("(Ce titre peut comporter des espaces en dbut et fin pour largir la taille de l'onglet)", 141, 68, 400, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group3_2 = GUICtrlCreateGroup(" Confirmation ", 21, 112, 760, 89)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox3_201 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer une seule ligne", 30, 140, 385, 17)
Global $Checkbox3_202 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer plusieurs lignes en mme temps", 30, 167, 460, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group3_3 = GUICtrlCreateGroup(" Comportement ", 21, 212, 760, 60)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox3_301 = GUICtrlCreateCheckbox("Lorsqu'un item est pass de la liste au presse-papier, cet item est remont en premier dans la liste", 30, 240, 577, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group3_4 = GUICtrlCreateGroup(" Couleur  ", 21, 283, 760, 276)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label3_401 = GUICtrlCreateLabel("Dfinissez ici les couleurs que vous allez pouvoir utiliser pour les listes des Favoris mais galement des Textes et des Slections", 107, 305, 624, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $ListViewCouleursRestantes = GUICtrlCreateListView('Toutes les couleurs', 88, 325, 260, 222, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
Global $ListViewCouleursChoisies = GUICtrlCreateListView('Couleurs slectionnes', 415, 325, 260, 222, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
Global $Button3_401 = GUICtrlCreateButton(">", 359, 392, 45, 25, $BS_NOTIFY)
GUICtrlSetFont(-1, 18, 800, 0, "MS Sans Serif")
Global $Button3_402 = GUICtrlCreateButton("<", 359, 440, 45, 25, $BS_NOTIFY)
GUICtrlSetFont(-1, 18, 800, 0, "MS Sans Serif")
Global $Button3_403 = GUICtrlCreateButton("^", 684, 392, 25, 45, $BS_NOTIFY)
GUICtrlSetFont(-1, 11, 800, 0, "MS Sans Serif")
Global $Button3_404 = GUICtrlCreateButton("v", 684, 440, 25, 45, $BS_NOTIFY)
GUICtrlSetFont(-1, 11, 800, 0, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetOngletSelection = GUICtrlCreateTabItem("Onglet Slection ")
Global $Group4_1 = GUICtrlCreateGroup(" Gnral ", 21, 40, 760, 60)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label4_101 = GUICtrlCreateLabel("Titre de l'onglet Slection", 30, 68, 120, 17, 0)
Global $Input4_101 = GUICtrlCreateInput("", 544, 66, 225, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
Global $Label4_101b = GUICtrlCreateLabel("(Ce titre peut comporter des espaces en dbut et fin pour largir la taille de l'onglet)", 151, 68, 390, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group4_2 = GUICtrlCreateGroup(" Confirmation ", 21, 112, 760, 89)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox4_201 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer une seule ligne", 30, 140, 385, 17)
Global $Checkbox4_202 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer plusieurs lignes en mme temps", 30, 167, 460, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetOngletImage = GUICtrlCreateTabItem("  Onglet Image    ")
Global $Group5_1 = GUICtrlCreateGroup(" Gnral ", 21, 40, 760, 100)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label5_101 = GUICtrlCreateLabel("Titre de l'onglet Image", 30, 68, 110, 17, 0)
Global $Label5_101b = GUICtrlCreateLabel("(Ce titre peut comporter des espaces en dbut et fin pour largir la taille de l'onglet)", 141, 68, 400, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input5_101 = GUICtrlCreateInput("", 544, 66, 225, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
Global $Label5_102 = GUICtrlCreateLabel("Nombre maximum d'images conserves", 30, 95, 196, 17, 0)
Global $Label5_102b = GUICtrlCreateLabel("(Au-del de cette valeur, les images les plus anciennes seront supprimes automatiquement)", 227, 95, 480, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Label5_102c = GUICtrlCreateLabel("Pour ne pas grer le suivi et la mmorisation des images, notez 0 comme valeur. L'onglet Image sera ainsi masqu.", 30, 111, 656, 17, 0)
Global $Input5_102 = GUICtrlCreateInput("", 712, 93, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 3)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group5_2 = GUICtrlCreateGroup(" Confirmation ", 21, 148, 760, 60)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox5_201 = GUICtrlCreateCheckbox("Demander une confirmation si vous supprimer une image", 30, 176, 385, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group5_3 = GUICtrlCreateGroup(" Comportement ", 21, 217, 760, 89)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox5_301 = GUICtrlCreateCheckbox("Lorsqu'une image est passe dans l'outil de traitement d'images, cette image est remonte en premier dans la liste", 30, 245, 721, 17)
Global $Checkbox5_302 = GUICtrlCreateCheckbox("Lorsqu'une image est insre dans la liste (par un couper ou coller d'une autre application), l'onglet Image est affich au dtriment des autres onglets", 30, 272, 732, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetScript = GUICtrlCreateTabItem("Scripting des textes")
Global $Group7_1 = GUICtrlCreateGroup("Scripting des textes ", 21, 40, 760, 522)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Radio7_101a = GUICtrlCreateRadio("Les scriptings de Transformation", 142, 64, 170, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
Global $Radio7_101b = GUICtrlCreateRadio("Les scriptings de Cration", 324, 64, 137, 17)
Global $Radio7_101c = GUICtrlCreateRadio("Le scripting Automatique", 472, 64, 145, 17)
Global $ListViewProg = GUICtrlCreateListView('Liste des scripts', 120, 90, 500, 154, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
Global $Button7_101 = GUICtrlCreateButton("+", 628, 101, 25, 29, $BS_NOTIFY)
GUICtrlSetFont(-1, 13, 800, 0, "MS Sans Serif")
Global $Button7_102 = GUICtrlCreateButton("-", 628, 133, 25, 29, $BS_NOTIFY)
GUICtrlSetFont(-1, 24, 800, 0, "MS Sans Serif")
Global $Button7_103 = GUICtrlCreateButton("^", 628, 165, 25, 35, $BS_NOTIFY)
GUICtrlSetFont(-1, 9, 800, 0, "MS Sans Serif")
Global $Button7_104 = GUICtrlCreateButton("v", 628, 205, 25, 35, $BS_NOTIFY)
GUICtrlSetFont(-1, 9, 800, 0, "MS Sans Serif")
Global $Label7_110 = GUICtrlCreateLabel("Titre du script", 30, 260, 65, 17, 0)
Global $Input7_110 = GUICtrlCreateInput("", 101, 258, 450, 21, $GUI_SS_DEFAULT_INPUT)
GUICtrlSetLimit(-1, 80)
Global $Label7_110b = GUICtrlCreateLabel("Nb max de secondes avant arrt", 565, 260, 161, 17, 0)
Global $Input7_110b = GUICtrlCreateInput("", 730, 258, 42, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_NUMBER))
GUICtrlSetLimit(-1, 3)
Global $Label7_111 = GUICtrlCreateLabel("Titre du menu", 30, 287, 65, 17, 0)
Global $Input7_111 = GUICtrlCreateInput("", 101, 285, 260, 21, $GUI_SS_DEFAULT_INPUT)
Global $Label7_113 = GUICtrlCreateLabel("Activer ce script avec", 383, 287, 106, 17, 0)
Global $CheckboxShift7_113 = GUICtrlCreateCheckbox("Shift", 490, 287, 46, 17)
Global $CheckboxCtrl7_113 = GUICtrlCreateCheckbox("Ctrl", 538, 287, 36, 17)
Global $CheckboxAlt7_113 = GUICtrlCreateCheckbox("Alt", 579, 287, 32, 17)
Global $CheckboxWin7_113 = GUICtrlCreateCheckbox("Win", 616, 287, 38, 17)
Global $ComboTouche7_113 = GUICtrlCreateCombo("", 659, 285, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label7_120 = GUICtrlCreateLabel("Lignes du script", 30, 314, 94, 17, 0)
Global $Edit7_120 = GUICtrlCreateEdit("", 30, 333, 742, 188, BitOR($ES_AUTOVSCROLL,$ES_AUTOHSCROLL,$ES_WANTRETURN,$WS_VSCROLL))
Global $Checkbox7_121 = GUICtrlCreateCheckbox("Activer ce script", 30, 532, 113, 17)
Global $Button7_121 = GUICtrlCreateButton("Simuler", 357, 528, 75, 22, $BS_NOTIFY)
GUICtrlSetState(-1, $GUI_HIDE)
Global $Button7_125a = GUICtrlCreateButton("Annuler", 581, 528, 75, 22, $BS_NOTIFY)
GUICtrlSetState(-1, $GUI_HIDE)
Global $Button7_125b = GUICtrlCreateButton("Modifier le script", 665, 528, 107, 22, $BS_NOTIFY)
Global $Button7_120a = GUICtrlCreateButton("Font", 465, 528, 75, 22, $BS_NOTIFY)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheet1 = GUICtrlCreateTabItem(" Synchronisation ")
Global $Group8_1 = GUICtrlCreateGroup(" Elments  synchroniser ", 21, 40, 760, 50)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox8_101 = GUICtrlCreateCheckbox("Synchronisation des textes et des favoris", 30, 64, 249, 17)
Global $Checkbox8_102 = GUICtrlCreateCheckbox("Synchronisation des images", 351, 64, 180, 17)
Global $Checkbox8_103 = GUICtrlCreateCheckbox("Synchronisation des scriptings", 602, 64, 169, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group8_2 = GUICtrlCreateGroup(" Paramtres de synchronisation ", 21, 95, 760, 232)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label8_201 = GUICtrlCreateLabel("Nom de cette machine", 30, 123, 108, 17, 0)
Global $Label8_201b = GUICtrlCreateLabel("(Le nom doit tre diffrent pour chaque machine qui utilise ClipSpirit et ne doit contenir que des lettres et des chiffres)", 140, 123, 557, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input8_201 = GUICtrlCreateInput("", 692, 121, 80, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
GUICtrlSetLimit(-1, 6)
Global $Label8_202 = GUICtrlCreateLabel("Cl de cryptage des fichiers envoys", 30, 147, 176, 17, 0)
Global $Label8_202b = GUICtrlCreateLabel("(Laissez vide pour ne pas crypter)", 207, 147, 158, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input8_202 = GUICtrlCreateInput("", 379, 145, 393, 21)
Global $Radio8_202A = GUICtrlCreateRadio("Synchronisation par un serveur FTP", 30, 173, 225, 17)
Global $Radio8_202B = GUICtrlCreateRadio("Synchronisation par support Disque (Cl USB par exemple)", 264, 173, 305, 17)
Global $Button8_202 = GUICtrlCreateButton("Tester le paramtrage", 630, 169, 139, 25, $BS_NOTIFY)
Global $Group8_203A = GUICtrlCreateGroup("", 30, 195, 740, 125)
Global $Label8_A01 = GUICtrlCreateLabel("Adresse hte du serveur FTP", 39, 212, 169, 17, 0)
Global $Input8_A01 = GUICtrlCreateInput("", 322, 210, 440, 21, $GUI_SS_DEFAULT_INPUT)
Global $Label8_A02 = GUICtrlCreateLabel("Nom de l'utilisateur ", 39, 238, 116, 17, 0)
Global $Input8_A02 = GUICtrlCreateInput("", 322, 236, 440, 21, $GUI_SS_DEFAULT_INPUT)
Global $Label8_A03 = GUICtrlCreateLabel("Mot de passe", 39, 264, 80, 17, 0)
Global $Button8_A03 = GUICtrlCreateButton("Afficher", 238, 261, 75, 22, $BS_NOTIFY)
Global $Input8_A03a = GUICtrlCreateInput("", 322, 262, 440, 21, $GUI_SS_DEFAULT_INPUT)
Global $Input8_A03b = GUICtrlCreateInput("", 322, 262, 440, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_PASSWORD))
Global $Label8_A04 = GUICtrlCreateLabel("Dossier serveur d'change des fichiers de synchronisation", 39, 291, 278, 17, 0)
Global $Input8_A04 = GUICtrlCreateInput("", 322, 288, 440, 21, $GUI_SS_DEFAULT_INPUT)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group8_203B = GUICtrlCreateGroup("", 30, 195, 740, 63)
Global $Label8_B01 = GUICtrlCreateLabel("Dossier(s) d'change des fichiers de synchronisation", 39, 210, 298, 17, 0)
Global $Input8_B01 = GUICtrlCreateInput("", 343, 210, 384, 21, $GUI_SS_DEFAULT_INPUT)
Global $Label8_B01B = GUICtrlCreateLabel("(Vous pouvez noter plusieurs dossiers en les sparant par des | )", 39, 229, 304, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group8_3 = GUICtrlCreateGroup(" Frquence de synchronisation ", 21, 334, 760, 99)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Radio8_301 = GUICtrlCreateRadio("Synchronisation  une frquence fixe => Saisir un temps sous forme Heure:Minute (exemple: 2:30)", 30, 358, 507, 17)
Global $Input8_301 = GUICtrlCreateInput("", 537, 355, 36, 21, $GUI_SS_DEFAULT_INPUT)
GUICtrlSetLimit(-1, 5)
Global $Radio8_302 = GUICtrlCreateRadio("Synchronisation  des heures prcises => Saisir une liste d'Heure:Minute spare par | (ex: 10:30|18:00)", 30, 382, 507, 17)
Global $Input8_302 = GUICtrlCreateInput("", 537, 379, 235, 21, $GUI_SS_DEFAULT_INPUT)
Global $Label8_303 = GUICtrlCreateLabel("En cas d'impossibilit de synchroniser, une relance est faite automatiquement => Temps en minutes", 30, 407, 500, 17, 0)
Global $Input8_303 = GUICtrlCreateInput("", 537, 404, 36, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_NUMBER))
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group8_4 = GUICtrlCreateGroup(" Affichage ", 21, 438, 760, 124)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label8_401 = GUICtrlCreateLabel("Afficher l'accs  la la synchronisation dans le menu  : ", 30, 460, 290, 17, 0)
Global $Checkbox8_401a = GUICtrlCreateCheckbox("Menu Fichier de ClipSpirit", 323, 458, 148, 17)
Global $Checkbox8_401b = GUICtrlCreateCheckbox("Menu de l'icne de ClipSpirit", 494, 458, 164, 17)
Global $Label8_402 = GUICtrlCreateLabel("Temps d'affichage, en secondes, aprs la synchronisation de l'icne dans la zone de notification", 30, 485, 460, 17, 0)
Global $Input8_402 = GUICtrlCreateInput("", 495, 483, 35, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label8_402b = GUICtrlCreateLabel("(0 = pas d'affichage)", 535, 485, 125, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Label8_403 = GUICtrlCreateLabel("Temps d'affichage, en secondes, du message de fin li  l'icne de zone de notification", 30, 510, 460, 17, 0)
Global $Input8_403 = GUICtrlCreateInput("", 495, 508, 35, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label8_403b = GUICtrlCreateLabel("(infrieur au temps de l'icne et 0=pas d'affichage)", 535, 510, 240, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Checkbox8_404 = GUICtrlCreateCheckbox("Lors des rceptions des textes, ajouter le nom de la machine mettrice dans le commentaire des textes reus", 30, 535, 580, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $TabSheetAvance = GUICtrlCreateTabItem("      Avanc         ")
Global $Group6_1 = GUICtrlCreateGroup(" Multi-slection ", 21, 40, 760, 97)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox6_101 = GUICtrlCreateCheckbox("Avoir la possibilit de slectionner plusieurs items", 30, 58, 305, 17)
Global $Label6_101b = GUICtrlCreateLabel("(La multi-slection permet, par exemple de passer N items en seule fois dans le presse-papier. Utilisez les touches Ctrl ou/et Shift pour ''multi-slectionner'')", 38, 76, 730, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Label6_102 = GUICtrlCreateLabel("Caractres ajouts entre plusieurs items multi-slectionns passs en une seule fois dans le pesse-papier", 30, 97, 600, 17, 0)
Global $Label6_102b = GUICtrlCreateLabel("(Pour ajouter des caractres spciaux utiliser : CR=Retour  la ligne, LF=Saut de ligne, TAB=Tabulation)", 38, 112, 597, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input6_102 = GUICtrlCreateInput("", 640, 95, 129, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER))
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group6_2 = GUICtrlCreateGroup(" Editeur de textes ", 21, 144, 760, 47)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Checkbox6_201 = GUICtrlCreateCheckbox("Utilisation de la touche TAB pour tabuler le texte dans le champ Texte du presse-papier de l'diteur", 30, 162, 485, 17)
Global $Label6_201b = GUICtrlCreateLabel("(Le cas chant, utiliser Ctrl+TAB pour tabuler le texte)", 518, 165, 260, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group6_3 = GUICtrlCreateGroup(" Pauses avant et aprs certaines actions  ", 21, 201, 760, 132)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label6_301 = GUICtrlCreateLabel("Nombre de millisecondes d'attente avant de passer un texte de l'application vers le presse-papier", 30, 229, 555, 17, 0)
Global $Label6_301b = GUICtrlCreateLabel("(0=pas de pause)", 604, 230, 102, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input6_301 = GUICtrlCreateInput("", 711, 227, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label6_302 = GUICtrlCreateLabel("Nombre de millisecondes d'attente aprs avoir passer le texte dans le presse-papier et avant de faire une autre action", 30, 256, 564, 17, 0)
Global $Label6_302b = GUICtrlCreateLabel("(0=pas de pause)", 604, 255, 102, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input6_302 = GUICtrlCreateInput("", 711, 254, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label6_303 = GUICtrlCreateLabel("Nombre de millisecondes d'attente aprs un appui sur une touche, pour viter que l'application de fasse plusieurs fois la mme action", 30, 283, 670, 17, 0)
Global $Input6_303 = GUICtrlCreateInput("", 711, 281, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Checkbox6_304 = GUICtrlCreateCheckbox("Reinitialiser la surveillance du presse-papier aprs un retour de mise en veille ou un changement d'alimentation ", 30, 310, 633, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group6_4 = GUICtrlCreateGroup(" Images   ", 21, 340, 760, 129)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label6_401 = GUICtrlCreateLabel("Format de l'image regnre par l'application", 30, 365, 270, 17, 0)
Global $Combo6_401 = GUICtrlCreateCombo("", 712, 363, 57, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
Global $Label6_402 = GUICtrlCreateLabel("Largeur, en pixel, des vignettes affiches dans la liste des images", 30, 392, 318, 17, 0)
Global $Label6_402b = GUICtrlCreateLabel("(Cette largeur doit tre compatible avec la largeur de la liste des images)", 348, 395, 350, 17, 0)
GUICtrlSetColor(-1, 0x646464)
Global $Input6_402 = GUICtrlCreateInput("", 711, 390, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label6_403 = GUICtrlCreateLabel("Hauteur, en pixel, des vignettes affiches dans la liste des images", 30, 419, 380, 17, 0)
Global $Input6_403 = GUICtrlCreateInput("", 711, 417, 57, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_CENTER,$ES_NUMBER))
GUICtrlSetLimit(-1, 4)
Global $Label6_404 = GUICtrlCreateLabel("(Attention, un changement de hauteur ou de largeur va perturber l'affichage des vignettes dj enregistres mais pas des images qui en rsultent)", 30, 442, 730, 17, 0)
GUICtrlSetColor(-1, 0x646464)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $Group6_5 = GUICtrlCreateGroup(" Cration et Suppresion de raccourcis vers l'application ", 21, 477, 760, 84)
GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
Global $Label6_501 = GUICtrlCreateLabel("Pour tous les utilisateurs :", 30, 505, 120, 17, 0)
Global $Checkbox6_501a = GUICtrlCreateCheckbox("Dossier dmarrage", 159, 504, 105, 17)
Global $Checkbox6_501b = GUICtrlCreateCheckbox("Racine du menu", 271, 504, 95, 17)
Global $Checkbox6_501c = GUICtrlCreateCheckbox("Bureau", 371, 504, 55, 17)
Global $Label6_502 = GUICtrlCreateLabel("Pour vous uniquement :", 30, 529, 120, 17, 0)
Global $Checkbox6_502a = GUICtrlCreateCheckbox("Dossier dmarrage", 159, 528, 105, 17)
Global $Checkbox6_502b = GUICtrlCreateCheckbox("Racine du menu", 271, 528, 95, 17)
Global $Checkbox6_502c = GUICtrlCreateCheckbox("Bureau", 371, 528, 55, 17)
Global $Label6_501b = GUICtrlCreateLabel("Autre :", 471, 505, 32, 17, 0)
Global $Input6_501 = GUICtrlCreateInput("", 511, 503, 257, 21, $GUI_SS_DEFAULT_INPUT)
Global $Button6_501 = GUICtrlCreateButton("Crer", 511, 528, 75, 20, $BS_NOTIFY)
Global $Button6_502 = GUICtrlCreateButton("Supprimer", 603, 528, 75, 20, $BS_NOTIFY)
Global $Button6_503 = GUICtrlCreateButton("Rechercher", 693, 528, 75, 20, $BS_NOTIFY)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateTabItem("")
Global $ButtonValdef = GUICtrlCreateButton("Valeurs dfaut", 21, 582, 75, 25, $BS_NOTIFY)
#EndRegion ### END Koda GUI section ###


;----- Prparation de l'interface ---------------------------------------------
; Une erreur  la compilation => voir les lignes ci-dessous
; --- Remarque 1
; Lignes  rajouter dans l'interface avant la ligne : Global $Button3_401 = GUICtrlCreateButton(">", 359, 392, 45, 25, $BS_NOTIFY)
;Global $ListViewCouleursRestantes = GUICtrlCreateListView('Toutes les couleurs', 88, 325, 260, 222, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
;Global $ListViewCouleursChoisies = GUICtrlCreateListView('Couleurs slectionnes', 415, 325, 260, 222, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
; --- Remarque 2
; Ligne  rajouter dans l'interface avant la ligne : Global $Button7_101 = GUICtrlCreateButton("+", 628, 101, 25, 29, $BS_NOTIFY)
;Global $ListViewProg = GUICtrlCreateListView('Liste des scripts', 120, 90, 500, 154, BitOR($LVS_SINGLESEL, $LVS_SHOWSELALWAYS), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
; --- Remaque 3
; Penser  supprimer la ligne "GUISetState(@SW_SHOW)" juste avant la ligne "#EndRegion ### END Koda GUI section ###"
;
PrepareDonneesEcran()
WinSetTitle("~Titre~", "", $sFenetreTitre)
GUISetState(@SW_SHOW, $FormClipSpiritPref)
_GUICtrlTab_SetCurFocus($TabSheet, 0)


;----- Boucle principale ------------------------------------------------------
While 1
	If $iItemSelectListViewProg <> ItemSelectionne($ListViewProg) Then
		$iItemSelectListViewProg = ItemSelectionne($ListViewProg)
		AfficherScriptDetail($iItemSelectListViewProg)
		GUICtrlSetState($ListViewProg, $GUI_FOCUS)
	EndIf
	If $iTabActif <> GUICtrlRead($TabSheet) Then
		$iTabActif = GUICtrlRead($TabSheet)
		Switch $iTabActif
			Case 0
				$sAideContexte = "PrefGeneral"
			Case 1
				$sAideContexte = "PrefOngletTexte"
			Case 2
				$sAideContexte = "PrefOngletFavoris"
			Case 3
				$sAideContexte = "PrefOngletSelection"
			Case 4
				$sAideContexte = "PrefOngletImage"
			Case 5
				$sAideContexte = "PrefScriptingtextes"
			Case 6
				$sAideContexte = "PrefSynchronisation"
			Case 7
				$sAideContexte = "PrefAvance"
		EndSwitch
	EndIf
	$idMsg = GUIGetMsg()
	Switch $idMsg
		Case $GUI_EVENT_CLOSE, $ButtonAnnuler
			If $iEtatScriptDetail <> 0 Then
				_GUICtrlTab_SetCurFocus($TabSheet, 5)
				MsgBox(4112, $scMsgErreur, "Avant de sortir vous devez Enregistrer ou Abandonner l'dition du script en cours", 0, $FormClipSpiritPref)
				ContinueLoop
			EndIf
			If $bScriptEnregistre Then
				If MsgBox(270628, $scMsgConfirm, "Voulez-vous sortir sans enregistrer ?" & @CRLF & "Pour information, des scriptings ont dj t enregistrs") = 6 Then
					If $sbEnregistrer Then RelanceAppli(False)
					ExitLoop
				EndIf
			Else
				If MsgBox(270628, $scMsgConfirm, "Voulez-vous sortir sans enregistrer ?") = 6 Then
					If $sbEnregistrer Then RelanceAppli(False)
					ExitLoop
				EndIf
			EndIf
		Case $ButtonAide
			AccesAide()
		Case $Button1_403 ; Rechercher le Dossier de dpt des Backups
			$sTemp = FileSelectFolder("Choisir le dossier o placer les backups", "", 3, @ScriptDir, $FormClipSpiritPref)
			If $sTemp <> "" Then GUICtrlSetData($Input1_403, $sTemp)
		Case $Button3_401 ; Ajouter une couleur
			CouleurAjouter()
		Case $Button3_402 ; Oter une couleur
			CouleurSupprimer()
		Case $Button3_403 ; Monter une couleur
			CouleurMonterDescendre(True)
		Case $Button3_404 ; Descendre une couleur
			CouleurMonterDescendre(False)
		Case $Button6_501 ; Crer raccourci(s)
			RaccourciAppliCreerSupprimer(True)
		Case $Button6_502 ; Supprimer raccourci(s)
			RaccourciAppliCreerSupprimer(False)
		Case $Button6_503 ; Rechercher un dossier pour le raccourci
			$sTemp = FileSelectFolder("Choisir le dossier o crer/supprimer un raccourci vers " & $scAppliTitreGeneral, "", 3, @ScriptDir, $FormClipSpiritPref)
			If $sTemp <> "" Then GUICtrlSetData($Input6_501, $sTemp)
		Case $Radio7_101a, $Radio7_101b, $Radio7_101c ; Type de scripting
			PositionnerTypeScript()
		Case $Button7_101 ; Ajouter un script
			AfficherScriptDetail(-1)
			PositionnerOngletScript("T")
			GUICtrlSetState($Input7_110, $GUI_FOCUS)
			$iEtatScriptDetail = 2 ; Mode cration
		Case $Button7_102 ; Supprimer un Script
			SupprimerScript()
		Case $Button7_120a ; Font
			$sScriptEdFont = _ChooseFont($sScriptEdFontNom, $iScriptEdFontTaille, $iScriptEdFontCouleur, $iScriptEdFontPoids)
            If @error = 0 Then ; Mise  jour des variables & des paramtres
				$iScriptEdFontTaille = $sScriptEdFont[3]
				DbParamMAJNum("PrefScriptEdFontTaille", $iScriptEdFontTaille)
				$iScriptEdFontPoids = $sScriptEdFont[4]
				DbParamMAJNum("PrefScriptEdFontPoids", $iScriptEdFontPoids)
				$sScriptEdFontNom = $sScriptEdFont[2]
				DbParamMAJTexte("PrefScriptEdFontNom", $sScriptEdFontNom)
				$iScriptEdFontCouleur = $sScriptEdFont[5]
				DbParamMAJNum("PrefScriptEdFontCouleur", $iScriptEdFontCouleur)
				GUICtrlSetFont($Edit7_120, $iScriptEdFontTaille, $iScriptEdFontPoids, 0, $sScriptEdFontNom)
				CouleurControle($Edit7_120, $iScriptEdFontCouleur)
			EndIf
			GUISetState(@SW_SHOW, $sFenetreTitre)
		Case $Checkbox7_121 ; Activer le script
			If GUICtrlRead($Checkbox7_121) = $GUI_CHECKED Then
				GUICtrlSetData($Button7_125b, "Valider le script")
			Else
				GUICtrlSetData($Button7_125b, "Enregistrer le script")
			EndIf
		Case $Button7_125a ; Abandon de la saisie d'un Script
			AfficherScriptDetail(ItemSelectionne($ListViewProg))
			$iEtatScriptDetail = 0 ; On passe en mode visu
		Case $Button7_125b ; Modif ou Validation de la saisie d'un Script
			GUISetState(@SW_DISABLE, $FormClipSpiritPref)
			If ModifValidScript($iEtatScriptDetail) Then
				If $iEtatScriptDetail = 0 Then
					$iEtatScriptDetail = 1 ; Mode Modif
				Else
					$iEtatScriptDetail = 0 ; Mode visu
				EndIf
			EndIf
			GUISetState(@SW_ENABLE, $FormClipSpiritPref)
			GUISetState(@SW_SHOW, $sFenetreTitre)
			If $iScriptLigneEnErreur > 0 Then
				GUICtrlSetState($Edit7_120, $GUI_FOCUS)
				; Slection
				If $iScriptLigneEnErreur < 2 Then
					$iTemp = 0
				Else
					$iTemp = StringInStr(GUICtrlRead($Edit7_120), @CR, 0, $iScriptLigneEnErreur - 1) +1
				EndIf
				If $iScriptLigneEnErreur < _GUICtrlEdit_GetLineCount($Edit7_120) Then
					_GUICtrlEdit_SetSel($Edit7_120, StringInStr(GUICtrlRead($Edit7_120), @CR, 0, $iScriptLigneEnErreur) -1, $iTemp)
				Else
					_GUICtrlEdit_SetSel($Edit7_120, $iTemp, -1)
				EndIf
				$iScriptLigneEnErreur = 0
			EndIf
		Case $Button7_103 ; Up Liste Script
			UpDownListeScript(True)
		Case $Button7_104 ; Down Liste Script
			UpDownListeScript(False)
		Case $Button7_121 ; Simuler
			$sAideContexte = "EcranSimulation"
			GUISetState(@SW_DISABLE, $FormClipSpiritPref)
			ScriptSimuler(_GUICtrlListView_GetItemText($ListViewProg, $iItemSelectListViewProg, 1))
			GUISwitch($sFenetreTitre)
			GUISetState(@SW_ENABLE, $FormClipSpiritPref)
			GUISetState(@SW_SHOW, $sFenetreTitre)
			WinSetOnTop($sFenetreTitre, "", 1)
			Sleep(300)
			WinSetOnTop($sFenetreTitre, "", 0)
			$sAideContexte = "PrefScriptingtextes"
		Case $Radio8_202A, $Radio8_202B ; "S"=Serveur, "L"=support Local
			PositionnerTypeSynchro()
		Case $Button8_202 ; Tester le paramtrage de synchronsiation
			SynchronisationTestParam()
		Case $Button8_A03 ; Synchronisation : Afficher/Masquer Mot de passe
			MotPasse2Input()
			If GUICtrlRead($Button8_A03) = "Masquer" Then
				GUICtrlSetState($Input8_A03b, $GUI_SHOW)
				GUICtrlSetState($Input8_A03a, $GUI_HIDE)
				GUICtrlSetData($Button8_A03, "Afficher")
			Else
				GUICtrlSetState($Input8_A03a, $GUI_SHOW)
				GUICtrlSetState($Input8_A03b, $GUI_HIDE)
				GUICtrlSetData($Button8_A03, "Masquer")
			EndIf
		Case $Radio8_301, $Radio8_302 ; Synchronisation : Frquence/Heures
			PositionnerSynchroFH()
		Case $ButtonValdef
			If RetourParamParDefaut() Then ExitLoop
		Case $ButtonOK, $ButtonAppliquer
			If $iEtatScriptDetail <> 0 Then
				_GUICtrlTab_SetCurFocus($TabSheet, 5)
				MsgBox(4112, $scMsgErreur, "Avant de valider vous devez Enregistrer ou Abandonner l'dition du script en cours", 0, $FormClipSpiritPref)
				ContinueLoop
			EndIf
			GUISetCursor(15, 1, $FormClipSpiritPref) ; Curseur WAIT
			If ValiderParam() Then
				If $idMsg = $ButtonOK Then
					RelanceAppli(True)
					ExitLoop
				EndIf
			EndIf
			$bScriptEnregistre = False
			GUISetCursor(2) ; Curseur Classique
	EndSwitch
	;
	If _IsPressed($sToucheAide) Then AccesAide() ; Touche d'aide
	;
	If _IsFocused($Edit7_120) Then ; Editeur de script
		HotKeySet("{TAB}", "TabPress")
	Else
		HotKeySet("{TAB}")
	EndIf
WEnd


;----- Fermeture de la base de donnes ----------------------------------------
_SQLite_Close($hDbPrp)
_SQLite_Shutdown()
FileDelete($scFicDebug)

;----- Sortie de l'application ------------------------------------------------
Exit


; ========== Fonctions principales ================================================================


;--------------------------------------------------------------------------------------------------
; Fonction prparant l'affichage des donnes  l'cran
;
; IN /
; OUT /
;--------------------------------------------------------------------------------------------------
Func PrepareDonneesEcran()
	Local $s
	;----- Prparer l'Onglet Gnral
	PositionnerChampsToucheActivation()
	PositionnerChampToucheEditeur()
	PositionnerChampToucheModifItem()
	PositionnerChampToucheOnglet()
	PositionnerChampToucheAide()
	GUICtrlSetData($Input1_201, _Min(_Max($icFenetreHauteurMin, DbParamLireNum("FenetreHauteurPixel", 0)), @DesktopHeight))
	GUICtrlSetData($Input1_202, _Min(_Max($icFenetreLargeListeMin, DbParamLireNum("FenetreLargeurListePixel", 0)), @DesktopWidth))
	GUICtrlSetData($Input1_203, _Min(_Max($icFenetreLargeEditeurMin, DbParamLireNum("FenetreLargeurEditeurPixel", 0)), @DesktopWidth))
	PositionnerCheckbox("1_301", DbParamLireBoolean("FermerSortir", True))
	PositionnerCheckbox("1_302", DbParamLireBoolean("EscSortir", True))
	PositionnerCheckbox("1_303", DbParamLireBoolean("FenetreTop", True))
	PositionnerModeBackup()
	GUICtrlSetData($Input1_402, DbParamLireNum("BackupMaxNbCopies", 0))
	GUICtrlSetData($Input1_403, DbParamLireTexte("BackupRepertoire", ""))
	;----- Prparer l'Onglet Texte
	GUICtrlSetData($Input2_101, DbParamLireTexte("TitreOngletTexte", ""))
	GUICtrlSetData($Input2_102, DbParamLireNum("NbMaxItemTexte", 0))
	PositionnerChampsToucheCollerTexte()
	PositionnerCheckbox("2_104", DbParamLireBoolean("AffichagerItemSurvole", True))
	GUICtrlSetData($Input2_105, DbParamLireNum("LapsTempsAvantAffichageItemSurvole", 500))
	PositionnerCheckbox("2_201", DbParamLireBoolean("ConfirmSuppTexteMono", True))
	PositionnerCheckbox("2_202", DbParamLireBoolean("ConfirmSuppTexteMulti", True))
	PositionnerCheckbox("2_301", DbParamLireBoolean("ItemTexteChoisiPasseEnPremier", True))
	PositionnerCheckbox("2_302", DbParamLireBoolean("ActiverListeTexteInsert", True))
	PositionnerCheckbox("2_303", DbParamLireBoolean("ItemSuppSiDeplacerFavoris", True))
	;----- Prparer l'Onglet Favoris
	_GUICtrlListView_AddColumn($ListViewCouleursRestantes, "", 0)
	_GUICtrlListView_SetColumnWidth($ListViewCouleursRestantes, 0, 239)
	_GUICtrlListView_AddColumn($ListViewCouleursChoisies, "", 0)
	_GUICtrlListView_SetColumnWidth($ListViewCouleursChoisies, 0, 239)
	PositionnerCouleur()
	_GUICtrlButton_SetText($Button3_401, ChrW(9654)) ; Ajouter
	_GUICtrlButton_SetText($Button3_402, ChrW(9664)) ; Oter
	_GUICtrlButton_SetText($Button3_403, ChrW(9650)) ; Monter
	_GUICtrlButton_SetText($Button3_404, ChrW(9660)) ; Descendre
	GUICtrlSetData($Input3_101, DbParamLireTexte("TitreOngletFavoris", ""))
	PositionnerCheckbox("3_201", DbParamLireBoolean("ConfirmSuppFavorisMono", True))
	PositionnerCheckbox("3_202", DbParamLireBoolean("ConfirmSuppFavorisMulti", True))
	PositionnerCheckbox("3_301", DbParamLireBoolean("ItemFavorisChoisiPasseEnPremier", False))
	;----- Prparer l'Onglet Selection
	GUICtrlSetData($Input4_101, DbParamLireTexte("TitreOngletSelection", ""))
	PositionnerCheckbox("4_201", DbParamLireBoolean("ConfirmSuppSelectMono", True))
	PositionnerCheckbox("4_202", DbParamLireBoolean("ConfirmSuppSelectMulti", True))
	;----- Prparer l'Onglet Image
	GUICtrlSetData($Input5_101, DbParamLireTexte("TitreOngletImage", ""))
	GUICtrlSetData($Input5_102, DbParamLireNum("NbMaxItemImage", 0))
	PositionnerCheckbox("5_201", DbParamLireBoolean("ConfirmSuppImageMono", True))
	PositionnerCheckbox("5_301", DbParamLireBoolean("ItemImageChoisiPasseEnPremier", True))
	PositionnerCheckbox("5_302", DbParamLireBoolean("ActiverListeImageInsert", True))
	;----- Prparer l'Onglet Scripting
	_GUICtrlListView_AddColumn($ListViewProg, "", 0)
	_GUICtrlListView_AddColumn($ListViewProg, "", 0)
	_GUICtrlListView_SetColumnWidth($ListViewProg, 0, 479)
	AlimenterCombo($ComboTouche7_113, $sListToucheToutLibelle)
	PositionnerTypeScript()
	_GUICtrlButton_SetText($Button7_103, ChrW(9650)) ; Monter
	_GUICtrlButton_SetText($Button7_104, ChrW(9660)) ; Descendre
	GUICtrlSetFont($Edit7_120, $iScriptEdFontTaille, $iScriptEdFontPoids, 0, $sScriptEdFontNom)
	CouleurControle($Edit7_120, $iScriptEdFontCouleur)
	Global $aTabStops[3] = [20, 40, 60]
	_GUICtrlEdit_SetTabStops($Edit7_120, $aTabStops)
	;----- Prparer l'Onglet Synchronisation
	PositionnerCheckbox("8_101", DbParamLireBoolean("SynchronisationTexte", False))
	PositionnerCheckbox("8_102", DbParamLireBoolean("SynchronisationImage", False))
	PositionnerCheckbox("8_103", DbParamLireBoolean("SynchronisationScript", False))
	$s = DbParamLireTexte("SynchroNomMachine", "")
	If $s = "" Then $s = @ComputerName
	$s = StringLeft($s, $iSynchroLongeurNomMachine)
	GUICtrlSetData($Input8_201, $s)
	GUICtrlSetData($Input8_202, DbParamLireTexte("SynchroCleCrypt", ""))
	Switch DbParamLireTexte("Synchronisation", "") ; "S"=Serveur, "L"=support Local
		Case "S"
			GUICtrlSetState($Radio8_202A, $GUI_CHECKED)
		Case "L"
			GUICtrlSetState($Radio8_202B, $GUI_CHECKED)
	EndSwitch
	PositionnerTypeSynchro()
	GUICtrlSetData($Input8_A01, DbParamLireTexte("SynchroServeur", ""))
	GUICtrlSetData($Input8_A02, DbParamLireTexte("SynchroUtilisateur", ""))
	$s = DbParamLireTexte("SynchroMotPasse", "")
	If $s <> "" Then $s = _StringEncrypt(0, $s, $scCryptCle)
	GUICtrlSetData($Input8_A03a, $s)
	GUICtrlSetData($Input8_A03b, $s)
	GUICtrlSetData($Input8_A04, DbParamLireTexte("SynchroDossierServeur", ""))
	GUICtrlSetData($Input8_B01, DbParamLireTexte("SynchroSupportLocal", ""))
	$iSynchroStepInit = DbParamLireTexte("SynchroStep", "")
	If StringInStr($iSynchroStepInit, "|") = 0 Then
		GUICtrlSetState($Radio8_301, $GUI_CHECKED)
		GUICtrlSetData($Input8_301, $iSynchroStepInit)
	Else
		If StringLeft($iSynchroStepInit, 1) = "|" Then $iSynchroStepInit = StringMid($iSynchroStepInit, 2)
		If StringRight($iSynchroStepInit, 1) = "|" Then $iSynchroStepInit = StringMid($iSynchroStepInit, 1, StringLen($iSynchroStepInit) - 1)
		GUICtrlSetState($Radio8_302, $GUI_CHECKED)
		GUICtrlSetData($Input8_302, $iSynchroStepInit)
	EndIf
	PositionnerSynchroFH()
	GUICtrlSetData($Input8_303, DbParamLireNum("SynchroStepRelance", 15))
	PositionnerCheckbox("8_401a", DbParamLireBoolean("SynchronisationManuel", False))
	PositionnerCheckbox("8_401b", DbParamLireBoolean("SynchroTrayIcon", False))
	GUICtrlSetData($Input8_402, DbParamLireNum("SynchroTempsIconeFin", 10))
	GUICtrlSetData($Input8_403, DbParamLireNum("SynchroTempsMessageFin", 8))
	PositionnerCheckbox("8_404", DbParamLireBoolean("SynchroAjoutNomMachineCommentaire", False))
	;----- Prparer l'Onglet Avanc
	If @StartupCommonDir = "" Then GUICtrlSetState($Checkbox6_501a, $GUI_HIDE)
	If @StartMenuCommonDir = "" Then GUICtrlSetState($Checkbox6_501b, $GUI_HIDE)
	If @DesktopCommonDir = "" Then GUICtrlSetState($Checkbox6_501c, $GUI_HIDE)
	If @StartupDir = "" Then GUICtrlSetState($Checkbox6_502a, $GUI_HIDE)
	If @StartMenuDir = "" Then GUICtrlSetState($Checkbox6_502b, $GUI_HIDE)
	If @DesktopDir = "" Then GUICtrlSetState($Checkbox6_502c, $GUI_HIDE)
	PositionnerCheckbox("6_101", DbParamLireBoolean("MultiSelectionItems", True))
	GUICtrlSetData($Input6_102, DbParamLireTexte("CaracteresAjoutesMultiSelectItems", ""))
	PositionnerCheckbox("6_201", DbParamLireBoolean("EditeurUtiliserTab", True))
	GUICtrlSetData($Input6_301, DbParamLireNum("PauseAvantSendV", 0))
	GUICtrlSetData($Input6_302, DbParamLireNum("PauseApresSendV", 0))
	GUICtrlSetData($Input6_303, DbParamLireNum("PauseApresAppuiTouche", 0))
	PositionnerCheckbox("6_304", DbParamLireBoolean("PowerManagementEvent", False))
	PositionnerChampFormat()
	GUICtrlSetData($Input6_402, DbParamLireNum("VignetteLargeur", 224))
	GUICtrlSetData($Input6_403, DbParamLireNum("VignetteHauteur", 126))
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction validant les donnes des crans
;
; IN
; OUT True si tout est OK, False sinon
;--------------------------------------------------------------------------------------------------
Func ValiderParam()
	;----- Valider l'Onglet Gnral
	; Taille
	If Not TestNombre($Input1_201, $icFenetreHauteurMin, @DesktopHeight, "La hauteur de l'application") Then Return False
	If Not TestNombre($Input1_202, $icFenetreLargeListeMin, @DesktopWidth, "La largeur de la partie liste") Then Return False
	If Not TestNombre($Input1_203, $icFenetreLargeEditeurMin, @DesktopWidth, "La largeur de la partie diteur") Then Return False
	If (GUICtrlRead($Input1_202) + GUICtrlRead($Input1_203)) > @DesktopWidth Then
		GUISetCursor(2) ; Curseur Classique
		MsgBox(4112, $scMsgErreur, "Dans l'onglet Gnral, la largeur de la partie liste + la largeur de la partie diteur doit tre infrieure  " & @DesktopWidth, 0, $FormClipSpiritPref)
		Return False
	EndIf
	;----- Valider l'Onglet Texte
	;----- Valider l'Onglet Favoris
	;----- Valider l'Onglet Selection
	;----- Valider l'Onglet Image
	;----- Valider l'Onglet Synchronisation
	If (GUICtrlRead($Checkbox8_101) = $GUI_CHECKED) Or (GUICtrlRead($Checkbox8_101) = $GUI_CHECKED) Or (GUICtrlRead($Checkbox8_101) = $GUI_CHECKED) Then
		; Nom de machine obligatoire
		If GUICtrlRead($Input8_201) = "" Then
			GUISetCursor(2) ; Curseur Classique
			MsgBox(4112, $scMsgErreur, "Dans l'onglet Synchronisation, le nom de la machine est obligatoire", 0, $FormClipSpiritPref)
			Return False
		EndIf
	EndIf
	;----- Valider l'Onglet Avanc
	;----- Enregistrement
	_SQLite_Exec($hDbPrp, "BEGIN;")
	If EnregistrerParam() Then
		Return (_SQLite_Exec($hDbPrp, "COMMIT;") = $SQLITE_OK)
	Else
		_SQLite_Exec($hDbPrp, "ROLLBACK;")
		Return False
	EndIf
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction Enregistrant les donnes
;
; IN
; OUT True si tous est OK, False sinon
;--------------------------------------------------------------------------------------------------
Func EnregistrerParam()
	Local $s, $sStep
	;----- Enregistrer l'Onglet Gnral
	If Not EnregistrerToucheActivation() Then Return False
	$sbEnregistrer = True ; Ds la premire info enregistre, il faut positionner ce flag
	If Not EnregistrerToucheEditeur() Then Return False
	If Not EnregistrerToucheModifItem() Then Return False
	If Not EnregistrerToucheOnglet() Then Return False
	If Not EnregistrerToucheAide() Then Return False
	If Not DbParamMAJNum("FenetreHauteurPixel", GUICtrlRead($Input1_201)) Then Return False
	If Not DbParamMAJNum("FenetreLargeurListePixel", GUICtrlRead($Input1_202)) Then Return False
	If Not DbParamMAJNum("FenetreLargeurEditeurPixel", GUICtrlRead($Input1_203)) Then Return False
	If Not DbParamMAJBoolean("FermerSortir", (GUICtrlRead($Checkbox1_301) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("EscSortir", (GUICtrlRead($Checkbox1_302) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("FenetreTop", (GUICtrlRead($Checkbox1_303) = $GUI_CHECKED)) Then Return False
	If Not EnregistrerModeBackup() Then Return False
	If Not DbParamMAJNum("BackupMaxNbCopies", GUICtrlRead($Input1_402)) Then Return False
	If Not DbParamMAJTexte("BackupRepertoire", GUICtrlRead($Input1_403)) Then Return False
	;----- Enregistrer l'Onglet Texte
	If Not DbParamMAJTexte("TitreOngletTexte", GUICtrlRead($Input2_101)) Then Return False
	If Not DbParamMAJNum("NbMaxItemTexte", GUICtrlRead($Input2_102)) Then Return False
	If Not EnregistrerToucheColler() Then Return False
	If Not DbParamMAJBoolean("AffichagerItemSurvole", (GUICtrlRead($Checkbox2_104) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJNum("LapsTempsAvantAffichageItemSurvole", GUICtrlRead($Input2_105)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppTexteMono", (GUICtrlRead($Checkbox2_201) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppTexteMulti", (GUICtrlRead($Checkbox2_202) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ItemTexteChoisiPasseEnPremier", (GUICtrlRead($Checkbox2_301) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ActiverListeTexteInsert", (GUICtrlRead($Checkbox2_302) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ItemSuppSiDeplacerFavoris", (GUICtrlRead($Checkbox2_303) = $GUI_CHECKED)) Then Return False
	;----- Enregistrer l'Onglet Favoris
	If Not DbParamMAJTexte("TitreOngletFavoris", GUICtrlRead($Input3_101)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppFavorisMono", (GUICtrlRead($Checkbox3_201) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppFavorisMulti", (GUICtrlRead($Checkbox3_202) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ItemFavorisChoisiPasseEnPremier", (GUICtrlRead($Checkbox3_301) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJTexte("ChaineCouleur", ValeurChaineCouleurs()) Then Return False
	;----- Enregistrer l'Onglet Selection
	If Not DbParamMAJTexte("TitreOngletSelection", GUICtrlRead($Input4_101)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppSelectMono", (GUICtrlRead($Checkbox4_201) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppSelectMulti", (GUICtrlRead($Checkbox4_202) = $GUI_CHECKED)) Then Return False
	;----- Enregistrer l'Onglet Image
	If Not DbParamMAJTexte("TitreOngletImage", GUICtrlRead($Input5_101)) Then Return False
	If Not DbParamMAJNum("NbMaxItemImage", GUICtrlRead($Input5_102)) Then Return False
	If Not DbParamMAJBoolean("ConfirmSuppImageMono", (GUICtrlRead($Checkbox5_201) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ItemImageChoisiPasseEnPremier", (GUICtrlRead($Checkbox5_301) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("ActiverListeImageInsert", (GUICtrlRead($Checkbox5_302) = $GUI_CHECKED)) Then Return False
	;----- Enregistrer l'Onglet Scripting -> Fait sur l'onglet lui-mme
	;----- Enregistrer l'Onglet Synchronisation
	If Not DbParamMAJBoolean("SynchronisationTexte", (GUICtrlRead($Checkbox8_101) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("SynchronisationImage", (GUICtrlRead($Checkbox8_102) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("SynchronisationScript", (GUICtrlRead($Checkbox8_103) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJTexte("SynchroNomMachine", GUICtrlRead($Input8_201)) Then Return False
	Select
		Case GUICtrlRead($Radio8_202A) = $GUI_CHECKED
			If Not DbParamMAJTexte("Synchronisation", "S") Then Return False
		Case GUICtrlRead($Radio8_202B) = $GUI_CHECKED
			If Not DbParamMAJTexte("Synchronisation", "L") Then Return False
		Case Else
			If Not DbParamMAJTexte("Synchronisation", "") Then Return False
	EndSelect
	If Not DbParamMAJTexte("SynchroCleCrypt", GUICtrlRead($Input8_202)) Then Return False
	If Not DbParamMAJTexte("SynchroServeur", GUICtrlRead($Input8_A01)) Then Return False
	If Not DbParamMAJTexte("SynchroUtilisateur", GUICtrlRead($Input8_A02)) Then Return False
	If GUICtrlRead($Button8_A03) = "Masquer" Then
		$s = GUICtrlRead($Input8_A03a)
	Else
		$s = GUICtrlRead($Input8_A03b)
	EndIf
	If $s <> "" Then $s = _StringEncrypt(1, $s, $scCryptCle)
	If Not DbParamMAJTexte("SynchroMotPasse", $s) Then Return False
	If Not DbParamMAJTexte("SynchroDossierServeur", GUICtrlRead($Input8_A04)) Then Return False
	If Not DbParamMAJTexte("SynchroSupportLocal", GUICtrlRead($Input8_B01)) Then Return False
	If GUICtrlRead($Radio8_302) = $GUI_CHECKED Then
		$sStep = GUICtrlRead($Input8_302)
		If $sStep <> "" Then
			If StringLeft($sStep, 1) <> "|" Then $sStep = "|" & $sStep
			If StringRight($sStep, 1) <> "|" Then $sStep &= "|"
		EndIf
	Else
		$sStep = GUICtrlRead($Input8_301)
	EndIf
	If Not DbParamMAJTexte("SynchroStep", $sStep) Then Return False
	If Not DbParamMAJNum("SynchroStepRelance", GUICtrlRead($Input8_303)) Then Return False
	If $iSynchroStepInit <> $sStep Then ; s'il y a changemement de synchronisation, alors recalculer l'heure de la prochaine synchro
		If Not DbParamMAJTexte("SynchroProchaine", _ProchaineSynchro($sStep, GUICtrlRead($Input8_303))) Then Return False
		$iSynchroStepInit = $sStep
	EndIf
	If Not DbParamMAJBoolean("SynchronisationManuel", (GUICtrlRead($Checkbox8_401a) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJBoolean("SynchroTrayIcon", (GUICtrlRead($Checkbox8_401b) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJNum("SynchroTempsIconeFin", GUICtrlRead($Input8_402)) Then Return False
	If Not DbParamMAJNum("SynchroTempsMessageFin", GUICtrlRead($Input8_403)) Then Return False
	If Not DbParamMAJBoolean("SynchroAjoutNomMachineCommentaire", (GUICtrlRead($Checkbox8_404) = $GUI_CHECKED)) Then Return False
	;----- Enregistrer l'Onglet Avanc
	If Not DbParamMAJBoolean("MultiSelectionItems", (GUICtrlRead($Checkbox6_101) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJTexte("CaracteresAjoutesMultiSelectItems", GUICtrlRead($Input6_102)) Then Return False
	If Not DbParamMAJBoolean("EditeurUtiliserTab", (GUICtrlRead($Checkbox6_201) = $GUI_CHECKED)) Then Return False
	If Not DbParamMAJNum("PauseAvantSendV", GUICtrlRead($Input6_301)) Then Return False
	If Not DbParamMAJNum("PauseApresSendV", GUICtrlRead($Input6_302)) Then Return False
	If Not DbParamMAJNum("PauseApresAppuiTouche", GUICtrlRead($Input6_303)) Then Return False
	If Not DbParamMAJBoolean("PowerManagementEvent", (GUICtrlRead($Checkbox6_304) = $GUI_CHECKED)) Then Return False
	If Not EnregistrerChampFormat() Then Return False
	If Not DbParamMAJNum("VignetteLargeur", GUICtrlRead($Input6_402)) Then Return False
	If Not DbParamMAJNum("VignetteHauteur", GUICtrlRead($Input6_403)) Then Return False
	;
	Return True
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction permettant de relancer l'appli matre
;
; IN  $bValidation : Est-ce une validation (Touche 'OK' ou 'Valeurs par dfaut')
; OUT /
;--------------------------------------------------------------------------------------------------
Func RelanceAppli($bValidation)
	Local $sMes
	; 	Le nom de l'exe dans la processus n'est pas toujours clipspirit.exe mais CLIPSP~1.EXE
	If (ProcessExists($scAppliTitreGeneral & ".exe") = 0) And (ProcessExists("CLIPSP~1.EXE") = 0) Then Return
	If Not FileExists(@ScriptDir & "\" & $scAppliTitreGeneral & ".exe") Then Return
	If $bValidation Then
		$sMes = "Pour que l'application prennent en compte le changement des prfrences, elle doit tre relance."
	Else
		$sMes = "Des prfrences ont dj t enregistres." & @CRLF & "Pour que l'application les prenne en compte celle-ci doit tre relance."
	EndIf
	GUISetCursor(2) ; Curseur Classique
	If MsgBox(8484, $scMsgConfirm, $sMes & @CRLF & @CRLF & "Voulez-vous que l'application soit relance maintenant ?", 0, $FormClipSpiritPref) = 6 Then
		GUISetCursor(15, 1, $FormClipSpiritPref) ; Curseur WAIT
		If (ProcessClose($scAppliTitreGeneral & ".exe") = 1) Or (ProcessClose("CLIPSP~1.EXE") = 1) Then ; test des 2 noms possibles
			_RefreshSystemTray(500)
			If Run(@ScriptDir & "\" & $scProgPrincipal) = 0 Then
				GUISetCursor(2) ; Curseur Classique
				MsgBox(4112, $scMsgErreur, "L'application ne peut pas tre relance !", 0, $FormClipSpiritPref)
			EndIf
		Else
			GUISetCursor(2) ; Curseur Classique
			MsgBox(4112, $scMsgErreur, "L'application ne peut pas tre arrte !", 0, $FormClipSpiritPref)
		EndIf
	EndIf
EndFunc



; ========== Fonctions secondaires ================================================================


Func AccesAide()
	If Not FileExists($scFichierAide) Then
		MsgBox(4112, $scMsgErreur, "Le fichier d'aide n'est pas trouv dans le dossier "  & @CRLF & @ScriptDir, 0, $FormClipSpiritPref)
	Else
		If WinExists("Aide " & $scAppliTitreGeneral) Then WinClose("Aide " & $scAppliTitreGeneral)
		If $sAideContexte <> "" Then
			ShellExecute("hh.exe", "mk:@MSITStore:" & StringReplace($scFichierAide, " ", "%20") & "::/" & $sAideContexte & ".html")
		Else
			ShellExecute($scFichierAide)
		EndIf
		Sleep(2000)
	EndIf
EndFunc


Func PositionnerChampsToucheActivation()
	Local $bShift, $bCtrl, $bAlt, $bWin, $iIndiceListe
	AlimenterCombo($ComboTouche1_101, $sListToucheToutLibelle)
	TraduireCodeToucheEnTousLesChamps(DbParamLireTexte("ToucheActivation", ""), $sListToucheToutCode, $bShift, $bCtrl,$bAlt, $bWin, $iIndiceListe)
	PositionnerChampsTouche("1_101", $iIndiceListe, $bShift, $bCtrl, $bAlt, $bWin)
EndFunc

Func PositionnerChampToucheEditeur()
	AlimenterCombo($ComboTouche1_102, $sListToucheFonctionPlusLibelle)
	PositionnerChampsTouche("1_102", TraduireCodeToucheEnUnChamp(DbParamLireTexte("ToucheAfficherEditeur", ""), $sListToucheFonctionPlusCode))
EndFunc

Func PositionnerChampToucheModifItem()
	AlimenterCombo($ComboTouche1_103, $sListToucheFonctionPlusLibelle)
	PositionnerChampsTouche("1_103", TraduireCodeToucheEnUnChamp(DbParamLireTexte("ToucheModifierItem", ""), $sListToucheFonctionPlusCode))
EndFunc

Func PositionnerChampsToucheCollerTexte()
	Local $bShift, $bCtrl, $bAlt, $bWin, $iIndiceListe
	AlimenterCombo($ComboTouche2_103, $sListToucheToutLibelle)
	TraduireCodeToucheEnTousLesChamps(DbParamLireTexte("ToucheColler", ""), $sListToucheToutCode, $bShift, $bCtrl,$bAlt, $bWin, $iIndiceListe)
	PositionnerChampsTouche("2_103", $iIndiceListe, $bShift, $bCtrl, $bAlt, $bWin)
EndFunc

Func PositionnerChampToucheOnglet()
	AlimenterCombo($ComboTouche1_104, $sListToucheFonctionPlusLibelle)
	PositionnerChampsTouche("1_104", TraduireCodeToucheEnUnChamp(DbParamLireTexte("ToucheChangementTab", ""), $sListToucheFonctionPlusCode))
EndFunc

Func PositionnerChampToucheAide()
	AlimenterCombo($ComboTouche1_105, $sListToucheFonctionPlusLibelle)
	PositionnerChampsTouche("1_105", TraduireCodeToucheEnUnChamp(DbParamLireTexte("ToucheAide", ""), $sListToucheFonctionPlusCode))
EndFunc

Func PositionnerModeBackup()
	Local $s = DbParamLireTexte("BackupMode", "")
	If StringInStr($s, "Manual") > 0 Then GUICtrlSetState($Checkbox1_401a, $GUI_CHECKED)
	If StringInStr($s, "Day") > 0 Then GUICtrlSetState($Checkbox1_401b, $GUI_CHECKED)
	If StringInStr($s, "Start") > 0 Then GUICtrlSetState($Checkbox1_401c, $GUI_CHECKED)
EndFunc

Func PositionnerChampFormat()
	Local $i, $iIndiceListe = -1, $sCode = DbParamLireTexte("ClipBoardImageFormat", "JPG")
	For $i = 0 To UBound($sListFormatImage) - 1
		If $sCode == $sListFormatImage[$i] Then
			$iIndiceListe = $i
			ExitLoop
		EndIf
	Next
	AlimenterCombo($Combo6_401, $sListFormatImage)
	_GUICtrlComboBox_SetCurSel($Combo6_401, $iIndiceListe)
EndFunc

Func PositionnerCouleur()
	Local $i, $j, $iNb = 0
	Local $s = DbParamLireTexte("ChaineCouleur", "")
	$sCouleursChoisiesCodes = StringSplit($s, "|")
	ReDim $sCouleursChoisiesCodes[$iNbCouleurTotal + 1]
	If $sCouleursChoisiesCodes[1] = "" Then $sCouleursChoisiesCodes[0] = 0
	$sCouleursChoisiesLibelles[0] = $sCouleursChoisiesCodes[0]
	For $i = 1 To $sCouleursChoisiesCodes[0]
		For $j = 0 To $iNbCouleurTotal -1
			If $sCouleursChoisiesCodes[$i] = $sCouleursToutesCodes[$j] Then
				$sCouleursChoisiesLibelles[$i] = $sCouleursToutesLibelles[$j]
				ExitLoop
			EndIf
		Next
	Next
	For $i = 0 To $iNbCouleurTotal -1
		If StringInStr($s, $sCouleursToutesCodes[$i]) = 0 Then
			$iNb += 1
			$sCouleursRestantesCodes[$iNb] = $sCouleursToutesCodes[$i]
			$sCouleursRestantesLibelles[$iNb] = $sCouleursToutesLibelles[$i]
		EndIf
	Next
	$sCouleursRestantesCodes[0] = $iNb
	$sCouleursRestantesLibelles[0] = $iNb
	PeuplerCouleurs($ListViewCouleursChoisies, $sCouleursChoisiesCodes, $sCouleursChoisiesLibelles, 0)
	PeuplerCouleurs($ListViewCouleursRestantes, $sCouleursRestantesCodes, $sCouleursRestantesLibelles, 0)
EndFunc


Func PositionnerTypeSynchro()
	Local $bLocal = $GUI_SHOW, $bSeveur = $GUI_HIDE, $bM2PMasque = $GUI_HIDE, $bM2PAffiche = $GUI_HIDE
	If GUICtrlRead($Radio8_202A) = $GUI_CHECKED Then ; Synchronisation par FTP
		$bLocal = $GUI_HIDE
		$bSeveur = $GUI_SHOW
		If GUICtrlRead($Button8_A03) = "Masquer" Then
			$bM2PAffiche = $GUI_SHOW
		Else
			$bM2PMasque = $GUI_SHOW
		EndIf
	EndIf
	GUICtrlSetState($Group8_203A, $bSeveur)
	GUICtrlSetState($Label8_A01, $bSeveur)
	GUICtrlSetState($Input8_A01, $bSeveur)
	GUICtrlSetState($Label8_A02, $bSeveur)
	GUICtrlSetState($Input8_A02, $bSeveur)
	GUICtrlSetState($Label8_A03, $bSeveur)
	GUICtrlSetState($Button8_A03, $bSeveur)
	GUICtrlSetState($Input8_A03a, $bM2PAffiche)
	GUICtrlSetState($Input8_A03b, $bM2PMasque)
	GUICtrlSetState($Label8_A04, $bSeveur)
	GUICtrlSetState($Input8_A04, $bSeveur)
	GUICtrlSetState($Group8_203B, $bLocal)
	GUICtrlSetState($Label8_B01, $bLocal)
	GUICtrlSetState($Input8_B01, $bLocal)
	GUICtrlSetState($Label8_B01B, $bLocal)
EndFunc

Func PositionnerSynchroFH() ; Synchronisation : Frquence/Heures
	If GUICtrlRead($Radio8_301) = $GUI_CHECKED Then
		GUICtrlSetState($Input8_301, $GUI_ENABLE)
		GUICtrlSetState($Input8_302, $GUI_DISABLE)
	Else
		GUICtrlSetState($Input8_301, $GUI_DISABLE)
		GUICtrlSetState($Input8_302, $GUI_ENABLE)
	EndIf
EndFunc


Func SynchronisationTestParam() ; Tester le paramtrage de synchronisation
	Local $s, $sMes, $iCreer, $sNom = GUICtrlRead($Input8_201)
	If $sNom = "" Then
		MsgBox(4112, $scMsgErreur, "Le nom de la machine est obligatoire", 0, $FormClipSpiritPref)
		Return
	EndIf
	;
	GUISetCursor(15, 1, $FormClipSpiritPref) ; Curseur WAIT
	If GUICtrlRead($Radio8_202A) = $GUI_CHECKED Then ; Synchronisation par FTP
		Local $hFTP, $IdFTP
		Local $sHote = GUICtrlRead($Input8_A01)
		Local $sUser = GUICtrlRead($Input8_A02)
		If GUICtrlRead($Button8_A03) = "Masquer" Then
			$s = GUICtrlRead($Input8_A03a)
		Else
			$s = GUICtrlRead($Input8_A03b)
		EndIf
		Local $sDossier = GUICtrlRead($Input8_A04)
		If StringRight($sDossier, 2) <> "/" Then $sDossier &= "/"
		; Connexion internet ?
		If Ping("www.google.com", 5000) = 0 Then
			$sMes = "Connexion internet indisponible"
		Else
			$hFTP = _FTP_Open($scAppliTitreGeneral)
			If $hFTP = 0 Then
				$sMes = "Erreur sur l'instruction _FTP_Open"
			Else
				$IdFTP = _FTP_Connect($hFTP, $sHote, $sUser, $s)
				If $IdFTP = 0 Then
					$sMes = "Connexion internet OK mais connexion FTP impossible"
				Else
					_FTP_DirGetCurrent($IdFTP)
					If @error <> 0 Then
						$sMes = "Connexion FTP OK mais l'accs au dossier racine pose problme"
					Else
						$s = _FTP_DirSetCurrent($IdFTP, $sDossier)
						If @error <> 0 Then
							$sMes = "Connexion FTP OK mais le dossier distant '" & $sDossier & "' n'est pas accessible. Vous devez le crer manuellement"
						Else
							_FTP_DirSetCurrent($IdFTP, $sDossier & $sNom)
							If @error = 0 Then
								$sMes = "Le dossier correspondant  votre machine est accessible sur votre serveur FTP"
							Else
								_FTP_DirCreate($IdFTP, $sDossier & $sNom)
								If @error <> 0 Then
									$sMes = "Connexion FTP OK mais le dossier propre  votre machine '" & $sNom & "' ne peut pas tre cr."
								Else
									$sMes = "Le dossier correspondant  votre machine peut tre cr avec succs sur votre serveur FTP"
									Sleep(250)
									_FTP_DirDelete($IdFTP, $sDossier & $sNom)
								EndIf
							EndIf
						EndIf
						_FTP_DirSetCurrent($IdFTP, $s)
					EndIf
				EndIf
			EndIf
		EndIf
		$sMes = @CRLF & $sMes
	Else ; Synchonisation par cl USB -----------------------------------------
		Local $i, $l = StringSplit(GUICtrlRead($Input8_B01), "|")
		For $i = 1 To $l[0]
			$iCreer = 0
			$s = _InfoNomFichier($l[$i], 8) ; Le drive
			; Drive OK ?
			If DriveStatus($s) <> "READY" Then
				$sMes &= @CRLF & "Le support " & $s & " est inaccessible"
				ContinueLoop
			EndIf
			; Rpertoire existant ?
			If Not _RepertoireExistant($l[$i]) Then
				If DirCreate($l[$i]) = 1 Then
					$iCreer = 2
				Else
					$sMes &= @CRLF & "Le support local " & $s & " est accessible mais le dossier " & $l[$i] & " ne peut pas tre cr"
					ContinueLoop
				EndIf
			EndIf
			If Not _RepertoireExistant($l[$i]) Then
				$sMes &= @CRLF & "Le support local " & $s & " est accessible mais le dossier " & $l[$i] & " ne peut pas tre cr"
				ContinueLoop
			EndIf
			; Dossier de la machine existant
			If StringRight($l[$i], 1) <> "\" Then $l[$i] &= "\"
			If Not _RepertoireExistant($l[$i] & $sNom) Then
				If DirCreate($l[$i] & $sNom) = 1 Then
					If $iCreer = 0 Then $iCreer = 1
				Else
					$sMes &= @CRLF & "Le support local " & $s & " est accessible mais le dossier " & $l[$i] & $sNom & " ne peut pas tre cr"
					ContinueLoop
				EndIf
			EndIf
			; OK
			$sMes &= @CRLF & "Le dossier " &  $l[$i] & " est OK"
			; suppression des ventuelles rpertoires
			If $iCreer <> 0 Then DirRemove(($l[$i] & $sNom))
			If $iCreer = 2 Then DirRemove($l[$i])
		Next
	EndIf
	GUISetCursor(2) ; Curseur Classique
	MsgBox(8192, $scMsgInfo, "Rsultat du test du paramtrage :" & $sMes, 0, $FormClipSpiritPref)
EndFunc


Func MotPasse2Input()
	If GUICtrlRead($Button8_A03) = "Masquer" Then
		GUICtrlSetData($Input8_A03b, GUICtrlRead($Input8_A03a))
	Else
		GUICtrlSetData($Input8_A03a, GUICtrlRead($Input8_A03b))
	EndIf
EndFunc


Func PositionnerTypeScript()
	Local $i, $sListeScript
	PositionnerOngletScript("")
	$iItemSelectListViewProg = -2
	;
	$sListeScript = DbScriptListe($sTypeScript)
	_GUICtrlListView_BeginUpdate($ListViewProg)
	_GUICtrlListView_DeleteAllItems($ListViewProg)
	For $i = 1 To $sListeScript[0][0]
		GUICtrlCreateListViewItem($sListeScript[$i][0] & "|" & $sListeScript[$i][1] & "|" & $sListeScript[$i][2], $ListViewProg)
	Next
	_GUICtrlListView_EndUpdate($ListViewProg)
	_GUICtrlListView_SetColumnWidth($ListViewProg, 1, 0)
	_GUICtrlListView_SetColumnWidth($ListViewProg, 2, 0)
 	If $sListeScript[0][0] > 0 Then _GUICtrlListView_SetItemSelected($ListViewProg, 0)
EndFunc

Func AfficherScriptDetail($iSelect)
	Local $sData, $bShift, $bCtrl, $bAlt, $bWin, $iIndiceListe
	If $iSelect >= 0 Then
		$sData = DbScriptDetailEntete(_GUICtrlListView_GetItemText($ListViewProg, $iSelect, 1)) ; CEnTitreCode, CEnTitreMenu, CEnCode, CEnToucheActivation, CEnActif, CEnTpsMaxExe
		GUICtrlSetData($Input7_110, $sData[0])
		GUICtrlSetData($Input7_111, $sData[1])
		TraduireCodeToucheEnTousLesChamps($sData[3], $sListToucheToutCode, $bShift, $bCtrl,$bAlt, $bWin, $iIndiceListe)
		PositionnerChampsTouche("7_113", $iIndiceListe, $bShift, $bCtrl, $bAlt, $bWin)
		GUICtrlSetData($Edit7_120, $sData[2])
		If Number($sData[4]) = 1 Then
			GUICtrlSetState($Checkbox7_121, $GUI_CHECKED)
		Else
			GUICtrlSetState($Checkbox7_121, $GUI_UNCHECKED)
		EndIf
		GUICtrlSetData($Input7_110b, Number($sData[5]))
	Else
		GUICtrlSetData($Input7_110, "")
		GUICtrlSetData($Input7_111, "")
		PositionnerChampsTouche("7_113", 0, 0, 0, 0, 0)
		GUICtrlSetData($Edit7_120, "")
		GUICtrlSetState($Checkbox7_121, $GUI_CHECKED)
		GUICtrlSetData($Input7_110b, 20)
	EndIf
	PositionnerOngletScript("F")
	If (GUICtrlRead($Checkbox7_121) = $GUI_CHECKED) And (GUICtrlRead($Edit7_120) <> "") Then
		GUICtrlSetState($Button7_121, $GUI_SHOW)
	Else
		GUICtrlSetState($Button7_121, $GUI_HIDE)
	EndIf
EndFunc

Func UpDownListeScript($bUp)
	Local $iNbItem = _GUICtrlListView_GetItemCount($ListViewProg)
	If $iNbItem < 2 Then Return
	Local $iSelect = ItemSelectionne($ListViewProg)
	Local $dOrdreNew, $iSelectNew
	If $bUp Then
		If $iSelect = 0 Then
			$iSelectNew = $iNbItem - 1
			$dOrdreNew = Ceiling(_GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) + 1)
		Else
			$iSelectNew = $iSelect - 1
			If $iSelect = 1 Then
				$dOrdreNew = _GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) / 2
			Else
				$dOrdreNew = (_GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) + _GUICtrlListView_GetItemText($ListViewProg, $iSelectNew - 1, 2)) / 2
			EndIf
		EndIf
	Else
		If $iSelect = ($iNbItem - 1) Then
			$iSelectNew = 0
			$dOrdreNew = _GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) / 2
		Else
			$iSelectNew = $iSelect + 1
			If $iSelectNew = ($iNbItem - 1) Then
				$dOrdreNew = Ceiling(_GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) + 1)
			Else
				$dOrdreNew = (_GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) + _GUICtrlListView_GetItemText($ListViewProg, $iSelectNew + 1, 2)) / 2
			EndIf
		EndIf
	EndIf
	If Not DbScriptMAJOrdre(_GUICtrlListView_GetItemText($ListViewProg, $iSelect, 1), $dOrdreNew) Then Return
	PositionnerTypeScript()
	_GUICtrlListView_SetItemSelected($ListViewProg, $iSelectNew)
EndFunc

Func SupprimerScript()
	Local $iNbItem = _GUICtrlListView_GetItemCount($ListViewProg)
	If $iNbItem < 1 Then Return
	Local $iSelect = ItemSelectionne($ListViewProg)
	If MsgBox(8484, $scMsgConfirm, "Etes-vous sr de vouloir supprimer le script" & @CRLF & _GUICtrlListView_GetItemText($ListViewProg, $iSelect, 0) & " ?", _
										0, $FormClipSpiritPref) <> 6 Then Return
	If Not DbScriptSupprimer(_GUICtrlListView_GetItemText($ListViewProg, $iSelect, 1), $sTypeScript, DbParamLireBoolean("SynchronisationScript", True)) Then Return
	PositionnerTypeScript()
	_GUICtrlListView_SetItemSelected($ListViewProg, _Max($iSelect, $iNbItem - 2))
EndFunc

Func ModifValidScript($iMode) ; 0=Visu, 1=Modif, 2=Cration
	Local $iRefAction, $iSelect = ItemSelectionne($ListViewProg)
	If $iMode = 0 Then ; Nous sommes en mode visu
		If ($iSelect < 0) And (GUICtrlRead($Radio7_101c) = $GUI_UNCHECKED) Then Return False
		PositionnerOngletScript("T")
		GUICtrlSetState($Edit7_120, $GUI_FOCUS)
	Else
		Local $iCEnActif = 0, $iSelectNew
		Local $sParamScript[1][$icNbParamCode + 1]
		If GUICtrlRead($Checkbox7_121) = $GUI_CHECKED Then $iCEnActif = 1
		Local $sCEnTitreCode = GUICtrlRead($Input7_110)
		Local $sCEnTitreMenu = GUICtrlRead($Input7_111)
		Local $sCEnCode = GUICtrlRead($Edit7_120)
		Local $sCEnToucheActivation = TraduireChampEnCodeTouche($sListToucheToutCode, IndiceComboTouche("7_113"), LireCheckBox("Shift7_113"), LireCheckBox("Ctrl7_113"), LireCheckBox("Alt7_113"), LireCheckBox("Win7_113"))
		Local $iCEnTpsMaxExe = Number(GUICtrlRead($Input7_110b))
		; Contrles
		If $sCEnTitreCode = "" Then
			MsgBox(4112, $scMsgErreur, "Vous n'avez pas saisi de titre de ce script", 0, $FormClipSpiritPref)
			GUICtrlSetState($Input7_110, $GUI_FOCUS)
			Return False
		EndIf
		If $iCEnActif = 1 Then
			If ($sCEnTitreMenu = "") And (GUICtrlRead($Radio7_101c) <> $GUI_CHECKED) Then
				MsgBox(4112, $scMsgErreur, "Vous n'avez pas saisi titre de menu", 0, $FormClipSpiritPref)
				GUICtrlSetState($Input7_111, $GUI_FOCUS)
				Return False
			EndIf
			If Not AnalyseCode($sCEnCode, $sParamScript) Then Return False
		EndIf
		; Enregistrement
		If $iMode = 1 Then
			If GUICtrlRead($Radio7_101c) = $GUI_CHECKED Then ; scripting Automatique
				$iRefAction = _GUICtrlListView_GetItemText($ListViewProg, 0, 1)
			Else
				$iRefAction = _GUICtrlListView_GetItemText($ListViewProg, $iSelect, 1)
			EndIf
			DbScriptMAJEntete($iRefAction, $sCEnTitreCode, $sCEnTitreMenu, $sCEnCode, $sCEnToucheActivation, $iCEnActif, $iCEnTpsMaxExe)
			$iSelectNew = $iSelect
		Else
			Local $dCEnOrdre
			Local $iNbItem = _GUICtrlListView_GetItemCount($ListViewProg)
			If $iSelect = ($iNbItem - 1) Then
				$iSelectNew = $iNbItem
				$dCEnOrdre = Ceiling(_GUICtrlListView_GetItemText($ListViewProg, $iSelect, 2) + 1)
			Else
				$iSelectNew = $iSelect + 1
				$dCEnOrdre = (_GUICtrlListView_GetItemText($ListViewProg, $iSelectNew, 2) + _GUICtrlListView_GetItemText($ListViewProg, $iSelect, 2)) / 2
			EndIf
			$iRefAction = DbScriptCreerEntete($sTypeScript, $dCEnOrdre, $sCEnTitreCode, $sCEnTitreMenu, $sCEnCode, $sCEnToucheActivation, $iCEnActif, $iCEnTpsMaxExe)
			If $iRefAction = -1 Then
				MsgBox(4112, $scMsgErreur, "Le script n'a pas pu tre enregistr !?" & @CRLF & "Sortez de l'application et recommencez", 0, $FormClipSpiritPref)
				Return False
			EndIf
		EndIf
		If $iCEnActif = 1 Then
			DbScriptDetailEnregistrer($iRefAction, $sTypeScript, $sParamScript)
		Else
			DbScriptDetailSupprimer($iRefAction)
		EndIf
		$bScriptEnregistre = True
		PositionnerTypeScript()
		_GUICtrlListView_SetItemSelected($ListViewProg, $iSelectNew)
		GUICtrlSetState($ListViewProg, $GUI_FOCUS)
	EndIf
	Return True
EndFunc

; OUT True si OK + False
Func AnalyseCode($sCode, ByRef $sParamScript)
	Local $iLigne, $sLigneCode = StringSplit($sCode, @CR)
	Local $i, $j, $iPos, $bExe, $b, $bToutOk = ($sLigneCode[0] > 0)
	Local $vExe, $sCond, $sAffect, $sPart1, $sPart2, $sPart3, $sPart4, $sPart5, $sLigne
	Local $iNbLigneNONCode = 0
	Local $iTaillePile = 0
	Local $sPile[$iTaillePile + 1][2]
	; Supprimer les lignes blanches en bas
	$iLigne = 0
	For $i = $sLigneCode[0] To 1 Step -1
		$sLigneCode[$i] = StringReplace($sLigneCode[$i], @LF, "")
		If StringStripWS($sLigneCode[$i], 3) <> "" Then
			$iLigne = $i
			ExitLoop
		EndIf
	Next
	$sLigneCode[0] = $iLigne
	ReDim $sParamScript[$sLigneCode[0] + 2][$icNbParamCode + 1]
	; Analyse chaque ligne
	For $iLigne = 1 To $sLigneCode[0]
		$sLigne = StringStripWS($sLigneCode[$iLigne], 3) ; Supp des blancs de dbut et fin
		; Recherche du type de ligne
		If ($sLigne = "") Or (StringLeft($sLigne, 1) = ";") Then ; Ligne blanche ou commentaire -------------
			$iNbLigneNONCode += 1
			$sParamScript[$iLigne][0] = "NA"
		ElseIf StringLeft($sLigne, 1) = "%" Then ; Affectation ----------------------------------------------
			; Variable d'affectation reconnue ?
			If AnalyseCodeVariableEtAffectation($sLigne, $iLigne, True, $sPart2, $sPart3) Then
				$sParamScript[$iLigne][0] = "A"
				$sParamScript[$iLigne][1] = $sPart2
				$sParamScript[$iLigne][2] = $sPart3
			Else
				$bToutOk = False
				ExitLoop
			EndIf
		ElseIf StringLeft($sLigne, 3) = "IF " Then ; IF -----------------------------------------------------
			; Then trouv
			$i = 1
			$bExe = True
			While 1
				$iPos = StringInStr($sLigne, " Then", 0, $i)
				If $iPos = 0 Then
					ExitLoop
				Else
					; Condition valide ?
					$sCond = StringStripWS(StringMid($sLigne, 4, $iPos -3), 3)
					$sCond = ToutVariabiliser($sCond, True)
					$vExe = Execute($sCond)
					If @error = 0 Then
						$bExe = True
						ExitLoop
					EndIf
					$bExe = False
				EndIf
				$i += 1
			WEnd
			If Not $bExe Then
				$bToutOk = False
				AnalyseCodeErreur( "La condition entre le 'If' et le 'Then' incorrecte", $iLigne)
				ExitLoop
			EndIf
			If $iPos = 0 Then
				$bToutOk = False
				AnalyseCodeErreur("' Then' non trouv aprs le 'If '", $iLigne)
				ExitLoop
			EndIf
			; Forme If ... Then
			If StringLen($sLigne) = ($iPos + 4) Then
				$sParamScript[$iLigne][0] = "ITM"
				$sParamScript[$iLigne][1] = $sCond
				; Grer la pile
				$iTaillePile += 1
				ReDim $sPile[$iTaillePile + 1][2]
				$sPile[$iTaillePile][0] = "ITM"
				$sPile[$iTaillePile][1] = $iLigne
				ContinueLoop
			EndIf
			; La suite de Then
			$sLigne = StringMid($sLigne, $iPos + 5)
			If StringLeft($sLigne, 1) <> " " Then
				$bToutOk = False
				AnalyseCodeErreur("La suite du 'If ... Then' n'est pas cohrent", $iLigne)
				ExitLoop
			EndIf
			; Forme If ... Then ... Else ... ?
			If StringInStr($sLigne, " Else ") > 0 Then
				$i = 1
				$bExe = False
				While 1
					$iPos = StringInStr($sLigne, " Else ", 0, $i)
					If $iPos = 0 Then
						ExitLoop
					Else
						; Affectation/Procdure 1 valide ?
						If AnalyseCodeVariableEtAffectationOuProcedure(StringStripWS(Stringleft($sLigne, $iPos -1), 3), $iLigne, False, $sPart2, $sPart3) Then
							; Affectation/Procdure 2 valide ?
							If AnalyseCodeVariableEtAffectationOuProcedure(StringStripWS(StringMid($sLigne, $iPos +6), 3), $iLigne, False, $sPart4, $sPart5) Then
								$bExe = True
								ExitLoop
							EndIf
						EndIf
					EndIf
					$i += 1
				WEnd
				If $bExe Then
					$sParamScript[$iLigne][0] = "ITE"
					$sParamScript[$iLigne][1] = $sCond
					$sParamScript[$iLigne][2] = $sPart2
					$sParamScript[$iLigne][3] = $sPart3
					$sParamScript[$iLigne][4] = $sPart4
					$sParamScript[$iLigne][5] = $sPart5
					ContinueLoop
				EndIf
			EndIf
			; Forme If ... Then ... ?
			If AnalyseCodeVariableEtAffectationOuProcedure($sLigne, $iLigne, True, $sPart2, $sPart3) Then
				$sParamScript[$iLigne][0] = "IT"
				$sParamScript[$iLigne][1] = $sCond
				$sParamScript[$iLigne][2] = $sPart2
				$sParamScript[$iLigne][3] = $sPart3
			Else
				$bToutOk = False
				ExitLoop
			EndIf
		ElseIf $sLigne = "Else" Then ; Else -----------------------------------------------------------------
			; Retrouver dans la pile le If ... then
			If $sPile[$iTaillePile][0] <> "ITM" Then
				$bToutOk = False
				AnalyseCodeErreur("'Else' trouv sans un 'If ... Then' avant,", $iLigne)
				ExitLoop
			Else
				; Mettre  jour la ligne ITM
				$sParamScript[$sPile[$iTaillePile][1]][2] = $iLigne
			EndIf
			$sParamScript[$iLigne][0] = "ITME"
		ElseIf $sLigne = "EndIf" Then ; EndIf ---------------------------------------------------------------
			; Retrouver dans la pile le If ... then
			If $sPile[$iTaillePile][0] <> "ITM" Then
				$bToutOk = False
				AnalyseCodeErreur("'EndIf' trouv sans un 'If ... Then' avant,", $iLigne)
				ExitLoop
			EndIf
			; Ligne ITMX
			$sParamScript[$iLigne][0] = "ITMX"
			; Mettre  jour la ligne ITM
			$sParamScript[$sPile[$iTaillePile][1]][3] = $iLigne
			; Mise  jour des lignes Else
			$j = 0
			For $i = $sPile[$iTaillePile][1] +1 To $iLigne -1
				If ($sParamScript[$i][0] = "ITME") And ($sParamScript[$i][1] = "") Then
					$sParamScript[$i][1] = $iLigne
					$j += 1
				EndIf
			Next
			If $j > 1 Then
				$bToutOk = False
				AnalyseCodeErreur("Plus d'un 'Else' entre le 'If ... Then' (ligne " & $sPile[$iTaillePile][1] & ") et le 'EndIf' (ligne " & $iLigne & ")", 0, $iLigne)
				ExitLoop
			EndIf
			; Oter de la pile
			$iTaillePile -= 1
			ReDim $sPile[$iTaillePile + 1][2]
		ElseIf (StringLeft($sLigne, 5) = "For %") Or (StringLeft($sLigne, 6) = "For  %") Then ; For ---------
			; To trouv
			$i = 1
			$bExe = False
			While 1
				$iPos = StringInStr($sLigne, " To", 0, $i)
				If $iPos = 0 Then
					ExitLoop
				Else
					; Affectation valide ?
					$sAffect = StringStripWS(StringMid($sLigne, 5, $iPos -4), 3)
					If AnalyseCodeVariableEtAffectation($sAffect, $iLigne, True, $sPart1, $sPart2) Then
						$bExe = False
						ExitLoop
					EndIf
					$bExe = True
				EndIf
				$i += 1
			WEnd
			If $bExe Then
				$bToutOk = False
				AnalyseCodeErreur("L'affectation entre le 'For' et le 'Next' incorrecte", $iLigne)
				ExitLoop
			EndIf
			If $iPos = 0 Then
				$bToutOk = False
				AnalyseCodeErreur("' To' non trouv aprs le 'For '", $iLigne)
				ExitLoop
			EndIf
			; Step ou pas
			$sPart4 = "1" ; Step par dfaut
			$sLigne = StringMid($sLigne, $iPos + 4)
			$iPos = StringInStr($sLigne, " Step ")
			If $iPos > 0 Then
				If Not AnalyseCodeAffectation(StringLeft($sLigne, $iPos -1), $iLigne, "", $sPart3) Then
					$bToutOk = False
					AnalyseCodeErreur("La valeur aprs le 'To' est incorrecte", $iLigne)
					ExitLoop
				EndIf
				If Not AnalyseCodeAffectation(StringMid($sLigne, $iPos +6), $iLigne, "", $sPart4) Then
					$bToutOk = False
					AnalyseCodeErreur("La valeur aprs le 'Step' est incorrecte", $iLigne)
					ExitLoop
				EndIf
			Else
				If Not AnalyseCodeAffectation($sLigne, $iLigne, "", $sPart3) Then
					$bToutOk = False
					AnalyseCodeErreur("La valeur aprs le 'To' est incorrecte", $iLigne)
					ExitLoop
				EndIf
			EndIf
			$sParamScript[$iLigne][0] = "For"
			$sParamScript[$iLigne][1] = $sPart1
			$sParamScript[$iLigne][2] = $sPart2
			$sParamScript[$iLigne][3] = $sPart3
			$sParamScript[$iLigne][4] = $sPart4
			; Grer la pile
			$iTaillePile += 1
			ReDim $sPile[$iTaillePile + 1][2]
			$sPile[$iTaillePile][0] = "For"
			$sPile[$iTaillePile][1] = $iLigne
		ElseIf $sLigne = "Next" Then ; Next -----------------------------------------------------------------
			; Retrouver dans la pile le For ... To
			If $sPile[$iTaillePile][0] <> "For" Then
				$bToutOk = False
				AnalyseCodeErreur("'Next' trouv sans un 'For ...=... To' avant,", $iLigne)
				ExitLoop
			EndIf
			; Ligne FTX
			$sParamScript[$iLigne][0] = "Next"
			; Mettre  jour la ligne FT
			$sParamScript[$sPile[$iTaillePile][1]][5] = $iLigne
			; Mise  jour des lignes ExitLoop & ContinueLoop
			For $i = $sPile[$iTaillePile][1] +1 To $iLigne -1
				If (($sParamScript[$i][0] = "ExitLoop") Or ($sParamScript[$i][0] = "ContinueLoop")) And ($sParamScript[$i][1] = "") Then
					$sParamScript[$i][1] = $iLigne
				Else
					If (($sParamScript[$i][2] = "ExitLoop") Or ($sParamScript[$i][2] = "ContinueLoop")) And ($sParamScript[$i][3] = "") Then $sParamScript[$i][3] = $iLigne
					If (($sParamScript[$i][4] = "ExitLoop") Or ($sParamScript[$i][4] = "ContinueLoop")) And ($sParamScript[$i][5] = "") Then $sParamScript[$i][5] = $iLigne
				EndIf
			Next
			; Oter de la pile
			$iTaillePile -= 1
			ReDim $sPile[$iTaillePile + 1][2]
		ElseIf $sLigne = "ExitLoop" Then ; ExitLoop ---------------------------------------------------------
			; Retrouver dans la pile le For ... TO
			$bToutOk = False
			For $i = $iTaillePile To 1 Step -1
				If $sPile[$i][0] = "For" Then $bToutOk = True
			Next
			If Not $bToutOk Then
				AnalyseCodeErreur("'ExitLoop' trouv sans un 'For ...=... To' avant,", $iLigne)
				ExitLoop
			EndIf
			$sParamScript[$iLigne][0] = "ExitLoop"
		ElseIf $sLigne = "ContinueLoop" Then ; ContinueLoop -------------------------------------------------
			; Retrouver dans la pile le For ... TO
			$bToutOk = False
			For $i = $iTaillePile To 1 Step -1
				If $sPile[$i][0] = "For" Then $bToutOk = True
			Next
			If Not $bToutOk Then
				AnalyseCodeErreur("'ContinueLoop' trouv sans un 'For ...=... To' avant,", $iLigne)
				ExitLoop
			EndIf
			$sParamScript[$iLigne][0] = "ContinueLoop"
		ElseIf $sLigne = "PutToClipboard" Then ; PutToClipboard ---------------------------------------------
			$sParamScript[$iLigne][0] = "PutToClipboard"
		ElseIf $sLigne = "Exit" Then ; Exit -----------------------------------------------------------------
			$sParamScript[$iLigne][0] = "Exit"
		Else ; Ligne non reconnue ---------------------------------------------------------------------------
			$bToutOk = False
			AnalyseCodeErreur("Erreur de syntaxe", $iLigne)
			ExitLoop
		EndIf
	Next
	If $bToutOk Then
		If $sLigneCode[0] = $iNbLigneNONCode Then
			$bToutOk = False
			MsgBox(4112, $scMsgErreur, "Aucune ligne de script valide !", 0, $FormClipSpiritPref)
		EndIf
		; La pile doit-tre vide
		If $iTaillePile > 0 Then
			$bToutOk = False
			If $sPile[$iTaillePile][0] = "For" Then
				AnalyseCodeErreur("'Next' non trouv aprs le 'For ... To ...'", $sPile[$iTaillePile][1])
			ElseIf $sPile[$iTaillePile][0] = "ITM" Then
				AnalyseCodeErreur("'EndIf' non trouv aprs le 'If ... Then'", $sPile[$iTaillePile][1])
			Else
				AnalyseCodeErreur("Fin attendue mais non trouve suite  l'instruction '" & $sPile[$iTaillePile][0] & "'", $sPile[$iTaillePile][1])
			EndIf
		Else
			; Cration de la ligne de fin de Script
			$sParamScript[$sLigneCode[0] +1][0] = "X"
			; Recherche des "Exit"
			For $i = 1 To $sLigneCode[0]
				If $sParamScript[$i][0] = "Exit" Then
					$sParamScript[$i][1] = $sLigneCode[0] +1
				Else
					If $sParamScript[$i][2] = "Exit" Then $sParamScript[$i][3] = $sLigneCode[0] +1
					If $sParamScript[$i][4] = "Exit" Then $sParamScript[$i][5] = $sLigneCode[0] +1
				EndIf
			Next
			; Compteur de ligne
			$sParamScript[0][0] = $sLigneCode[0] + 1
		EndIf
	EndIf
	Return $bToutOk
EndFunc


Func AnalyseCodeVariableEtAffectationOuProcedure($sAnalyse, $iLigne, $bMesErr, ByRef $sVariable, ByRef $sAffectation)
	Local $i
	$sVariable = ""
	$sAffectation = ""
	$sAnalyse = StringStripWS($sAnalyse, 3) ; Supp des blancs de dbut et fin
	; Est-ce une procdure ?
	For $i = 0 To $iParamScriptNbProcedure -1
		If $sAnalyse = $sParamScriptProcedure[$i] Then
			$sVariable = $sParamScriptProcedure[$i]
			ExitLoop
		EndIf
	Next
	If $sVariable <> "" Then
		Return True
	Else
		If StringInStr($sAnalyse, "=") = 0 Then
			If $bMesErr Then AnalyseCodeErreur("Procdure non reconnue ", $iLigne)
			Return False
		EndIf
	EndIf
	; Est-ce une affectation ?
	Return AnalyseCodeVariableEtAffectation($sAnalyse, $iLigne, $bMesErr, $sVariable, $sAffectation)
EndFunc

Func AnalyseCodeVariableEtAffectation($sAnalyse, $iLigne, $bMesErr, ByRef $sVariable, ByRef $sAffectation)
	Local $i, $vExe, $iNumVar = -1
	For $i = 0 To $iParamScriptNbVarRW -1
		If StringInStr($sAnalyse, $sParamScriptVarRW[$i]) = 1 Then
			$iNumVar = $i
			ExitLoop
		EndIf
	Next
	If $iNumVar = -1 Then
		For $i = 0 To $iParamScriptNbVarR -1
			If StringInStr($sAnalyse, $sParamScriptVarR[$i]) = 1 Then
				$iNumVar = $i
				ExitLoop
			EndIf
		Next
		If $bMesErr Then
			If $iNumVar = -1 Then
				AnalyseCodeErreur("Variable non reconnue de dbut de " & $iLigne, 0, $iLigne)
			Else
				AnalyseCodeErreur("Variable interdite avant le signe = ", $iLigne)
			EndIf
		EndIf
		Return False
	EndIf
	If $iNumVar < 26 Then
		$sVariable = "__" & Chr(Number($iNumVar + 97))
	Else
		$sVariable = "_" & StringReplace( $sParamScriptVarRW[$iNumVar], "%", "")
	EndIf
	; Signe = trouv ?
	$sAnalyse = StringStripWS(StringMid($sAnalyse, StringLen( $sParamScriptVarRW[$iNumVar]) + 1), 1)
	If StringLeft($sAnalyse, 1) <> "=" Then
		If $bMesErr Then  AnalyseCodeErreur( "Le signe = n'est pas trouv aprs la variable " & $sParamScriptVarRW[$iNumVar] & " en ligne " & $iLigne, 0, $iLigne)
		Return False
	EndIf
	; Expression OK ?
	If Not AnalyseCodeAffectation(StringMid($sAnalyse, 2), $iLigne, $bMesErr, $sAffectation) Then Return False
	Return True
EndFunc

Func AnalyseCodeAffectation($sAnalyse, $iLigne, $sMesErr, ByRef $sAffectation)
	Local $vExe
	$sAnalyse = StringStripWS($sAnalyse, 1)
	$sAnalyse = ToutVariabiliser($sAnalyse, True)
	$vExe = Execute($sAnalyse)
	If @error <> 0 Then
		If $sMesErr <> "" Then AnalyseCodeErreur("L'lment affect  la variable n'est pas reconnu", $iLigne)
		Return False
	EndIf
	$sAffectation = $sAnalyse
	Return True
EndFunc

Func AnalyseCodeErreur($sMsg, $iLigneErr, $iLigneGo = -1)
	Local $s
	If $iLigneGo = -1 Then $iLigneGo = $iLigneErr
	If $iLigneErr > 0 Then $s = " en ligne " & $iLigneErr
	MsgBox(4112, $scMsgErreur, $sMsg & $s & @CRLF & @CRLF & "(Vous pouvez valider en dcochant 'Activer ce script')", 0, $FormClipSpiritPref)
	; Prparation de la ligne en erreur pour la marquer
	$iScriptLigneEnErreur = $iLigneGo
EndFunc

Func ToutVariabiliser($sChaine, $bRead)
	Local $i
	For $i = 0 To $iParamScriptNbVarRW -1
		If $i < 26 Then
			$sChaine = StringReplace($sChaine, $sParamScriptVarRW[$i], "$__" & Chr(Number($i + 97)))
		Else
			$sChaine = StringReplace($sChaine, $sParamScriptVarRW[$i], "$_" & StringReplace( $sParamScriptVarRW[$i], "%", ""))
		EndIf
	Next
	If $bRead Then
		For $i = 0 To $iParamScriptNbVarR -1
			$sChaine = StringReplace($sChaine, $sParamScriptVarR[$i], "$_" & StringReplace( $sParamScriptVarR[$i], "%", ""))
		Next
	EndIf
	Return $sChaine
EndFunc

Func ScriptSimuler($iRefAction)
	; Couleurs
	$sSimulChaineCouleur = DbParamLireTexte("ChaineCouleur", "FFFFFF|FEE347|7FFF00|C60800|096A09|120D16")
	$sSimulTableauCouleurs = _StringSplitInverse($sSimulChaineCouleur, "|")
	If $sSimulChaineCouleur = "" Then $sSimulTableauCouleurs[0] = 0
	;
	Local $idMsgSimul, $sListParam, $bTemp, $iRetour
	Local $sTitreRetour, $sTexteRetour, $sCommentaireRetour, $sProvenanceRetour, $sCouleurRetour = "F0F0F0"
	Local Const $sSimulTitreF = "Simulation du script"
	Local $sData[5]
	; Interface
	Local $FormSimuler = GUICreate("~Simul~", 435, 645, -1, -1, BitOR($WS_MINIMIZEBOX,$WS_SYSMENU,$WS_CAPTION,$WS_GROUP,$WS_BORDER), $WS_EX_TOOLWINDOW, $FormClipSpiritPref)
	Local $GroupSimulAvant = GUICtrlCreateGroup(" Valeurs initiales avant l'excution du script ", 8, 32, 417, 281)
	Local $LabelSimulAvant1 = GUICtrlCreateLabel("Titre", 24, 58, 25, 17)
	Local $InputSimulAvantTitre = GUICtrlCreateInput("", 75, 55, 322, 21)
	GUICtrlSetLimit(-1, 50)
	Global $InputSimulAvantCouleurNum = GUICtrlCreateInput("", 384, 55, 33, 21)
	GUICtrlSetState(-1, $GUI_HIDE)
	Global $UpdownSiumulAvantCouleurNum = GUICtrlCreateUpdown($InputSimulAvantCouleurNum)
	Local $LabelSimulAvant2 = GUICtrlCreateLabel("Texte du presse-papier", 24, 81, 112, 17)
	Local $EditSimulAvantTexte = GUICtrlCreateEdit("", 22, 99, 393, 153)
	Local $LabelSimulAvant3 = GUICtrlCreateLabel("Commentaire", 24, 262, 65, 17)
	Local $InputSimulAvantCommentaire = GUICtrlCreateInput("", 91, 259, 322, 21)
	Local $LabelSimulAvant4 = GUICtrlCreateLabel("Provenance", 24, 286, 62, 17)
	Local $InputSimulAvantProvenance = GUICtrlCreateInput("", 91, 283, 322, 21)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $GroupApres = GUICtrlCreateGroup(" Valeurs aprs l'excution du script ", 8, 318, 417, 281)
	Local $LabelSimulApres1 = GUICtrlCreateLabel("Titre", 24, 344, 25, 17)
	Local $InputSimulApresTitre = GUICtrlCreateInput("", 75, 341, 322, 21)
	GUICtrlSetLimit(-1, 50)
	Local $LabelSimulApres2 = GUICtrlCreateLabel("Texte du presse-papier", 24, 367, 112, 17)
	Local $EditSimulApresTexte = GUICtrlCreateEdit("", 22, 385, 393, 153)
	Local $LabelSimulApres3 = GUICtrlCreateLabel("Commentaire", 24, 548, 65, 17)
	Local $InputSimulApresCommentaire = GUICtrlCreateInput("", 91, 545, 322, 21)
	Local $LabelSimulApres4 = GUICtrlCreateLabel("Provenance", 24, 572, 62, 17)
	Local $InputSimulApresProvenance = GUICtrlCreateInput("", 91, 569, 322, 21)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $ButtonSimulSimuler = GUICtrlCreateButton("Simuler", 10, 608, 251, 25, $WS_GROUP)
	Local $ButtonSimulRapport = GUICtrlCreateButton("Afficher rapport", 272, 608, 91, 25, $WS_GROUP)
	Local $ButtonSimulFermer = GUICtrlCreateButton("Fermer", 374, 608, 51, 25, $WS_GROUP)
	Local $ButtonSimulRamenerPP = GUICtrlCreateButton("Ramener le dernier presse-papier", 254, 8, 171, 25, $WS_GROUP)
	;
	If GUICtrlRead($Radio7_101b) = $GUI_UNCHECKED Then ; Type cration
		GUICtrlSetData($InputSimulAvantTitre, $sSimulTitre)
		GUICtrlSetData($EditSimulAvantTexte, $sSimulTexte)
		GUICtrlSetData($InputSimulAvantCommentaire, $sSimulCommentaire)
		GUICtrlSetData($InputSimulAvantProvenance, $sSimulProvenance)
	EndIf
	_ChampModifiable($InputSimulApresTitre, False)
	_ChampModifiable($EditSimulApresTexte, False)
	_ChampModifiable($InputSimulApresCommentaire, False)
	_ChampModifiable($InputSimulApresProvenance, False)
	WinSetTitle("~Simul~", "", $sSimulTitreF)
	GUISetState(@SW_DISABLE, $FormClipSpiritPref)
	GUISwitch($FormSimuler)
	GUISetState(@SW_SHOW, $FormSimuler)
	While 1
		$idMsgSimul = GUIGetMsg()
		Switch $idMsgSimul
			Case $GUI_EVENT_CLOSE, $ButtonSimulFermer
				ExitLoop
			Case $InputSimulAvantCouleurNum
				CouleurSimulTitre($InputSimulAvantCouleurNum, $InputSimulAvantTitre, $sCouleurRetour)
			Case $ButtonSimulSimuler
				$sListParam = DbScriptListeParam($iRefAction)
				If GUICtrlRead($Radio7_101b) = $GUI_CHECKED Then ; Type cration
					$sTitreRetour = ""
					$sTexteRetour = ""
					$sCommentaireRetour = ""
					$sProvenanceRetour = ""
				Else
					$sTitreRetour = GUICtrlRead($InputSimulAvantTitre)
					$sTexteRetour = GUICtrlRead($EditSimulAvantTexte)
					$sCommentaireRetour = GUICtrlRead($InputSimulAvantCommentaire)
					$sProvenanceRetour = GUICtrlRead($InputSimulAvantProvenance)
				EndIf
				$iRetour = _ExecScript($sListParam, $sTitreRetour, $sTexteRetour, $sCommentaireRetour, $sCouleurRetour, $sProvenanceRetour, $scMsgErreur, $FormSimuler, _
										$bTemp, $scFicDebug, GUICtrlRead($Edit7_120), GUICtrlRead($Input7_110))
				If GUICtrlRead($Radio7_101b) = $GUI_CHECKED Then $sProvenanceRetour = "Auto-cration" ; Type cration
				If $iRetour <> -1 Then
					If $iRetour = 0 Then MsgBox(4160, $scMsgInfo, "Le script n'a produit aucun changement sur les donnes", 0, $FormClipSpiritPref)
					GUICtrlSetData($InputSimulApresTitre, $sTitreRetour)
					GUICtrlSetData($EditSimulApresTexte, $sTexteRetour)
					GUICtrlSetData($InputSimulApresCommentaire, $sCommentaireRetour)
					GUICtrlSetData($InputSimulApresProvenance, $sProvenanceRetour)
					CouleurSimulTexteEtFond($InputSimulApresTitre, $sCouleurRetour, "6D6D6D")
					ChampModifie($InputSimulApresTitre, $sTitreRetour <> GUICtrlRead($InputSimulAvantTitre))
					ChampModifie($EditSimulApresTexte, $sTexteRetour <> GUICtrlRead($EditSimulAvantTexte))
					ChampModifie($InputSimulApresCommentaire, $sCommentaireRetour <> GUICtrlRead($InputSimulAvantCommentaire))
					ChampModifie($InputSimulApresProvenance, $sProvenanceRetour <> GUICtrlRead($InputSimulAvantProvenance))
				EndIf
				GUISetState(@SW_SHOW, $sSimulTitreF)
			Case $ButtonSimulRapport
				If Not FileExists($scFicDebug) Then
					MsgBox(4160, $scMsgInfo, "Rapport non disponible (" & $scFicDebug & ")", 0, $FormClipSpiritPref)
				Else
					GUISetCursor(15, 1, $FormSimuler) ; Curseur WAIT
					ShellExecute($scFicDebug)
					GUISetCursor(2) ; Curseur Classique
				EndIf
			Case $ButtonSimulRamenerPP
				$sData = DbItemTexteLireDernier() ; 0=PrpText 1=PrpTitre 2=PrpProvenance 3=PrpCommentaire 4=PrpPlus
				GUICtrlSetData($InputSimulAvantTitre, $sData[1])
				GUICtrlSetData($EditSimulAvantTexte, $sData[0])
				GUICtrlSetData($InputSimulAvantCommentaire, $sData[3])
				GUICtrlSetData($InputSimulAvantProvenance, $sData[2])
				$sCouleurRetour = _LireValParamPlus($sData[4], "BkC", $sCouleurDef)
				CouleurSimulTexteEtFond($InputSimulAvantTitre, $sCouleurRetour)
		EndSwitch
		If _IsPressed($sToucheAide) Then AccesAide() ; Touche d'aide
	WEnd
	If GUICtrlRead($Radio7_101b) = $GUI_UNCHECKED Then
		$sSimulTitre = GUICtrlRead($InputSimulAvantTitre)
		$sSimulTexte = GUICtrlRead($EditSimulAvantTexte)
		$sSimulCommentaire = GUICtrlRead($InputSimulAvantCommentaire)
		$sSimulProvenance = GUICtrlRead($InputSimulAvantProvenance)
	EndIf
	GUIDelete($FormSimuler)
EndFunc

Func CouleurSimulTitre($InputTitre, $InputColorNum, ByRef $sCouleur)
	Local $iMin, $iNumCouleur = GUICtrlRead($InputTitre), $sCouleurOld = $sCouleur
	If StringInStr($sSimulChaineCouleur, $sCouleur) > 0 Then
		$iMin = 1
	Else
		$iMin = 0
	EndIf
	If $iNumCouleur < $iMin Then
		$iNumCouleur = $sSimulTableauCouleurs[0]
	EndIf
	If $iNumCouleur > $sSimulTableauCouleurs[0] Then
		$iNumCouleur = $iMin
	EndIf
	GUICtrlSetData($InputTitre, $iNumCouleur)
	If $iNumCouleur = 0 Then
		$sCouleur = $sCouleurOld
	Else
		$sCouleur = $sSimulTableauCouleurs[$iNumCouleur]
	EndIf
	CouleurSimulTexteEtFond($InputColorNum, $sCouleur)
EndFunc

Func CouleurSimulTexteEtFond($ControlID, $sCouleurFond, $sCouleurTexte = "")
	GUICtrlSetBkColor($ControlID, Dec($sCouleurFond))
	If $sCouleurTexte = "" Then
		If (0.299 * Dec(StringLeft($sCouleurFond, 2)) + 0.587 * Dec(StringMid($sCouleurFond, 3, 2)) + 0.114 * Dec(StringRight($sCouleurFond, 2))) < 80 Then
			GUICtrlSetColor($ControlID, 0xFFFFFF)
		Else
			GUICtrlSetColor($ControlID, 0x000000)
		EndIf
	Else
		GUICtrlSetColor($ControlID, Dec($sCouleurTexte))
	EndIf
EndFunc


Func PositionnerOngletScript($cCas)
	If $cCas = "" Then
		Local $iEtat1 = $GUI_HIDE, $iEtat2 = $GUI_SHOW
		Select
			Case GUICtrlRead($Radio7_101a) = $GUI_CHECKED
				$sTypeScript = "T"
			Case GUICtrlRead($Radio7_101b) = $GUI_CHECKED
				$sTypeScript = "C"
			Case GUICtrlRead($Radio7_101c) = $GUI_CHECKED
				$sTypeScript = "A"
				$iEtat1 = $GUI_SHOW
				$iEtat2 = $GUI_HIDE
				$cCas = "T"
		EndSelect
		GUICtrlSetState($Label7_111, $iEtat2)
		GUICtrlSetState($Input7_111, $iEtat2)
		GUICtrlSetState($Label7_113, $iEtat2)
		GUICtrlSetState($CheckboxShift7_113, $iEtat2)
		GUICtrlSetState($CheckboxAlt7_113, $iEtat2)
		GUICtrlSetState($CheckboxCtrl7_113, $iEtat2)
		GUICtrlSetState($CheckboxWin7_113, $iEtat2)
		GUICtrlSetState($ComboTouche7_113, $iEtat2)
	EndIf
	If $cCas <> "" Then
		; Accessible/Inaccesssible & Cacher/Montrer
		Local $EnableDisable = $GUI_ENABLE
		If $cCas = "F" Then $EnableDisable = $GUI_DISABLE
		Local $NotEnableDisable = $GUI_DISABLE
		If $cCas = "F" Then $NotEnableDisable = $GUI_ENABLE
		Local $Hide = $GUI_HIDE
		If $cCas = "F" Then $Hide = $GUI_SHOW
		GUICtrlSetState($Radio7_101a, $NotEnableDisable)
		GUICtrlSetState($Radio7_101b, $NotEnableDisable)
		GUICtrlSetState($Radio7_101c, $NotEnableDisable)
		GUICtrlSetState($Input7_110, $EnableDisable)
		GUICtrlSetState($Input7_110b, $EnableDisable)
		GUICtrlSetState($Input7_111, $EnableDisable)
		GUICtrlSetState($CheckboxShift7_113, $EnableDisable)
		GUICtrlSetState($CheckboxAlt7_113, $EnableDisable)
		GUICtrlSetState($CheckboxCtrl7_113, $EnableDisable)
		GUICtrlSetState($CheckboxWin7_113, $EnableDisable)
		GUICtrlSetState($ComboTouche7_113, $EnableDisable)
		If $cCas = "T" Then
			GUICtrlSendMsg($Edit7_120, 0xCF, 0, 0)
			CouleurControle($Edit7_120, $iScriptEdFontCouleur)
		Else
			ChampModifie($Edit7_120)
		EndIf
		GUICtrlSetState($Checkbox7_121, $EnableDisable)
		If $cCas = "T" Then
			GUICtrlSetState($Button7_125a, $GUI_SHOW)
			If GUICtrlRead($Checkbox7_121) = $GUI_CHECKED Then
				GUICtrlSetData($Button7_125b, "Valider le script")
			Else
				GUICtrlSetData($Button7_125b, "Enregistrer le script")
			EndIf
			GUICtrlSetState($Button7_121, $GUI_HIDE)
			GUICtrlSetState($Button7_120a, $GUI_SHOW)
		Else
			GUICtrlSetState($Button7_125a, $GUI_HIDE)
			GUICtrlSetData($Button7_125b, "Modifier le script")
			If GUICtrlRead($Checkbox7_121) = $GUI_CHECKED Then GUICtrlSetState($Button7_121, $GUI_SHOW)
			GUICtrlSetState($Button7_120a, $GUI_HIDE)
		EndIf
		If $sTypeScript = "A" Then
			$NotEnableDisable = $GUI_DISABLE
			$Hide = $GUI_HIDE
		EndIf
		GUICtrlSetState($ListViewProg, $NotEnableDisable)
		GUICtrlSetState($ListViewProg, $Hide)
		GUICtrlSetState($Button7_101, $NotEnableDisable)
		GUICtrlSetState($Button7_101, $Hide)
		GUICtrlSetState($Button7_102, $NotEnableDisable)
		GUICtrlSetState($Button7_102, $Hide)
		GUICtrlSetState($Button7_103, $NotEnableDisable)
		GUICtrlSetState($Button7_103, $Hide)
		GUICtrlSetState($Button7_104, $NotEnableDisable)
		GUICtrlSetState($Button7_104, $Hide)
		; Bouger/retailler le detail
		If $sTypeScript = "A" Then $cCas = "T"
		Local $iTop = 92
		If $cCas = "F" Then $iTop = 260
		Local $Height = 356
		If $cCas = "F" Then $Height = 188
		ControlMove($FormClipSpiritPref, "", $Label7_110, 30, $iTop)
		ControlMove($FormClipSpiritPref, "", $Input7_110, 101, $iTop -2)
		ControlMove($FormClipSpiritPref, "", $Label7_110b, 565, $iTop)
		ControlMove($FormClipSpiritPref, "", $Input7_110b, 730, $iTop -2)
		ControlMove($FormClipSpiritPref, "", $Label7_111, 30, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $Input7_111, 101, $iTop +25)
		ControlMove($FormClipSpiritPref, "", $Label7_113, 383, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $CheckboxShift7_113, 490, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $CheckboxCtrl7_113, 538, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $CheckboxAlt7_113, 579, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $CheckboxWin7_113, 616, $iTop +27)
		ControlMove($FormClipSpiritPref, "", $ComboTouche7_113, 659, $iTop +25)
		ControlMove($FormClipSpiritPref, "", $Label7_120, 30, $iTop +54)
		ControlMove($FormClipSpiritPref, "", $Edit7_120, 30, $iTop +73, 742, $Height)
	EndIf
EndFunc


Func PeuplerCouleurs($ListView, $sCodes, $sLibelles, $iIndiceItem)
	Local $i
	_GUICtrlListView_BeginUpdate($ListView)
	_GUICtrlListView_DeleteAllItems($ListView)
	For $i = 1 To $sCodes[0]
		GUICtrlCreateListViewItem($sLibelles[$i] & "|" & $sCodes[$i], $ListView)
		CouleurItem($sCodes[$i], -1)
	Next
	_GUICtrlListView_EndUpdate($ListView)
	_GUICtrlListView_SetColumnWidth($ListView, 1, 0)
	_GUICtrlListView_EnsureVisible($ListView, $iIndiceItem)
	_GUICtrlListView_SetItemSelected($ListView, $iIndiceItem)
EndFunc


Func CouleurAjouter()
	Local $i, $iIndChoisi, $iInsert
	If $sCouleursRestantesCodes[0] = 0 Then Return
	$iIndChoisi = ItemSelectionne($ListViewCouleursRestantes)
	If $iIndChoisi < 0 Then $iIndChoisi = 0
	If $iIndChoisi > $sCouleursRestantesCodes[0] Then $iIndChoisi = $sCouleursRestantesCodes[0]
	$iIndChoisi += 1
	$iInsert = ItemSelectionne($ListViewCouleursChoisies)
	If $iInsert < 0 Then $iInsert = 0
	If $iInsert > $sCouleursChoisiesCodes[0] Then $iInsert = $sCouleursChoisiesCodes[0]
	If $sCouleursChoisiesCodes[0] = 0 Then
		$iInsert = 1
	Else
		$iInsert += 2
	EndIf
	; Insrer sous l'item slectionn
	For $i = $sCouleursChoisiesCodes[0] + 1 To $iInsert Step -1
		$sCouleursChoisiesCodes[$i] = $sCouleursChoisiesCodes[$i - 1]
		$sCouleursChoisiesLibelles[$i] = $sCouleursChoisiesLibelles[$i - 1]
	Next
	$sCouleursChoisiesCodes[$iInsert] = $sCouleursRestantesCodes[$iIndChoisi]
	$sCouleursChoisiesLibelles[$iInsert] = $sCouleursRestantesLibelles[$iIndChoisi]
	$sCouleursChoisiesCodes[0] = $sCouleursChoisiesCodes[0] + 1
	$sCouleursChoisiesLibelles[0] = $sCouleursChoisiesLibelles[0] + 1
	PeuplerCouleurs($ListViewCouleursChoisies, $sCouleursChoisiesCodes, $sCouleursChoisiesLibelles, $iInsert - 1)
	; Supprimer l'item
	For $i = $iIndChoisi To $sCouleursRestantesCodes[0] - 1
		$sCouleursRestantesCodes[$i] = $sCouleursRestantesCodes[$i + 1]
		$sCouleursRestantesLibelles[$i] = $sCouleursRestantesLibelles[$i + 1]
	Next
	$sCouleursRestantesCodes[$sCouleursRestantesCodes[0]] = ""
	$sCouleursRestantesLibelles[$sCouleursRestantesCodes[0]] = ""
	$sCouleursRestantesCodes[0] = $sCouleursRestantesCodes[0] - 1
	$sCouleursRestantesLibelles[0] = $sCouleursRestantesLibelles[0] - 1
	_GUICtrlListView_DeleteItem($ListViewCouleursRestantes, $iIndChoisi - 1)
EndFunc

Func CouleurSupprimer()
	Local $i, $iIndChoisi, $dInsensite, $iInsert
	If $sCouleursChoisiesCodes[0] = 0 Then Return
	$iIndChoisi = ItemSelectionne($ListViewCouleursChoisies)
	If $iIndChoisi < 0 Then $iIndChoisi = 0
	If $iIndChoisi > $sCouleursChoisiesCodes[0] Then $iIndChoisi = $sCouleursChoisiesCodes[0]
	$iIndChoisi += 1
	; Classement de cet item dans la liste des couleurs restantes suivant son intensit
	$dInsensite = CouleurIntensite($sCouleursChoisiesCodes[$iIndChoisi])
	$iInsert = $sCouleursRestantesCodes[0] + 1
	For $i = 1 To $sCouleursRestantesCodes[0]
		If $dInsensite > CouleurIntensite($sCouleursRestantesCodes[$i]) Then
			$iInsert = $i
			ExitLoop
		EndIf
	Next
	For $i = $sCouleursRestantesCodes[0] + 1 To $iInsert Step -1
		$sCouleursRestantesCodes[$i] = $sCouleursRestantesCodes[$i - 1]
		$sCouleursRestantesLibelles[$i] = $sCouleursRestantesLibelles[$i - 1]
	Next
	$sCouleursRestantesCodes[$iInsert] = $sCouleursChoisiesCodes[$iIndChoisi]
	$sCouleursRestantesLibelles[$iInsert] = $sCouleursChoisiesLibelles[$iIndChoisi]
	$sCouleursRestantesCodes[0] = $sCouleursRestantesCodes[0] + 1
	$sCouleursRestantesLibelles[0] = $sCouleursRestantesLibelles[0] + 1
	PeuplerCouleurs($ListViewCouleursRestantes, $sCouleursRestantesCodes, $sCouleursRestantesLibelles, $iInsert)
	; Suppression de l'item dans la liste des couleurs choisies
	For $i = $iIndChoisi To $sCouleursChoisiesCodes[0] - 1
		$sCouleursChoisiesCodes[$i] = $sCouleursChoisiesCodes[$i + 1]
		$sCouleursChoisiesLibelles[$i] = $sCouleursChoisiesLibelles[$i + 1]
	Next
	$sCouleursChoisiesCodes[$sCouleursChoisiesCodes[0]] = ""
	$sCouleursChoisiesLibelles[$sCouleursChoisiesCodes[0]] = ""
	$sCouleursChoisiesCodes[0] = $sCouleursChoisiesCodes[0] - 1
	$sCouleursChoisiesLibelles[0] = $sCouleursChoisiesLibelles[0] - 1
	_GUICtrlListView_DeleteItem($ListViewCouleursChoisies, $iIndChoisi - 1)
EndFunc


Func CouleurMonterDescendre($bMonter)
	Local $i, $iIndChoisi, $iGo, $s
	If $sCouleursChoisiesCodes[0] = 0 Then Return
	$iIndChoisi = ItemSelectionne($ListViewCouleursChoisies)
	If $iIndChoisi < 0 Then $iIndChoisi = 0
	If $iIndChoisi > $sCouleursChoisiesCodes[0] Then $iIndChoisi = $sCouleursChoisiesCodes[0]
	$iIndChoisi += 1
	If $bMonter Then
		If $iIndChoisi = 1 Then Return
		$iGo = $iIndChoisi - 1
	Else
		If $iIndChoisi = $sCouleursChoisiesCodes[0] Then Return
		$iGo = $iIndChoisi + 1
	EndIf
	$s = $sCouleursChoisiesCodes[$iIndChoisi]
	$sCouleursChoisiesCodes[$iIndChoisi] = $sCouleursChoisiesCodes[$iGo]
	$sCouleursChoisiesCodes[$iGo] = $s
	$s = $sCouleursChoisiesLibelles[$iIndChoisi]
	$sCouleursChoisiesLibelles[$iIndChoisi] = $sCouleursChoisiesLibelles[$iGo]
	$sCouleursChoisiesLibelles[$iGo] = $s
	PeuplerCouleurs($ListViewCouleursChoisies, $sCouleursChoisiesCodes, $sCouleursChoisiesLibelles, $iGo - 1)
EndFunc


Func ItemSelectionne($ListView)
	Local $ListSelect
	$ListSelect = _GUICtrlListView_GetSelectedIndices($ListView, True)
	If $ListSelect[0] = 1 Then
		Return $ListSelect[1]
	Else
		Return -1
	EndIf
EndFunc

Func ValeurChaineCouleurs()
	Local $i, $s
	If $sCouleursChoisiesCodes[0] > 0 Then $s = $sCouleursChoisiesCodes[1]
	For $i = 2 To $sCouleursChoisiesCodes[0]
		$s &= "|" & $sCouleursChoisiesCodes[$i]
	Next
	Return $s
EndFunc

Func CouleurItem($sColor, $hControlID)
	GUICtrlSetBkColor($hControlID, Dec($sColor))
	If CouleurIntensite($sColor) < 80 Then
		GUICtrlSetColor($hControlID, 0xFFFFFF)
	Else
		GUICtrlSetColor($hControlID, 0x000000)
	EndIf
EndFunc

Func CouleurIntensite($sColor)
	Return (0.299 * Dec(StringLeft($sColor, 2)) + 0.587 * Dec(StringMid($sColor, 3, 2)) + 0.114 * Dec(StringRight($sColor, 2)))
EndFunc

Func EnregistrerToucheActivation()
	Local $sCode = TraduireChampEnCodeTouche($sListToucheToutCode, IndiceComboTouche("1_101"), LireCheckBox("Shift1_101"), LireCheckBox("Ctrl1_101"), LireCheckBox("Alt1_101"), LireCheckBox("Win1_101"))
	Return DbParamMAJTexte("ToucheActivation", $sCode)
EndFunc

Func EnregistrerToucheEditeur()
	Return DbParamMAJTexte("ToucheAfficherEditeur", TraduireChampEnCodeTouche($sListToucheFonctionPlusCode, IndiceComboTouche("1_102")))
EndFunc

Func EnregistrerToucheModifItem()
	Return DbParamMAJTexte("ToucheModifierItem", TraduireChampEnCodeTouche($sListToucheFonctionPlusCode, IndiceComboTouche("1_103")))
EndFunc

Func EnregistrerToucheOnglet()
	Return DbParamMAJTexte("ToucheChangementTab", TraduireChampEnCodeTouche($sListToucheFonctionPlusCode, IndiceComboTouche("1_104")))
EndFunc

Func EnregistrerToucheAide()
	Return DbParamMAJTexte("ToucheAide", TraduireChampEnCodeTouche($sListToucheFonctionPlusCode, IndiceComboTouche("1_105")))
EndFunc

Func EnregistrerModeBackup()
	Local $s
	If GUICtrlRead($Checkbox1_401a) = $GUI_CHECKED Then $s = "+Manual"
	If GUICtrlRead($Checkbox1_401b) = $GUI_CHECKED Then $s &= "+Day"
	If GUICtrlRead($Checkbox1_401c) = $GUI_CHECKED Then $s &= "+Start"
	If $s <> "" Then $s = StringMid($s, 2)
	Return DbParamMAJTexte("BackupMode", $s)
EndFunc

Func EnregistrerToucheColler()
	Local $sCode = TraduireChampEnCodeTouche($sListToucheToutCode, IndiceComboTouche("2_103"), LireCheckBox("Shift2_103"), LireCheckBox("Ctrl2_103"), LireCheckBox("Alt2_103"), LireCheckBox("Win2_103"))
	Return DbParamMAJTexte("ToucheColler", $sCode)
EndFunc

Func EnregistrerChampFormat()
	Local $iIndiceListe = _GUICtrlComboBox_GetCurSel($Combo6_401)
	If ($iIndiceListe >= 0) And ($iIndiceListe < UBound($sListFormatImage)) Then
		Return DbParamMAJTexte("ClipBoardImageFormat", $sListFormatImage[$iIndiceListe])
	Else
		Return False
	EndIf
EndFunc


Func TestNombre($Input, $iMin, $iMax, $sTexte)
	Local $dVal = Number(GUICtrlRead($Input))
	If $iMax = 0 Then
		If $dVal < $iMin Then
			GUISetCursor(2) ; Curseur Classique
			MsgBox(4112, $scMsgErreur, $sTexte & " doit tre suprieur " & $iMin, 0, $FormClipSpiritPref)
			Return False
		Else
			Return True
		EndIf
	Else
		If ($dVal < $iMin) Or ($dVal > $iMax) Then
			GUISetCursor(2) ; Curseur Classique
			MsgBox(4112, $scMsgErreur, $sTexte & " doit tre comprise entre " & $iMin & " et " & $iMax, 0, $FormClipSpiritPref)
			Return False
		Else
			Return True
		EndIf
	EndIf
EndFunc


Func TraduireChampEnCodeTouche($sListCode, $iIndiceListe, $bShift = False, $bCtrl = False, $bAlt = False, $bWin = False)
	Local $sCode = ""
	If $iIndiceListe < 1 Then Return ""
	If $bShift Then $sCode &= "+"
	If $bCtrl Then $sCode &= "^"
	If $bAlt Then $sCode &= "!"
	If $bWin Then $sCode &= "#"
	If ($iIndiceListe >= 0) And ($iIndiceListe < UBound($sListCode)) Then $sCode &= $sListCode[$iIndiceListe]
	Return $sCode
EndFunc


Func LireCheckBox($sNomEtRef)
	Switch Execute("GUICtrlRead($Checkbox" & $sNomEtRef & ")")
	Case $GUI_CHECKED
			Return True
		Case $GUI_UNCHECKED
			Return False
		Case Else
			Return -1
	EndSwitch
EndFunc


Func TraduireCodeToucheEnTousLesChamps($sCodeTouche, $sListCode, ByRef $bShift, ByRef $bCtrl, ByRef $bAlt, ByRef $bWin, ByRef $iIndiceListe)
	Local $i
	$bShift = (StringInStr($sCodeTouche, "+") > 0)
	If $bShift Then $sCodeTouche = StringReplace($sCodeTouche, "+", "")
	$bCtrl = (StringInStr($sCodeTouche, "^") > 0)
	If $bCtrl Then $sCodeTouche = StringReplace($sCodeTouche, "^", "")
	$bAlt = (StringInStr($sCodeTouche, "!") > 0)
	If $bAlt Then $sCodeTouche = StringReplace($sCodeTouche, "!", "")
	$bWin = (StringInStr($sCodeTouche, "#") > 0)
	If $bWin Then $sCodeTouche = StringReplace($sCodeTouche, "#", "")
	$iIndiceListe = TraduireCodeToucheEnUnChamp($sCodeTouche, $sListCode)
EndFunc


Func TraduireCodeToucheEnUnChamp($sCodeTouche, $sListCode)
	Local $i, $iIndiceListe = -1
	For $i = 0 To UBound($sListCode) - 1
		If $sCodeTouche == $sListCode[$i] Then
			$iIndiceListe = $i
			ExitLoop
		EndIf
	Next
	Return $iIndiceListe
EndFunc


;--------------------------------------------------------------------------------------------------
; Fonction positionnant les valeurs des champs type Touche
; Le nom des champs doivent tre sous la forme $CheckboxShiftXXXXX, $CheckboxCtrlXXXXX, $CheckboxAltXXXXX, $CheckboxWinXXXXX, $ComboToucheXXXXX
; ou XXXX est la Rfrence du champs
;
; IN  $sRef   		: Rfrence des champs positionn
;	  $iIndiceListe :  -1 : Pas utilis, 0  X=Indice  positionner
;	  $iShift 		: -1 : Pas utilis, 0=$GUI_UNCHECKED, 1=$GUI_CHECKED
;	  $iCtrl  		: -1 : Pas utilis, 0=$GUI_UNCHECKED, 1=$GUI_CHECKED
;	  $iAlt   		: -1 : Pas utilis, 0=$GUI_UNCHECKED, 1=$GUI_CHECKED
;	  $iWin   		: -1 : Pas utilis, 0=$GUI_UNCHECKED, 1=$GUI_CHECKED
; OUT /
;--------------------------------------------------------------------------------------------------
Func PositionnerChampsTouche($sRef, $iIndiceListe, $iShift = -1 , $iCtrl = -1, $iAlt = -1, $iWin = -1)
	PositionnerCheckBox("Shift" & $sRef, $iShift)
	PositionnerCheckBox("Ctrl" & $sRef, $iCtrl)
	PositionnerCheckBox("Alt" & $sRef, $iAlt)
	PositionnerCheckBox("Win" & $sRef, $iWin)
	If Execute("_GUICtrlComboBox_SetCurSel($ComboTouche" & $sRef & ", $iIndiceListe)") <> $iIndiceListe Then
		GUISetCursor(2) ; Curseur Classique
		MsgBox(4112, $scMsgErreur, "Objet $ComboTouche" & $sRef & " inexistant", 0, $FormClipSpiritPref)
		Exit
	EndIf
EndFunc

Func PositionnerCheckBox($sNomEtRef, $iEtat)
	Local $iR = 1
	Switch $iEtat
		Case 1
			$iR = Execute("GUICtrlSetState($Checkbox" & $sNomEtRef & ", $GUI_CHECKED)")
		Case 0
			$iR = Execute("GUICtrlSetState($Checkbox" & $sNomEtRef & ", $GUI_UNCHECKED)")
	EndSwitch
	If $iR <> 1 Then
		GUISetCursor(2) ; Curseur Classique
		MsgBox(4112, $scMsgErreur, "Objet Checkbox" & $sNomEtRef & " inexistant", 0, $FormClipSpiritPref)
		Exit
	EndIf
EndFunc


Func AlimenterCombo($hCombo, $sList)
	Local $i
	_GUICtrlComboBox_ResetContent($hCombo)
    _GUICtrlComboBox_BeginUpdate($hCombo)
	For $i = 0 To UBound($sList) -1
		_GUICtrlComboBox_AddString($hCombo, $sList[$i])
	Next
    _GUICtrlComboBox_EndUpdate($hCombo)
EndFunc


Func IndiceComboTouche($sRef)
	Local $iInd
	$iInd = Execute("_GUICtrlComboBox_GetCurSel($ComboTouche" & $sRef & ")")
	If $iInd = -1 Then
		GUISetCursor(2) ; Curseur Classique
		MsgBox(4112, $scMsgErreur, "Objet $ComboTouche" & $sRef & " inexistant", 0, $FormClipSpiritPref)
		Exit
	EndIf
	Return $iInd
EndFunc


Func NumVerCourt($sVer)
	Local $i = StringInStr($sVer, ".", 0, 2) - 1
	If $i > 0 Then
		Return StringLeft($sVer, $i)
	Else
		Return $sVer
	EndIf
EndFunc


Func RetourParamParDefaut()
	If MsgBox(8484, $scMsgConfirm, "Vous voulez rinitialiser les prfrences ?", 0, $FormClipSpiritPref) <> 6 Then Return False
	If MsgBox(8484, $scMsgConfirm, "ATTENTION : Toutes vos prfrences seront perdues (sauf les scriptings)." & @CRLF & @CRLF & "Etes-vous sr et certain de vouloir rinitialiser les prfrences de " & $scAppliTitreGeneral & " ?", 0, $FormClipSpiritPref) <> 6 Then Return False
	GUISetCursor(15, 1, $FormClipSpiritPref) ; Curseur WAIT
	DbSupprimerParam()
	GUISetCursor(2) ; Curseur Classique
	RelanceAppli(True)
	Return True
EndFunc



; ===================================================================
; _RefreshSystemTray($nDealy = 1000)
;
; AUTEUR : wraithdu
; WEB    : http://www.autoitscript.com/forum/index.php?showtopic=7404
;
; Removes any dead icons from the notification area.
; Parameters:
;   $nDelay - IN/OPTIONAL - The delay to wait for the notification area to expand with Windows XP's
;       "Hide Inactive Icons" feature (In milliseconds).
; Returns:
;   Sets @error on failure:
;       1 - Tray couldn't be found.
;       2 - DllCall error.
; ===================================================================
Func _RefreshSystemTray($nDelay = 1000)
	; Save Opt settings
    Local $oldMatchMode = Opt("WinTitleMatchMode", 4)
    Local $oldChildMode = Opt("WinSearchChildren", 1)
    Local $error = 0
    Do ; Pseudo loop
        Local $hWnd = WinGetHandle("classname=TrayNotifyWnd")
        If @error Then
            $error = 1
            ExitLoop
        EndIf
        Local $hControl = ControlGetHandle($hWnd, "", "Button1")
		; We're on XP and the Hide Inactive Icons button is there, so expand it
        If $hControl <> "" And ControlCommand($hWnd, "", $hControl, "IsVisible") Then
            ControlClick($hWnd, "", $hControl)
            Sleep($nDelay)
        EndIf
        Local $posStart = MouseGetPos()
        Local $posWin = WinGetPos($hWnd)
        Local $y = $posWin[1]
        While $y < $posWin[3] + $posWin[1]
            Local $x = $posWin[0]
            While $x < $posWin[2] + $posWin[0]
                DllCall("user32.dll", "int", "SetCursorPos", "int", $x, "int", $y)
                If @error Then
                    $error = 2
                    ExitLoop 3; Jump out of While/While/Do
                EndIf
                $x = $x + 8
            WEnd
            $y = $y + 8
        WEnd
        DllCall("user32.dll", "int", "SetCursorPos", "int", $posStart[0], "int", $posStart[1])
		; We're on XP so we need to hide the inactive icons again.
        If $hControl <> "" And ControlCommand($hWnd, "", $hControl, "IsVisible") Then
            ControlClick($hWnd, "", $hControl)
        EndIf
    Until 1
	; Restore Opt settings
    Opt("WinTitleMatchMode", $oldMatchMode)
    Opt("WinSearchChildren", $oldChildMode)
    SetError($error)
EndFunc


Func Quote($sTexte)
	Return StringReplace($sTexte, "'", "''")
EndFunc

Func _IsFocused($hControl)
    Return (ControlGetHandle($FormClipSpiritPref, '', $hControl) = ControlGetHandle($FormClipSpiritPref, '', ControlGetFocus($FormClipSpiritPref)))
EndFunc

Func TabPress()
	Send("^{TAB}")
EndFunc

Func ChampModifie($hControl, $bModifie = False)
	GUICtrlSendMsg($hControl, 0xCF, 1, 0) ; 0xCF=$EM_SETREADONLY
	If $bModifie Then
		GUICtrlSetColor($hControl, 0xFF0000)
	Else
		GUICtrlSetColor($hControl, 0x6D6D6D)
	EndIf
EndFunc


Func CouleurControle($hControl, $iCouleur)
	GUICtrlSetColor($hControl, Number(_ColorGetBlue($iCouleur)) * 256*256 + Number(_ColorGetGreen($iCouleur)) * 256 + Number(_ColorGetRed($iCouleur)))
EndFunc


Func RaccourciAppliCreerSupprimer($bCreer)
	Local $sRep, $iNb = 0, $bRetour
	Local $scFic = "\" & $scAppliTitreGeneral & ".lnk"
	If GUICtrlRead($Checkbox6_501a) = $GUI_CHECKED Then ; Dossier Dmarrage Tous users
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@StartupCommonDir)
		Else
			$bRetour = FileDelete(@StartupCommonDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	If GUICtrlRead($Checkbox6_501b) = $GUI_CHECKED Then ; Racine Menu Tous users
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@StartMenuCommonDir)
		Else
			$bRetour = FileDelete(@StartMenuCommonDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	If GUICtrlRead($Checkbox6_501c) = $GUI_CHECKED Then ; Bureau Tous users
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@DesktopCommonDir)
		Else
			$bRetour = FileDelete(@DesktopCommonDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	If GUICtrlRead($Checkbox6_502a) = $GUI_CHECKED Then ; Dossier Dmarrage Perso
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@StartupDir)
		Else
			$bRetour = FileDelete(@StartupDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	If GUICtrlRead($Checkbox6_502b) = $GUI_CHECKED Then ; Racine Menu Perso
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@StartMenuDir)
		Else
			$bRetour = FileDelete(@StartMenuDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	If GUICtrlRead($Checkbox6_502c) = $GUI_CHECKED Then ; Bureau Perso
		If $bCreer Then
			$bRetour = RaccourciAppliCreer(@DesktopDir)
		Else
			$bRetour = FileDelete(@DesktopDir & $scFic)
		EndIf
		If $bRetour Then $iNb +=1
	EndIf
	; Autre dossier
	$sRep = GUICtrlRead($Input6_501)
	If $sRep <> "" Then
		If DriveStatus($sRep) <> "READY" Then
			If Not $bCreer Then
				MsgBox(4112, $scMsgErreur, "Le dossier" & @CRLF & $sRep & @CRLF & "n'existe pas", 0, $FormClipSpiritPref)
				$sRep = ""
			Else
				If DirCreate($sRep) <> 1 Then
					MsgBox(4112, $scMsgErreur, "Le dossier" & @CRLF & $sRep & @CRLF & "n'existe pas et ne peut pas tre cr", 0, $FormClipSpiritPref)
					$sRep = ""
				EndIf
			EndIf
		EndIf
		If $sRep <> "" Then
			If $bCreer Then
				$bRetour = RaccourciAppliCreer($sRep)
			Else
				$bRetour = FileDelete($sRep & $scFic)
			EndIf
			If $bRetour Then $iNb +=1
		EndIf
	EndIf
	Switch $iNb
		Case 0
			If $bCreer Then
				MsgBox(4160, $scMsgInfo, "Aucun raccourci n'a t cr", 0, $FormClipSpiritPref)
			Else
				MsgBox(4160, $scMsgInfo, "Aucun raccourci n'a t supprim", 0, $FormClipSpiritPref)
			EndIf
		Case 1
			If $bCreer Then
				MsgBox(4160, $scMsgInfo, "Un raccourci a t cr", 0, $FormClipSpiritPref)
			Else
				MsgBox(4160, $scMsgInfo, "Un raccourci a t supprim", 0, $FormClipSpiritPref)
			EndIf
		Case Else
			If $bCreer Then
				MsgBox(4160, $scMsgInfo, $iNb & " raccourcis ont t crs", 0, $FormClipSpiritPref)
			Else
				MsgBox(4160, $scMsgInfo, $iNb & " raccourcis ont t supprims", 0, $FormClipSpiritPref)
			EndIf
	EndSwitch
EndFunc

Func RaccourciAppliCreer($sRep)
	If StringRight($sRep, 1) = "\" Then $sRep = StringLeft($sRep, StringLen($sRep) -1)
	Return FileCreateShortcut(@ScriptDir & "\" & $scAppliTitreGeneral & ".exe" , $sRep & "\" & $scAppliTitreGeneral & ".lnk", @ScriptDir, "", "Raccourci vers ClipSpirit By Ahbadiane", @ScriptDir & "\" & $scAppliTitreGeneral & ".exe")
EndFunc
