#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=ClipSpirit.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Module principal
#AutoIt3Wrapper_Res_Description=ClipSpirit - L'esprit de votre presse-papier
#AutoIt3Wrapper_Res_Fileversion=1.2.0.10
#AutoIt3Wrapper_Res_LegalCopyright=By Ahbadiane
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ---------------------------------------------------------------------------

	ClipSpirit - Gestionnaire de presse-papier
	Script AutoIt Version 3.3.6.1

	Auteur : Ahbadiane
	Juin 2010 - Octobre 2011

	EN CHANTIER :

	BUG :

	A FAIRE :

FAIT :

#ce ---------------------------------------------------------------------------

#Region - Dclaration
#include <ClipBoard.au3>
#include <GDIPlus.au3>
#include <GuiComboBox.au3>
#include <GuiListView.au3>
#include <Process.au3>
#include <String.au3>
#include <Timers.au3>
#include <WindowsConstants.au3>
#include "ClipSpiritLib.au3"
#include "ClipSpiritDB.au3"
#include "ClipSpiritRes.au3"
#include "ClipSpiritExec.au3"


AutoItSetOption("MustDeclareVars", 1)
Opt("WinTitleMatchMode", 3)     ;1=start, 2=subStr, 3=exact, 4=advanced, -1 to -4=Nocase
Opt("GUIDataSeparatorChar", $cCarSep)


; Titre de la fentre
Global $sFenetreTitre = $scAppliTitreGeneral & "  v" & _NumVerCourt($scVersion)
If Not @Compiled Then $sFenetreTitre &= " Test"
$sFenetreTitre &= " " & $scAuteur


;----- Base de donnes --------------------------------------------------------
If DbOuvrir($scProgPrincipal) = "" Then Exit


#EndRegion - Dclaration


#Region - Dfinition Variables
;------ Fentre Principale ----------------------------------------------------
; Hauteur d'un onglet
Global Const $icOngletHauteur = 28
; icones
Global Const $icIconesPlaceHauteur = 28
Global Const $icMenuHauteur = 20
Global Const $icIconeY0 = 2
Global Const $icPoubelleX0 = 2
Global Const $icNouveauX0 = 30
Global Const $icFavorisX0 = 58
; Largeur & Hauteur de la fentre
Global Const $icFenetreHauteur = _Min(_Max($icFenetreHauteurMin, DbParamLireNum("FenetreHauteurPixel", $icFenetreHauteurMin)), @DesktopHeight) ; Rgle  mettre en concordance avec ClipSpirit-Pref.au3
Global Const $iFenetreLargeurModeListe = _Min(_Max($icFenetreLargeListeMin, DbParamLireNum("FenetreLargeurListePixel", $icFenetreLargeListeMin)), @DesktopWidth) ; Rgle  mettre en concordance avec ClipSpirit-Pref.au3
Global Const $icFenetreLargeurModeEditeur = _Min(_Max($icFenetreLargeEditeurMin, DbParamLireNum("FenetreLargeurEditeurPixel", $icFenetreLargeEditeurMin)), @DesktopWidth) ; Rgle  mettre en concordance avec ClipSpirit-Pref.au3
Global Const $icFenetreLargeurModeListeEtEditeur = $iFenetreLargeurModeListe + $icFenetreLargeurModeEditeur
Global Const $icEditeurX0 = $iFenetreLargeurModeListe +8
Global Const $icEditeurY0 = $icIconesPlaceHauteur +22
; Delta Vertical des lments de l'diteur
Global Const $icEditeurY1 = $icEditeurY0 + $icFenetreHauteur - $icFenetreHauteurMin
; Hauteur des lments de slection
Global Const $icSelectHauteur = 110
; Tops et Hauteurs de la ListViewSelection
Global Const $icSelectLWTop1 = $icIconesPlaceHauteur + $icOngletHauteur + $icSelectHauteur
Global Const $icSelectLWTop2 = $icIconesPlaceHauteur + $icOngletHauteur +30
Global Const $icSelectLWHauteur1 = $icFenetreHauteur - $icIconesPlaceHauteur - $icOngletHauteur - $icSelectHauteur - $icMenuHauteur -4
Global Const $icSelectLWHauteur2 = $icFenetreHauteur - $icIconesPlaceHauteur - $icOngletHauteur - $icSelectHauteur - $icMenuHauteur -34 + $icSelectHauteur
Global $bSelectionPlusAffichee = False
; Font et taille de la police des onglets
Global $scOngletFont = "Verdana"
Global $icOngletFontTaille = 10
; Titre et rfrence des onglets
Global Const $scOngletTitre[4] = [DbParamLireTexte("TitreOngletTexte", "Texte"), DbParamLireTexte("TitreOngletFavoris", "Favoris"), DbParamLireTexte("TitreOngletSelection", "Slection"), DbParamLireTexte("TitreOngletImage", "Image")]
Global Const $icOngletTexte = 0
Global Const $icOngletFavoris = 1
Global Const $icOngletSelection = 2
Global Const $icOngletImage = 3
; Fonction Cherche/Remplace
Global $iCRNbRecherche, $iCRNbRemplace, $iCRRecherche, $iCRRemplace, $iCRType =1
Global Const $scCRLibBouton = "Remplacer"
Global $iListCRRecherche = 3
Global $sListCRRecherche[$iListCRRecherche] = ["Tabulation", "Saut de ligne", "Espace"]
Global $iListCRRemplace = 4
Global $sListCRRemplace[$iListCRRemplace] = ["Rien", "Tabulation", "Saut de ligne", "Espace"]
; Choix de tri de la slection
Global Const $sListeSelectTri[12] = ["Tri comme les listes", "Tri inverse des listes", "Tri par Date d'utilisation Dcroissante", "Tri par Date d'utilisation Croissante", "Tri par Titre Croissant", "Tri par Titre Dcroissant", "Tri par Commentaire Croissant", "Tri par Commentaire Dcroissant", "Tri par Provenance Croissant", "Tri par Provenance Dcroissant", "Tri par Contenu du Presse-Papier Croissant", "Tri par Contenu du Presse-Papier Dcroissant"]
; Choix du type d'info
Global Const $sListeSelectInfo[4] = ["Cherche Texte et Favoris", "Cherche Texte uniquement", "Cherche Favoris uniquement", "Uniquement avec raccourci"]
; Touche de raccourcis des items
Global Const $sListRaccourciLibelle[79] = ["Aucun", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "", "", "", "", "", "(", ")", "'", '"', "_", "-", "*", "/", "=", ",", ".", ";", "", "$", "", "%", "?", "", "&", "F1"  , "F2"  , "F3"  , "F4"  , "F5"  , "F6"  , "F7"  , "F8"  , "F9"  , "F10"  , "F11"  , "F12"  , "Flche Droite", "Flche Gauche", "Flche Haut", "Flche Bas", "Page Prcdente", "Page Suivante", "Page Accueil", "Page Finale", "Espace" , "Suppr", "Inser", "Echap", "Pause" , "Impression Ecran", "Tabulation", "Retour Arrire"]
Global Const $sListRaccourciCode[79]    = [""     , "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "", "", "", "", "", "(", ")", "'", '"', "_", "-", "*", "/", "=", ",", ".", ";", "", "$", "", "%", "?", "", "&", "{F1}", "{F2}", "{F3}", "{F4}", "{F5}", "{F6}", "{F7}", "{F8}", "{F9}", "{F10}", "{F11}", "{F12}", "{RIGHT}"      , "{LEFT}"       , "{UP}"       , "{DOWN}"    , "{PGUP}"         , "{PGDN}"       , "{HOME}"      , "{END}"      , "{SPACE}", "{DEL}", "{INS}", "{ESC}", "{PAUSE}", "{PRINTSCREEN}"  , "{TAB}"     , "{BS}"          ]


;----- Variables Gnrales Diverses -------------------------------------------
; Delta entre position du curseur et la fentre
Global Const $icEcartFenetreCurseur = 20
; Flag Appli/Fenetre Affiche
Global $bAppliAffichee = False
; Flag Appli Mode Edtieur
Global $bEditeurEstAffiche = False
; Nombre de caractres maxi du titre
Global Const $icLongMaxTitre = 50  ; Rgle  mettre en concordance avec ClipSpiritExec.au2
; Item Actif
Global $iItemActif = 0, $iItemActifOld = -1
; Item survol par la souris
Global $aItemSurvoleInfo, $iItemSurvoleInit, $iItemSurvole = -1, $bItemSurvoleTip = False
; Item Drag (Drag&Drop)
Global $bDebutDrag = False
Global $iItemDrag = -1
; Tab actif
Global $iTabActif, $iTabActifOld = -1
; Flag Mise  jour du clipboard
Global $bMajClipBoard = False
; Flag Edition item en cours
Global $iItemEnCoursEdition = 0 ; 0=Non, 1=Item modifi, 2=Nouvelle item (cration)
; Souris
Global $iGetPos[4], $iGetPosX = -1, $iGetPosY = -1
; ID des messages Windows
Global $idMsg
; Variables diverses
Global $hNext
; Handle de la listview Active
Global $hListViewActive
; Controle qui  la focus dans la fentre
Global $sFenetreControlFocus
; Editeur de Texte a le focus
Global $bEditTexteFocus = False
; Surveiller le presse-papier
Global $bSurveillerPressePapier = True
; Double clic effectu
Global $bDoubleClicItem = False
; Cles de Backup
Global Const $sCleBackupTime = "Log-Backup-Time"
Global Const $sCleBackupInfo = "Log-Backup-Info"
; Handle de la Dll user32 utilis par _IsPressed
Global $hDllUser32
; Valeur de PrpPlus dans diteur
Global $sValPrpPlus, $sValPrpPlusOld
; Boucle d'attente avant lancement des actions (backup, Synchro ...)
Global $iWaitAction
; Variables temporaires
Global $iTemp, $sTab2DTemp

#EndRegion - Dfinition Variables


#Region - Initialisation

;----- Une seule instance -----------------------------------------------------
If _Singleton($sFenetreTitre,1) = 0 Then
	MsgBox(4144, $scMsgErreur, "L'application est dj lance." & @CRLF & "Rechercher l'icne  ct de votre pendule en bas  droite.")
	Exit
EndIf


;----- Variables de paramtrages (prfrences) mmorises dans la base de donnes
Global $sFenetreTop = DbParamLireBoolean("FenetreTop", True)
Global $bFermerSortir = DbParamLireBoolean("FermerSortir", False)
Global $bEscSortir = DbParamLireBoolean("EscSortir", False)
Global $bFermerEditeurAppliMasquee = DbParamLireBoolean("FermerEditeurAppliMasquee", True)
Global $bFermerEditeurPerteFocus = DbParamLireBoolean("FermerEditeurPerteFocus", False)
Global $bItemTexteChoisiPasseEnPremier = DbParamLireBoolean("ItemTexteChoisiPasseEnPremier", True)
Global $bItemFavorisChoisiPasseEnPremier = DbParamLireBoolean("ItemFavorisChoisiPasseEnPremier", False)
Global $bItemImageChoisiPasseEnPremier = DbParamLireBoolean("ItemImageChoisiPasseEnPremier", True)
Global $bItemSuppSiDeplacerFavoris = DbParamLireBoolean("ItemSuppSiDeplacerFavoris", True)
Global $bMultiSelectionItems = DbParamLireBoolean("MultiSelectionItems", True)
Global $bActiverListeTexteInsert = DbParamLireBoolean("ActiverListeTexteInsert", True)
Global $bActiverListeImageInsert = DbParamLireBoolean("ActiverListeImageInsert", True)
Global $bDeplacerFenetrePresCurseur = DbParamLireBoolean("DeplacerFenetrePresCurseur", True)
Global $iPauseAvantSendV = DbParamLireNum("PauseAvantSendV", 100)
Global $iPauseApresSendV = DbParamLireNum("PauseApresSendV", 0)
Global $iPauseApresAppuiTouche = DbParamLireNum("PauseApresAppuiTouche", 200)
Global $sToucheAfficherEditeur = DbParamLireTexte("ToucheAfficherEditeur", "70") ; Touche F1
Global $sToucheModifierItem = DbParamLireTexte("ToucheModifierItem", "71") ; Touche F2
Global $sToucheChangementTab = DbParamLireTexte("ToucheChangementTab", "72") ; Touche F3
Global $sToucheAide = DbParamLireTexte("ToucheAide", "7B") ; Touche F12
Global $bEditeurUtiliserTab = DbParamLireBoolean("EditeurUtiliserTab", False)
Global $sCaracteresAjoutesMultiSelectItems = ConvertirCarAjout(DbParamLireTexte("CaracteresAjoutesMultiSelectItems", "CRLF"))
Global $iNbMaxItemTexte = DbParamLireNum("NbMaxItemTexte", 200)
Global $iNbMaxItemImage = DbParamLireNum("NbMaxItemImage", 20)
Global $bAffichagerItemSurvole = DbParamLireBoolean("AffichagerItemSurvole", True)
Global $iLapsTempsAvantAffichageItemSurvole = DbParamLireNum("LapsTempsAvantAffichageItemSurvole", 500)
Global $sBackupRepertoire = DbParamLireTexte("BackupRepertoire", $scAppliTitreGeneral & "-Backup")
Global $sBackupMode = DbParamLireTexte("BackupMode", "Start+Manual") ; "Start", "Manual", "", "Day"
Global $iBackupMaxNbCopies = DbParamLireNum("BackupMaxNbCopies", 10)
Global $bConfirmSuppTexteMono = DbParamLireBoolean("ConfirmSuppTexteMono", False)
Global $bConfirmSuppTexteMulti = DbParamLireBoolean("ConfirmSuppTexteMulti", True)
Global $bConfirmSuppFavorisMono = DbParamLireBoolean("ConfirmSuppFavorisMono", True)
Global $bConfirmSuppFavorisMulti = DbParamLireBoolean("ConfirmSuppFavorisMulti", True)
Global $bConfirmSuppSelectMono = DbParamLireBoolean("ConfirmSuppSelectMono", True)
Global $bConfirmSuppSelectMulti = DbParamLireBoolean("ConfirmSuppSelectMulti", True)
Global $bConfirmSuppImageMono = DbParamLireBoolean("ConfirmSuppImageMono", False)
Global $sClipBoardImageFormat  = DbParamLireTexte("ClipBoardImageFormat", "JPG")
Global $iVignetteLargeur = DbParamLireNum("VignetteLargeur", 224)
Global $iVignetteHauteur = DbParamLireNum("VignetteHauteur", 126)
Global $sToucheActivation = DbParamLireTexte("ToucheActivation", "!c")
Global $sToucheColler = DbParamLireTexte("ToucheColler", "!g")
Global $sChaineCouleur = DbParamLireTexte("ChaineCouleur", "FFFFFF|FEE347|7FFF00|C60800|096A09|120D16")
Global $bSynchronisationManuel = DbParamLireBoolean("SynchronisationManuel", False)
Global $bSynchronisationTexte = DbParamLireBoolean("SynchronisationTexte", False)
Global $bSynchronisationImage = DbParamLireBoolean("SynchronisationImage", False)
Global $bSynchronisationScript = DbParamLireBoolean("SynchronisationScript", False)
Global $sSynchroProchaine = DbParamLireTexte("SynchroProchaine", "")
Global $bPowerManagementEvent = DbParamLireBoolean("PowerManagementEvent", False)


;----- TrayIcon ---------------------------------------------------------------
Opt("TrayOnEventMode", 1)
Opt("TrayAutoPause", 0)
Opt("TrayMenuMode", 3)
Global $hTrayPressePapier = TrayCreateItem("Ouvrir " & $scAppliTitreGeneral)
TrayItemSetOnEvent($hTrayPressePapier, "AppliAfficherMasquer")
Global $hTrayEcouter = TrayCreateItem("Ne plus surveiller le presse-papier")
TrayItemSetOnEvent($hTrayEcouter, "SurveillerOuPasPressePapier")
TrayCreateItem("")
Global $hTrayPref = TrayCreateItem("Prfrences")
TrayItemSetOnEvent($hTrayPref, "AccesPreferences")
Global $hTraySynchro
If DbParamLireBoolean("SynchroTrayIcon", $bSynchronisationManuel) Then
	$hTraySynchro = TrayCreateItem("Synchroniser les donnes")
	TrayItemSetOnEvent($hTraySynchro, "TrayLancerSynchro")
EndIf
Global $hTrayAide = TrayCreateItem("Aide")
TrayItemSetOnEvent($hTrayAide, "AccesAide")
TrayCreateItem("")
Global $hTrayQuitter = TrayCreateItem("Quitter " & $scAppliTitreGeneral)
TrayItemSetOnEvent($hTrayQuitter, "ExitClipSpirit")
TraySetToolTip($scAppliTitreGeneral & " " & $scAuteur & " v" & _NumVerCourt($scVersion))
TraySetOnEvent(-8, "AppliAfficherMasquer") ; -$TRAY_EVENT_PRIMARYUP
TraySetClick(16)
TraySetState()

#EndRegion - Initialisation


#Region - Interface

Global $FormClipSpirit = GUICreate($sFenetreTitre, $icFenetreLargeurModeListeEtEditeur, $icFenetreHauteur, 426, 248, -1, $WS_EX_TOOLWINDOW)
; Icones
Global $PicNouveau = GUICtrlCreatePic(_Ressource("Nouveau.jpg"), $icNouveauX0, $icIconeY0, 24, 24, BitOR(0x0100, $WS_GROUP, $WS_CLIPSIBLINGS)) ;$SS_NOTIFY(0x0100)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $PicPoubelle = GUICtrlCreatePic(_Ressource("Poubelle0.jpg"), $icPoubelleX0, $icIconeY0, 24, 24, BitOR(0x0100, $WS_GROUP, $WS_CLIPSIBLINGS)) ;$SS_NOTIFY(0x0100)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $PicFavoris = GUICtrlCreatePic(_Ressource("Favoris0.jpg"), $icFavorisX0, $icIconeY0, 24, 24, BitOR(0x0100, $WS_GROUP, $WS_CLIPSIBLINGS)) ;$SS_NOTIFY(0x0100)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $PicEditeur = GUICtrlCreatePic(_Ressource("Editeur" & Number($bEditeurEstAffiche) & ".jpg"), $iFenetreLargeurModeListe -30, $icIconeY0, 24, 24, BitOR(0x0100, $WS_GROUP, $WS_CLIPSIBLINGS)) ;$SS_NOTIFY(0x0100)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
; Tab
Global $TabClipSpirit = GUICtrlCreateTab(1, $icIconesPlaceHauteur, $iFenetreLargeurModeListe, $icFenetreHauteur - $icIconesPlaceHauteur - $icMenuHauteur)
GUICtrlSetFont(-1, $icOngletFontTaille, 400, 0, $scOngletFont)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $iMultiSelect = $LVS_SINGLESEL
If $bMultiSelectionItems Then $iMultiSelect = 0
; Onglet Texte
Global $TabSheetTexte = GUICtrlCreateTabItem($scOngletTitre[0])
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $ListViewTexte = GUICtrlCreateListView("", 3, $icIconesPlaceHauteur + $icOngletHauteur, $iFenetreLargeurModeListe -6 , $icFenetreHauteur - $icIconesPlaceHauteur - $icMenuHauteur - $icOngletHauteur -4, BitOR($LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS, $iMultiSelect), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetFont(-1, 10, 400)
_GUICtrlListView_AddColumn($ListViewTexte, "", $iFenetreLargeurModeListe -28)
_GUICtrlListView_AddColumn($ListViewTexte, "", 0)
; Onglet Favoris
Global $TabSheetFavoris = GUICtrlCreateTabItem($scOngletTitre[1])
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $ListViewFavoris = GUICtrlCreateListView("", 3, $icIconesPlaceHauteur + $icOngletHauteur, $iFenetreLargeurModeListe -6 , $icFenetreHauteur - $icIconesPlaceHauteur - $icMenuHauteur - $icOngletHauteur -4, BitOR($LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS, $iMultiSelect), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetFont(-1, 10, 400)
_GUICtrlListView_AddColumn($ListViewFavoris, "", $iFenetreLargeurModeListe -28)
_GUICtrlListView_AddColumn($ListViewFavoris, "", 0)
; Onglet Slection
Global $TabSheetSelection = GUICtrlCreateTabItem($scOngletTitre[2])
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $LabelTSelectTexte = GUICtrlCreateLabel("Texte", 4, $icIconesPlaceHauteur + $icOngletHauteur +4, 31, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputSelectTexte = GUICtrlCreateInput("", 34, $icIconesPlaceHauteur + $icOngletHauteur +2, $iFenetreLargeurModeListe -70, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $ButtonSelectPlus = GUICtrlCreateButton("+", $iFenetreLargeurModeListe -30, $icIconesPlaceHauteur + $icOngletHauteur +3, 19, 19)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $CheckboxSelectPrp = GUICtrlCreateCheckbox("Texte", 8, $icIconesPlaceHauteur + $icOngletHauteur +30, 46, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_CHECKED + $GUI_HIDE)
Global $CheckboxSelectTitre = GUICtrlCreateCheckbox("Titre", 68,  $icIconesPlaceHauteur + $icOngletHauteur +30, 41, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_CHECKED + $GUI_HIDE)
Global $CheckboxSelectCommentaire = GUICtrlCreateCheckbox("Comm.", 120,  $icIconesPlaceHauteur + $icOngletHauteur +30, 45, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_CHECKED + $GUI_HIDE)
Global $CheckboxSelectProvenance = GUICtrlCreateCheckbox("Prove.", 176,  $icIconesPlaceHauteur + $icOngletHauteur +30, 49, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_CHECKED + $GUI_HIDE)
Global $ComboSelectTri = GUICtrlCreateCombo($sListeSelectTri[0], 6, $icIconesPlaceHauteur + $icOngletHauteur +52, $iFenetreLargeurModeListe -17, 25,  BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
For $iTemp = 1 To UBound($sListeSelectTri) -1
	GUICtrlSetData(-1, $sListeSelectTri[$iTemp])
Next
Global $ComboSelectInfo = GUICtrlCreateCombo($sListeSelectInfo[0], 6, $icIconesPlaceHauteur + $icOngletHauteur +82, $iFenetreLargeurModeListe -56, 25,  BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
For $iTemp = 1 To UBound($sListeSelectInfo) -1
	GUICtrlSetData(-1, $sListeSelectInfo[$iTemp])
Next
Global $ButtonSelect = GUICtrlCreateButton("Go", $iFenetreLargeurModeListe -45, $icIconesPlaceHauteur + $icOngletHauteur +80, 35, 25)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
Global $ListViewSelection = GUICtrlCreateListView("", 3, $icSelectLWTop2, $iFenetreLargeurModeListe -6, $icSelectLWHauteur2, BitOR($LVS_NOCOLUMNHEADER, $LVS_SHOWSELALWAYS, $iMultiSelect), BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetFont(-1, 10, 400)
_GUICtrlListView_AddColumn($ListViewSelection, "", $iFenetreLargeurModeListe -28)
_GUICtrlListView_AddColumn($ListViewSelection, "", 0)
; Onglet Image
If $iNbMaxItemImage = 0 Then
	Global $TabSheetImage = $TabSheetTexte
	Global $ListViewImage = 1000000
Else
	Global $TabSheetImage = GUICtrlCreateTabItem($scOngletTitre[3])
	GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
	Global $ListViewImage = GUICtrlCreateListView("", 3, $icIconesPlaceHauteur + $icOngletHauteur, $iVignetteLargeur +30 , $icFenetreHauteur - $icIconesPlaceHauteur - $icMenuHauteur - $icOngletHauteur -4, -1, BitOr($WS_EX_CLIENTEDGE, $LVS_EX_DOUBLEBUFFER))
	_GUICtrlListView_SetView($ListviewImage, 1)
	_GUICtrlListView_SetIconSpacing($ListviewImage, $iVignetteLargeur, $iVignetteHauteur-120)
EndIf
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlCreateTabItem("")
; ------------ Partie Editeur -----------------------------
Global $GroupEd = GUICtrlCreateGroup(" Dtail de l'item  ", $icEditeurX0 -2, $icEditeurY0 -18, $icFenetreLargeurModeEditeur -16, $icFenetreHauteur - $icEditeurY0 - $icMenuHauteur +12)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetFont(-1, $icOngletFontTaille, 400, 0, $scOngletFont)
Global $LabelEdTitre = GUICtrlCreateLabel("Titre", $icEditeurX0 +8, $icEditeurY0 +12, 46, 19)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $LabelEdEtoile = GUICtrlCreateLabel("", $icEditeurX0 +42, $icEditeurY0 +8, 10, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetFont(-1, 22, 400)
Global $InputEdTitre = GUICtrlCreateInput("", $icEditeurX0 +75, $icEditeurY0 +9, $icFenetreLargeurModeEditeur -116, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetLimit(-1, $icLongMaxTitre)
_ChampModifiable(-1, False)
If $sChaineCouleur = "" Then
	$iTemp = 0
Else
	$iTemp = 20
EndIf
Global $InputEdCouleurNum = GUICtrlCreateInput("", $icEditeurX0 + $icFenetreLargeurModeEditeur -41, $icEditeurY0 +9, $iTemp, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
Global $UpDownEdCouleurNum = GUICtrlCreateUpdown($InputEdCouleurNum)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $LabelEdTexte = GUICtrlCreateLabel("Texte du presse-papier", $icEditeurX0 +8, $icEditeurY0 +35, 112, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $EditEdTexte = GUICtrlCreateEdit("", $icEditeurX0 +7, $icEditeurY0 +53, $icFenetreLargeurModeEditeur -28, 79 + $icEditeurY1 - $icEditeurY0)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $LabelEdCommentaire = GUICtrlCreateLabel("Commentaire", $icEditeurX0 +8, $icEditeurY1 +142, 65, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputEdCommentaire = GUICtrlCreateInput("", $icEditeurX0 +75, $icEditeurY1 +139, $icFenetreLargeurModeEditeur -175, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetLimit(-1, $icLongMaxCommentaire)
_ChampModifiable(-1, False)
Global $ButtonEdRemplacer = GUICtrlCreateButton($scCRLibBouton, $icEditeurX0 + $icFenetreLargeurModeEditeur -96, $icEditeurY1 +138, 75, 23)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
Global $LabelEdRaccourci = GUICtrlCreateLabel("Raccourci", $icEditeurX0 +8, $icEditeurY1 +166, 62, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $CheckboxRaccourciShift = GUICtrlCreateCheckbox("Shift", $icEditeurX0 +76, $icEditeurY1 +166, 42, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $CheckboxRaccourciCtrl = GUICtrlCreateCheckbox("Ctrl", $icEditeurX0 +125, $icEditeurY1 +166, 36, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $CheckboxRaccourciAlt = GUICtrlCreateCheckbox("Alt", $icEditeurX0 +168, $icEditeurY1 +166, 32, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $CheckboxRaccourciWin = GUICtrlCreateCheckbox("Win", $icEditeurX0 +208, $icEditeurY1 +166, 38, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $ComboRaccourci = GUICtrlCreateCombo("", $icEditeurX0 +255, $icEditeurY1 +162, 113, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_DISABLE)
Global $LabelEdProvenance = GUICtrlCreateLabel("Provenance", $icEditeurX0 +8, $icEditeurY1 +190, 62, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputEdProvenance = GUICtrlCreateInput("", $icEditeurX0 +75, $icEditeurY1 +187, $icFenetreLargeurModeEditeur -96, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
_ChampModifiable(-1, False)
Global $LabelEdCree = GUICtrlCreateLabel("Cr le", $icEditeurX0 +8, $icEditeurY1 +214, 37, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputEdCree = GUICtrlCreateInput("", $icEditeurX0 +75, $icEditeurY1 +211, 90, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
_ChampModifiable(-1, False)
Global $LabelEdModifie = GUICtrlCreateLabel("Modifi", $icEditeurX0 +170, $icEditeurY1 +214, 34, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputEdModifie = GUICtrlCreateInput("", $icEditeurX0 +206, $icEditeurY1 +211, 90, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
_ChampModifiable(-1, False)
Global $LabelEdModifie = GUICtrlCreateLabel("Utilis", $icEditeurX0 +301, $icEditeurY1 +214, 28, 17)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $InputEdUtilise = GUICtrlCreateInput("", $icEditeurX0 +331, $icEditeurY1 +211, 90, 21)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
_ChampModifiable(-1, False)
Global $ButtonEdEdiValider = GUICtrlCreateButton("Modifier", $icEditeurX0 + $icFenetreLargeurModeEditeur -96, $icEditeurY1 +240, 75, 25)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
Global $ButtonEdEnregistrer = GUICtrlCreateButton("Enregistrer", $icEditeurX0 + $icFenetreLargeurModeEditeur -180, $icEditeurY1 +240, 75, 25)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
Global $ButtonEdAbandonner = GUICtrlCreateButton("Abandonner", $icEditeurX0 + $icFenetreLargeurModeEditeur -264, $icEditeurY1 +240, 75, 25)
GUICtrlSetResizing(-1, $GUI_DOCKWIDTH + $GUI_DOCKLEFT)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlCreateGroup("", -99, -99, 1, 1)
; ------------ Menu ---------------------------------------
Global $MenuFichier = GUICtrlCreateMenu("Fichier")
Global $MenuFicCompacter = GUICtrlCreateMenuItem("Compacter les donnes", $MenuFichier)
Global $MenuFicBackuper = $iNoMenu
If StringInStr($sBackupMode, "Manual") > 0 Then $MenuFicBackuper = GUICtrlCreateMenuItem("Sauvegarder les donnes", $MenuFichier)
Global $MenuFicSynchoniser = $iNoMenu
If $bSynchronisationManuel Then $MenuFicSynchoniser = GUICtrlCreateMenuItem("Synchroniser les donnes", $MenuFichier)
GUICtrlCreateMenuItem("", $MenuFichier)
Global $MenuFicMasquer = GUICtrlCreateMenuItem("Masquer", $MenuFichier)
Global $MenuFicQuitter = GUICtrlCreateMenuItem("Quitter" & @TAB & "Alt-F4", $MenuFichier)
Global $MenuItem = GUICtrlCreateMenu("Item")
Global $MenuItemVoirEditeur = GUICtrlCreateMenuItem("Voir le dtail", $MenuItem)
GUICtrlSetState($MenuItemVoirEditeur, _CheckedUnchecked($bEditeurEstAffiche))
Global $MenuItemModifier = GUICtrlCreateMenuItem("Modifier l'item", $MenuItem)
GUICtrlCreateMenuItem("", $MenuItemModifier)
Global $MenuItemPasserFenetre = GUICtrlCreateMenuItem("Passer le texte dans votre application", $MenuItem)
Global $MenuItemPasserPrp = GUICtrlCreateMenuItem("Mettre simplement dans le presse-papier", $MenuItem)
GUICtrlCreateMenuItem("", $MenuItem)
Global $MenuItemLirePrp = GUICtrlCreateMenuItem("Lire le presse-papier", $MenuItem)
GUICtrlCreateMenuItem("", $MenuItem)
Global $MenuItemNouveau = GUICtrlCreateMenuItem("Nouvel item", $MenuItem)
Global $MenuItemSupprimer = GUICtrlCreateMenuItem("Supprimer l'item", $MenuItem)
Global $MenuItemFavoris = GUICtrlCreateMenuItem("Classer l'item en favoris", $MenuItem)
Global $MenuAction = GUICtrlCreateMenu("Actions")
Global $MenuActionInternet = GUICtrlCreateMenuItem("Ouvrir les liens Internet des items slectionns", $MenuAction)
Global $MenuActionLienFichier = GUICtrlCreateMenuItem("Copier les liens fichiers dans le pressse-papier", $MenuAction)
Global $MenuActionReunir = GUICtrlCreateMenuItem("Runir les items slectionns", $MenuAction)
If Not $bMultiSelectionItems Then GUICtrlSetState($MenuActionReunir, $GUI_DISABLE)
Global $MenuActionSeparer = GUICtrlCreateMenuItem("Sparer l'item en autant d'items que de lignes", $MenuAction)
$sTab2DTemp = DbScriptListeMenu("T")
If $sTab2DTemp[0][0] > 0 Then GUICtrlCreateMenuItem("", $MenuAction)
Global $MenuActionTListe[_Max($sTab2DTemp[0][0] +1, 2)], $iRefTListe[$sTab2DTemp[0][0] +1]
$MenuActionTListe[0] = $sTab2DTemp[0][0]
$MenuActionTListe[1] = -1000000
For $iTemp = 1 To $MenuActionTListe[0]
	$MenuActionTListe[$iTemp] = GUICtrlCreateMenuItem($sTab2DTemp[$iTemp][0], $MenuAction)
	$iRefTListe[$iTemp] = $sTab2DTemp[$iTemp][1]
Next
$sTab2DTemp = DbScriptListeMenu("C")
If $sTab2DTemp[0][0] > 0 Then GUICtrlCreateMenuItem("", $MenuAction)
Global $MenuActionCListe[_Max($sTab2DTemp[0][0] +1, 2)], $iRefcListe[$sTab2DTemp[0][0] +1]
$MenuActionCListe[0] = $sTab2DTemp[0][0]
$MenuActionCListe[1] = -1000000
For $iTemp = 1 To $MenuActionCListe[0]
	$MenuActionCListe[$iTemp] = GUICtrlCreateMenuItem($sTab2DTemp[$iTemp][0], $MenuAction)
	$iRefcListe[$iTemp] = $sTab2DTemp[$iTemp][1]
Next
Global $MenuOption = GUICtrlCreateMenu("Options")
Global $MenuOptionTop = GUICtrlCreateMenuItem("Garder en premier plan", $MenuOption)
GUICtrlSetState($MenuOptionTop, _CheckedUnchecked($sFenetreTop))
Global $MenuOptionSurveiller = GUICtrlCreateMenuItem("Surveiller le Presse-papier", $MenuOptionTop)
GUICtrlSetState($MenuOptionSurveiller, _CheckedUnchecked($bSurveillerPressePapier))
GUICtrlCreateMenuItem("", $MenuOption)
Global $MenuOptionPreferences = GUICtrlCreateMenuItem("Prfrences ...", $MenuOption)
Global $MenuAide = GUICtrlCreateMenu("Aide")
Global $MenuAideAide = GUICtrlCreateMenuItem("Aide", $MenuAide)
Global $MenuAideAPropos = GUICtrlCreateMenuItem("A propos ...", $MenuAide)
Dim $TableRaccourci[1][2] = [["!{F4}", $MenuFicQuitter]]
GUISetAccelerators($TableRaccourci)

#EndRegion - Interface


#Region - Lancement

;----- Initialisations diverses -----------------------------------------------
Global $scNomCompletTempImage = @ScriptDir & "\" & $scAppliTitreGeneral & " Temp ImageGrd." & $sClipBoardImageFormat
Global $scNomCompletTempVignette = @ScriptDir & "\" & $scAppliTitreGeneral & " Temp ImagePtt." & $sClipBoardImageFormat
Global $scNomCompletImageReCree = @ScriptDir & "\" & $scAppliTitreGeneral & "_Image." & $sClipBoardImageFormat
Global $scFichierAide = @ScriptDir & "\" & $scAppliTitreGeneral & ".chm"
Global $sAideContexte
; Raccourcis
_GUICtrlComboBox_BeginUpdate($ComboRaccourci)
For $iTemp = 0 To UBound($sListRaccourciLibelle) -1
	_GUICtrlComboBox_AddString($ComboRaccourci, $sListRaccourciLibelle[$iTemp])
Next
_GUICtrlComboBox_EndUpdate($ComboRaccourci)
; Couleurs
Global $sTableauCouleurs = _StringSplitInverse($sChaineCouleur, "|")
If $sChaineCouleur = "" Then $sTableauCouleurs[0] = 0
; Script Automatique
Global $sScriptAuto = DBScriptListeParam(-2)
Global $bScriptAuto = ($sScriptAuto[0][0] > 0)
; PowerManagementEvent
Global $gobjWMI_CIMV2
Global $gobjWMI_PowerEVT_Sink
If $bPowerManagementEvent Then
	$gobjWMI_CIMV2 = ObjGet("winmgmts:\\.\root\cimv2")
	$gobjWMI_PowerEVT_Sink = ObjCreate("WbemScripting.SWbemSink")
	ObjEvent($gobjWMI_PowerEVT_Sink , "PowerEVT_SINK_")
	$gobjWMI_CIMV2.ExecNotificationQueryAsync($gobjWMI_PowerEVT_Sink, "Select EventType from Win32_PowerManagementEvent")
EndIf

;----- Lancement --------------------------------------------------------------
GUISetState(@SW_HIDE, $FormClipSpirit)
WinSetOnTop($sFenetreTitre, "", $sFenetreTop)
; Initialiser le clipboard viewer
$hNext = _ClipBoard_SetViewer($FormClipSpirit)
GUIRegisterMsg($WM_CHANGECBCHAIN, "WM_CHANGECBCHAIN")
GUIRegisterMsg($WM_DRAWCLIPBOARD, "WM_DRAWCLIPBOARD")
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
If $sToucheActivation <> "" Then HotKeySet($sToucheActivation, "AppliAfficherMasquer")
If $sToucheColler <> "" Then HotKeySet($sToucheColler, "CollerAuto")
; Liste des touches Hotkey des scrpitings et des textes
$sListeHotKey = DbListeHotKey()
For $iTemp = 1 To $sListeHotKey[0][0]
	HotKeySet($sListeHotKey[$iTemp][0], "ToucheHotKey" & $iTemp)
Next
$hDllUser32 = DllOpen("user32.dll")
If $hDllUser32 = -1 Then
	MsgBox(4144, $scMsgErreur, "La DLL User32 ne peut tre ouverte !", 0, $FormClipSpirit)
	Exit
EndIf

;----- Initialiser l'affichage ------------------------------------------------
DbPeuplerListViewTexte($ListViewFavoris, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
DbPeuplerListViewTexte($ListViewTexte, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
If $iNbMaxItemImage > 0 Then
	DbPeuplerListViewImage($ListViewImage, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage, True) ; Initilisation de la liste (je ne sais pas pourquoi mais sans cela a ne marche pas si pas fait 2 fois)
	DbPeuplerListViewImage($ListViewImage, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
EndIf
LireClipBoard()
If $iNbMaxItemImage > 0 Then ListViewItemFocus($ListViewImage, 0, False, True)
ListViewItemFocus($ListViewFavoris, 0, False)
ListViewItemFocus($ListViewTexte, 0, True)
_EspaceBureau($iEspaceBureau)
EditeurAfficherMasquer(Number($bEditeurEstAffiche), True)
BackupBase("Start")

#EndRegion - Lancement


#Region - Boucle principale

While 1
	If Not WinActive($sFenetreTitre) Then ; L'appli est-elle active
		If $iItemEnCoursEdition <> 0 Then ModifierValiderItem(False) ; Enregistrement de la mofification en cours
		If $bEditeurEstAffiche And ($bFermerEditeurPerteFocus Or (Not $bAppliAffichee And $bFermerEditeurAppliMasquee)) Then EditeurAfficherMasquer(0, True) ; Masquer l'diteur
		$iItemDrag = -1 ; Plus en mode Drag&Drop
		If $bAffichagerItemSurvole Then ToolTip("") ; Effacer l'ventuelle infoBulle
	ElseIf $bAppliAffichee Then
		$sFenetreControlFocus = ControlGetFocus($sFenetreTitre) ; Le contrle qui a le focus
		If ($iItemEnCoursEdition <> 0) And (StringLeft($sFenetreControlFocus, 11) = "SysListView") Then ItemAbandonnerEdition() ;  Abandon de l'dition si une listView est active
		; Message windows
		$idMsg = GUIGetMsg()
		; Tab Actif
		$iTabActif = GUICtrlRead($TabClipSpirit)
		If $iTabActif <> $iTabActifOld Then
			Environnement("ChgTab", $iTabActif)
			$iTabActifOld = $iTabActif
			$iItemActifOld = -2
			$iItemDrag = -1
		EndIf
		; Item actif
		$iItemActif = ItemActif($hListViewActive)
		If $iItemActifOld <> $iItemActif Then
			$iItemActifOld = $iItemActif
			If $iItemEnCoursEdition <> 2 Then ItemAbandonnerEdition()
			EditeurAfficherItem($hListViewActive, $iItemActif)
		EndIf
		; Item survol par la souris
		If $bAffichagerItemSurvole Then
			ItemSurvoleSouris()
			If ($idMsg <> 0) And ($idMsg <> -11) Then ToolTip("")
		EndIf
		; Actions suivant l'vnement
		Switch $idMsg
			Case $MenuFicCompacter
				DbVacuum($FormClipSpirit)
			Case $MenuFicBackuper
				BackupBase("Manual")
			Case $MenuFicSynchoniser
				LancerSynchro(True)
			Case $MenuFicMasquer
				AppliMasquer()
			Case $MenuFicQuitter
				ExitLoop
			Case $GUI_EVENT_CLOSE
				If (_IsPressed("1B", $hDllUser32) And $bEscSortir) Or (Not _IsPressed("1B", $hDllUser32) And $bFermerSortir) Then
						ExitLoop
					Else
						AppliMasquer()
					EndIf
			Case $GUI_EVENT_PRIMARYUP
				ItemDragDrop(True)
			Case $PicEditeur, $MenuItemVoirEditeur
				EditeurAfficherMasquer(-1)
			Case $PicNouveau, $MenuItemNouveau
				ItemSaisieNouveau($hListViewActive)
			Case $PicFavoris, $MenuItemFavoris
				ItemCopierFavoris($hListViewActive, $iItemActif)
			Case $PicPoubelle, $MenuItemSupprimer
				ItemSupprimer($hListViewActive, $iItemActif)
			Case $ButtonSelectPlus
				SelectionPlusAfficherMasquer()
			Case $ButtonSelect
				SelectionGo()
			Case $InputEdCouleurNum
				CouleurEdTitre()
			Case $EditEdTexte
				GUICtrlSetData($ButtonEdRemplacer, $scCRLibBouton)
			Case $ButtonEdRemplacer
				ChercherRemplacer()
				WinActivate($sFenetreTitre)
				Sleep(30)
				GUIGetMsg()
			Case $ButtonEdEdiValider
				ModifierValiderItem(True)
			Case $ButtonEdEnregistrer, $MenuItemModifier
				ModifierValiderItem(False)
			Case $ButtonEdAbandonner
				ItemAbandonnerEdition()
			Case $MenuItemPasserFenetre
				ItemValide($hListViewActive)
			Case $MenuItemPasserPrp
				ItemValide($hListViewActive, False)
			Case $MenuItemLirePrp
				LireClipBoard()
			Case $MenuOptionSurveiller
				SurveillerOuPasPressePapier()
			Case $MenuActionInternet
				OuvrirLienInternet($hListViewActive)
			Case $MenuActionLienFichier
				CopierLiensFichiers($hListViewActive)
			Case $MenuActionReunir
				FonctionReunirOuSplitter($hListViewActive, True)
			Case $MenuActionSeparer
				FonctionReunirOuSplitter($hListViewActive, False)
			Case $MenuActionTListe[1] To $MenuActionTListe[_Max($MenuActionTListe[0], 1)]
				FonctionHotKeyScript($hListViewActive, "T", $iRefTListe[$idMsg - $MenuActionTListe[1] +1 ])
			Case $MenuActionCListe[1] To $MenuActionCListe[_Max($MenuActionCListe[0], 1)]
				FonctionHotKeyScript($hListViewActive, "C", $iRefCListe[$idMsg - $MenuActionCListe[1] +1 ])
			Case $MenuOptionTop
				MenuCheckedUnchecked($idMsg, "FenetreTop", $sFenetreTop)
				WinSetOnTop($sFenetreTitre, "", $sFenetreTop)
			Case $MenuOptionPreferences
				AccesPreferences()
			Case $MenuAideAide
				AccesAide()
			Case $MenuAideAPropos
				APropos()
		EndSwitch
		; Double clic Item rencontr
		If $bDoubleClicItem Then
			$bDoubleClicItem = False
			ItemValide($hListViewActive)
		EndIf
		; Dbut de Drag & Drop
		If $bDebutDrag Then
			$bDebutDrag = False
			ItemDragDrop(False)
		EndIf
		; Reconnaissance de Touches -----------------------
		If (StringLeft($sFenetreControlFocus, 11) = "SysListView") Then ; Touches dans les listview
			If _IsPressed("0D", $hDllUser32) Then ; Touche Entre
				ItemValide($hListViewActive)
			EndIf
			If _IsPressed("2E", $hDllUser32) Then ; Touche Suppr
				ItemSupprimer($hListViewActive, $iItemActif)
				Sleep($iPauseApresAppuiTouche)
			EndIf
			If _IsPressed("2D", $hDllUser32) Then ; Touche Insert
				ItemSaisieNouveau($hListViewActive)
				Sleep($iPauseApresAppuiTouche)
			EndIf
		ElseIf _IsFocused($InputSelectTexte) Then ; Texte de la slection
			If _IsPressed("0D", $hDllUser32) Then ; Touche Entre
				SelectionGo()
				Sleep($iPauseApresAppuiTouche)
			EndIf
		EndIf
		If $bEditeurUtiliserTab Then
			If _IsFocused($EditEdTexte) Then
				If Not $bEditTexteFocus Then
					Sleep($iPauseApresAppuiTouche)
					HotKeySet("{TAB}", "TabPress")
					$bEditTexteFocus = True
				EndIf
			Else
				If $bEditTexteFocus Then
					HotKeySet("{TAB}")
					$bEditTexteFocus = False
				EndIf
			EndIf
		EndIf
		If _IsPressed($sToucheAfficherEditeur, $hDllUser32) Then ; Afficher/masquer l'diteur
			If $hListViewActive <> $ListViewImage Then
				EditeurAfficherMasquer(-1)
				Sleep($iPauseApresAppuiTouche)
			EndIf
		EndIf
		If _IsPressed($sToucheModifierItem, $hDllUser32) Then ; Modifier/Valider l'item
			If $hListViewActive <> $ListViewImage Then
				ModifierValiderItem(True)
				Sleep($iPauseApresAppuiTouche)
			EndIf
		EndIf
		If _IsPressed($sToucheChangementTab, $hDllUser32) Then ; Passer d'onglet/tab en onglet/tab
			$iTabActif += 1
			If $iNbMaxItemImage = 0 Then
				If $iTabActif >= (UBound($scOngletTitre) -1) Then $iTabActif = 0
			Else
				If $iTabActif >= UBound($scOngletTitre) Then $iTabActif = 0
			EndIf
			Environnement("FaireChgTab", $iTabActif)
			Sleep($iPauseApresAppuiTouche)
		EndIf
		If _IsPressed($sToucheAide, $hDllUser32) Then AccesAide() ; Touche d'aide
	Else ; C'est l'icone qui a le focus mais pas l'appli ouverte
		Sleep(30)
	EndIf
	; Lancer des actions ------------------------------------------------------
	$iWaitAction += 1
	If $iWaitAction > 400 Then ; environ toutes les 20 secondes
		; Backup
		BackupBase("Day")
		; Synchronisation
		If $bSynchronisationTexte Or $bSynchronisationImage Or $bSynchronisationScript Then ActionSynchronisation()
		; RAZ
		$iWaitAction = 0
	EndIf
	; Attente -----------------------------------------------------------------
	Sleep(30)
WEnd

ExitClipSpirit()

#EndRegion - Boucle principale


#Region - Fonctions principales

Func ExitClipSpirit()
	FileDelete($scNomCompletImageReCree)
	; Fermer clipboard viewer
	_ClipBoard_ChangeChain($FormClipSpirit, $hNext)
	; Fermer la base
	_SQLite_Close($hDbPrp)
	_SQLite_Shutdown()
	Exit
EndFunc


Func ChercherRemplacer()
	Local $sRechercheUnique, $sRemplaceUnique, $sRechercheNFois, $sRemplaceNFois, $bRechercheFoisPlus
	Local $sChercheUN, $sChercheN, $iNbChercheUN, $iNbChercheN, $iPos, $iPos1, $iPos2, $aPos = WinGetPos($sFenetreTitre)
	Local $sCRMsg, $sText, $sTextDebut, $sTextFin, $iNbRemplace = 0, $sDebJoker, $sFinJoker
	Local $sTitre = $scAppliTitreGeneral & " - Chercher & Remplacer"
	; Interface
	Local $FormChercherRemplacer = GUICreate($sTitre, 429, 142, $aPos[0] + $icEditeurX0 +8, $aPos[1] + $icEditeurY1 +170, BitOR($WS_MINIMIZEBOX,$WS_SYSMENU,$WS_GROUP), $WS_EX_TOOLWINDOW)
	Local $LabelCRType = GUICtrlCreateLabel("Type de recherche", 8, 9, 94, 17)
	Local $RadioCRType1 = GUICtrlCreateRadio("Simple", 104, 7, 64, 17)
	Local $RadioCRType2 = GUICtrlCreateRadio("Multiple", 187, 7, 64, 17)
	Local $RadioCRType3 = GUICtrlCreateRadio("Joker ?*", 269, 7, 64, 17)
	Local $RadioCRType4 = GUICtrlCreateRadio("Joker _%", 352, 7, 64, 17)
	Local $LabelCRRecherche = GUICtrlCreateLabel("Chercher", 8, 32, 60, 17)
	Local $ComboCRRecherche = GUICtrlCreateCombo("", 103, 30, 205, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1, RechercherRemplacerListeToChaine($sListCRRecherche))
	Local $ComboCRNbRecherche = GUICtrlCreateCombo("", 312, 30, 105, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1, StringReplace("Une fois|Une fois et plus|Deux fois|Deux fois et plus|Trois fois|Trois fois et plus", "|", $cCarSep))
	Local $LabelCRRemplace = GUICtrlCreateLabel("Remplacer par", 8, 59, 73, 17)
	Local $ComboCRRemplace = GUICtrlCreateCombo("", 103, 57, 205, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1, RechercherRemplacerListeToChaine($sListCRRemplace))
	Local $ComboCRNbRemplace = GUICtrlCreateCombo("", 312, 57, 105, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
	GUICtrlSetData(-1, StringReplace("Une fois|Deux fois|Trois fois", "|", $cCarSep))
	Local $LabelCRMessage = GUICtrlCreateLabel("", 8, 93, 234, 17, 0x1) ; $SS_CENTER(0x1)
	GUICtrlSetColor(-1, 0x800000)
	Local $ButtonCRAbandonner = GUICtrlCreateButton("Abandonner", 246, 89, 83, 25)
	Local $ButtonCRValider = GUICtrlCreateButton("Remplacer", 336, 89, 83, 25)
	;
	_GUICtrlComboBox_SetCurSel($ComboCRRecherche, $iCRRecherche)
	_GUICtrlComboBox_SetCurSel($ComboCRNbRecherche, $iCRNbRecherche)
	_GUICtrlComboBox_SetCurSel($ComboCRRemplace, $iCRRemplace)
	_GUICtrlComboBox_SetCurSel($ComboCRNbRemplace, $iCRNbRemplace)
	If $iCRType < 1 Then $iCRType = 1
	If $iCRType > 4 Then $iCRType = 4
	Execute("GUICtrlSetState($RadioCRType" & $iCRType & ", $GUI_CHECKED)")
	ChercherRemplacerChgType($iCRType, $ComboCRRecherche, $ComboCRNbRecherche, $ComboCRRemplace, $ComboCRNbRemplace)
	;
	GUISetState(@SW_DISABLE, $FormClipSpirit)
	GUISwitch($FormChercherRemplacer)
	GUISetState(@SW_SHOW, $FormChercherRemplacer)
	WinSetOnTop($sTitre, "", 1)
	While 1
		If Not WinActive($sTitre) Then ExitLoop
		$sCRMsg = GUIGetMsg()
		Switch $sCRMsg
			Case $GUI_EVENT_CLOSE, $ButtonCRAbandonner
				GUICtrlSetData($ButtonEdRemplacer, $scCRLibBouton)
				ExitLoop
			Case $ComboCRRecherche, $ComboCRNbRecherche, $ComboCRRemplace, $ComboCRNbRemplace
				GUICtrlSetData($LabelCRMessage, "")
			Case $RadioCRType1, $RadioCRType2, $RadioCRType3, $RadioCRType4
				GUICtrlSetData($LabelCRMessage, "")
				ChercherRemplacerChgType($sCRMsg - $RadioCRType1 +1, $ComboCRRecherche, $ComboCRNbRecherche, $ComboCRRemplace, $ComboCRNbRemplace)
			Case $ButtonCRValider
				GUICtrlSetData($LabelCRMessage, "")
				$sRechercheUnique = _GUICtrlComboBox_GetEditText($ComboCRRecherche)
				If $sRechercheUnique = "" Then
					GUICtrlSetData($LabelCRMessage, "La recherche ne peut pas tre vide")
					ContinueCase
				EndIf
				If $iCRType > 2 Then
					If $iCRType = 3 Then
						$sChercheUN = "?"
						$sChercheN = "*"
					Else
						$sChercheUN = "_"
						$sChercheN = "%"
					EndIf
					StringReplace($sRechercheUnique, $sChercheUN, "")
					$iNbChercheUN = @extended
					StringReplace($sRechercheUnique, $sChercheN, "")
					$iNbChercheN = @extended
					If ($iNbChercheUN = 0) And ($iNbChercheN = 0) Then
						GUICtrlSetData($LabelCRMessage, "Aucun joker (" & $sChercheUN & $sChercheN & ") trouv")
						ContinueCase
					EndIf
					If ($iNbChercheUN > 0) And ($iNbChercheN > 0) Then
						GUICtrlSetData($LabelCRMessage, "Un seul type de joker (" & $sChercheUN & $sChercheN & ") en mme temps")
						ContinueCase
					EndIf
					If $iNbChercheN > 1 Then
						GUICtrlSetData($LabelCRMessage, "Un seul joker " & $sChercheN & " en mme temps")
						ContinueCase
					EndIf
					If $iNbChercheUN > 1 Then
						$iPos1 = StringInStr($sRechercheUnique, $sChercheUN)
						For $iPos = 2 To $iNbChercheUN
							$iPos2 = StringInStr($sRechercheUnique, $sChercheUN, 0, $iPos)
							If ($iPos1 +1) <> $iPos2 Then
								$iPos1 = -1
								ExitLoop
							EndIf
							$iPos1 += 1
						Next
						If $iPos1 = -1 Then
							GUICtrlSetData($LabelCRMessage, "Les " & $iNbChercheUN & " jokers " & $sChercheUN & " doivent se suivre")
							ContinueCase
						EndIf
					EndIf
				EndIf
				$sText = GUICtrlRead($EditEdTexte)
				$iCRRecherche = _GUICtrlComboBox_GetCurSel($ComboCRRecherche)
				Switch $iCRRecherche
					Case -1
						$iCRRecherche = ChercherRemplacerAjouterOuNon($sRechercheUnique, $sListCRRecherche)
					Case 0
						$sRechercheUnique = @TAB
					Case 1
						$sRechercheUnique = @CRLF
					Case 2
						$sRechercheUnique = " "
					Case Else
				EndSwitch
				$sRechercheNFois = $sRechercheUnique
				If $iCRType = 2 Then
					$iCRNbRecherche = _GUICtrlComboBox_GetCurSel($ComboCRNbRecherche)
					If Round(($iCRNbRecherche +1) / 2) > 1 Then $sRechercheNFois &= $sRechercheUnique
					If Round(($iCRNbRecherche +1) / 2) > 2 Then $sRechercheNFois &= $sRechercheUnique
					$bRechercheFoisPlus = (Int($iCRNbRecherche/2) <> ($iCRNbRecherche/2))
				Else
					$bRechercheFoisPlus = False
				EndIf
				;
				$iCRRemplace = _GUICtrlComboBox_GetCurSel($ComboCRRemplace)
				Switch $iCRRemplace
					Case -1
						$sRemplaceUnique = _GUICtrlComboBox_GetEditText($ComboCRRemplace)
						$iCRRemplace = ChercherRemplacerAjouterOuNon($sRemplaceUnique, $sListCRRemplace)
					Case 0
						$sRemplaceUnique = ""
					Case 1
						$sRemplaceUnique = @TAB
					Case 2
						$sRemplaceUnique = @CRLF
					Case 3
						$sRemplaceUnique = " "
					Case Else
						$sRemplaceUnique = _GUICtrlComboBox_GetEditText($ComboCRRemplace)
				EndSwitch
				$sRemplaceNFois = $sRemplaceUnique
				If $iCRType = 2 Then
					$iCRNbRemplace = _GUICtrlComboBox_GetCurSel($ComboCRNbRemplace)
					If $iCRNbRemplace > 0 Then $sRemplaceNFois &= $sRemplaceUnique
					If $iCRNbRemplace > 1 Then $sRemplaceNFois &= $sRemplaceUnique
				EndIf
				;
				If $iCRType < 3 Then ; ---------------------------------------- Cas recherche simple et multiple --------------------------------------------------------
					If $bRechercheFoisPlus Then ; ----------------------------- Cas recherche simple ou multiple, avec N fois en plus -----------------------------------
						$sTextDebut = ""
						$sTextFin = $sText
						While 1
							$iPos = StringInStr($sTextFin, $sRechercheNFois)
							If $iPos = 0 Then ExitLoop
							$iNbRemplace += 1
							$sTextDebut &= StringLeft($sTextFin, $iPos -1)
							$sTextFin = StringMid($sTextFin, $iPos + StringLen($sRechercheNFois))
							While 1
								If StringInStr($sTextFin, $sRechercheUnique) <> 1 Then ExitLoop
								$sTextFin = StringMid($sTextFin, StringInStr($sTextFin, $sRechercheUnique) + StringLen($sRechercheUnique))
							WEnd
							$sTextDebut &= $sRemplaceNFois
						WEnd
						$sText = $sTextDebut & $sTextFin
					Else ; ---------------------------------------------------- Cas recherche simple ou multiple, sans N fois en plus -----------------------------------
						$sText = StringReplace($sText, $sRechercheNFois, $sRemplaceNFois)
						$iNbRemplace = @extended
					EndIf
				Else
					If $iNbChercheUN > 0 Then ; ------------------------------- Cas des jockets ? ou _ ------------------------------------------------------------------
						$iPos = StringInStr($sRechercheUnique, $sChercheUN)
						$sDebJoker = StringMid($sRechercheUnique, 1, $iPos -1)
						$sFinJoker = StringMid($sRechercheUnique, $iPos + $iNbChercheUN)
						$sTextDebut = ""
						$sTextFin = $sText
						If ($sDebJoker <> "") And ($sFinJoker <> "") Then ; - Cas des jockets ? ou _, avec des caractres de recherche avant et aprs les ? ou _  -----
							While 1
								$iPos1 = StringInStr($sTextFin, $sDebJoker)
								If $iPos1 = 0 Then ExitLoop
								$iPos2 = StringInStr(StringMid($sTextFin, $iPos1 + StringLen($sDebJoker)), $sFinJoker)
								If $iPos2 = 0 Then ExitLoop
								If $iPos2 = ($iNbChercheUN +1) Then
									$sTextDebut &= StringLeft($sTextFin, $iPos1 -1) & $sRemplaceNFois
									$sTextFin = StringMid($sTextFin, $iPos1 + StringLen($sDebJoker) + $iPos2 + StringLen($sFinJoker) -1)
									$iNbRemplace += 1
								Else
									$sTextDebut &= StringLeft($sTextFin, $iPos1 +1)
									$sTextFin = StringMid($sTextFin, $iPos1 +2)
								EndIf
							WEnd
						ElseIf ($sDebJoker = "") And ($sFinJoker <> "") Then; Cas des jockets ? ou _, avec des caractres de recherche aprs les ? ou _ mais pas avant-
							$sTextDebut = StringLeft($sText, $iNbChercheUN)
							$sTextFin = StringMid($sText, $iNbChercheUN +1)
							While 1
								$iPos = StringInStr($sTextFin, $sFinJoker)
								If $iPos = 0 Then ExitLoop
								$sTextDebut &= StringLeft($sTextFin, $iPos - $iNbChercheUN -1) & $sRemplaceNFois
								$sTextFin = StringMid($sTextFin, $iPos + StringLen($sFinJoker))
								$iNbRemplace += 1
							WEnd
						ElseIf ($sDebJoker <> "") And ($sFinJoker = "") Then; Cas des jockets ? ou _, avec des caractres de recherche avant les ? ou _ mais pas aprs-
							While 1
								$iPos = StringInStr($sTextFin, $sDebJoker)
								If $iPos = 0 Then ExitLoop
								If ($iPos + StringLen($sDebJoker) + $iNbChercheUN - 1) > StringLen($sTextFin) Then ExitLoop
								$sTextDebut &= StringLeft($sTextFin, $iPos -1) & $sRemplaceNFois
								$sTextFin = StringMid($sTextFin, $iPos + StringLen($sDebJoker) + $iNbChercheUN)
								$iNbRemplace += 1
							WEnd
						ElseIf ($sDebJoker = "") And ($sFinJoker = "") Then ; Cas des jockets ? ou _, sans caractre de recherche avant et aprs les ? ou _ -----------
							$iPos2 = Floor(StringLen($sText) / $iNbChercheUN)
							$sTextFin = StringMid($sText, ($iNbChercheUN * $iPos2) +1)
							For $iPos = 1 To $iPos2
								$sTextDebut &= $sRemplaceNFois
								$iNbRemplace += 1
							Next
						EndIf
					Else ; ---------------------------------------------------- Cas du jocket * ou % --------------------------------------------------------------------
						$iPos = StringInStr($sRechercheUnique, $sChercheN)
						$sDebJoker = StringMid($sRechercheUnique, 1, $iPos -1)
						$sFinJoker = StringMid($sRechercheUnique, $iPos + 1)
						$sTextDebut = ""
						$sTextFin = $sText
						If ($sDebJoker <> "") And ($sFinJoker <> "") Then ; - Cas des jockets * ou %, avec des caractres de recherche avant et aprs les * ou %  -----
							While 1
								$iPos1 = StringInStr($sTextFin, $sDebJoker)
								If $iPos1 = 0 Then ExitLoop
								$iPos2 = StringInStr(StringMid($sTextFin, $iPos1 + StringLen($sDebJoker)), $sFinJoker)
								If $iPos2 = 0 Then ExitLoop
								$sTextDebut &= StringLeft($sTextFin, $iPos1 -1) & $sRemplaceNFois
								$sTextFin = StringMid($sTextFin, $iPos1 + StringLen($sDebJoker) + $iPos2 + StringLen($sFinJoker) -1)
								$iNbRemplace += 1
							WEnd
						ElseIf ($sDebJoker = "") And ($sFinJoker <> "") Then; Cas des jockets * ou %, avec des caractres de recherche aprs les * ou % mais pas avant-
							While 1
								$iPos = StringInStr($sTextFin, $sFinJoker)
								If $iPos = 0 Then ExitLoop
								$sTextDebut &= $sRemplaceNFois
								$sTextFin = StringMid($sTextFin, $iPos + StringLen($sFinJoker))
								$iNbRemplace += 1
							WEnd
						ElseIf ($sDebJoker <> "") And ($sFinJoker = "") Then; Cas des jockets * ou %, avec des caractres de recherche avant les * ou % mais pas aprs-
							$iPos = StringInStr($sTextFin, $sDebJoker)
							If $iPos <> 0 Then
								$sTextDebut = StringLeft($sTextFin, $iPos -1)
								$sTextFin = $sRemplaceNFois
								$iNbRemplace = 1
							EndIf
						ElseIf ($sDebJoker = "") And ($sFinJoker = "") Then ; Cas des jockets * ou %, sans caractre de recherche avant et aprs les * ou % -----------
							$sTextFin = $sRemplaceNFois
							$iNbRemplace = 1
						EndIf
					EndIf
					$sText = $sTextDebut & $sTextFin
				EndIf
				;
				GUICtrlSetData($EditEdTexte, $sText)
				If $iNbRemplace > 1000 Then
					GUICtrlSetData($ButtonEdRemplacer, $iNbRemplace & " rempl.")
				Else
					GUICtrlSetData($ButtonEdRemplacer, $iNbRemplace & " remplace.")
				EndIf
				ExitLoop
		EndSwitch
		Sleep(30)
	WEnd
	GUIDelete($FormChercherRemplacer)
	GUISetState(@SW_ENABLE, $FormClipSpirit)
EndFunc

Func ChercherRemplacerChgType($iNewType, $ComboRecherche, $ComboNbRecherche, $ComboRemplace, $ComboNbRemplace)
	If $iNewType = 2 Then
		GUICtrlSetPos($ComboRecherche, 103, 30, 205)
		GUICtrlSetState($ComboNbRecherche, $GUI_SHOW)
		GUICtrlSetPos($ComboRemplace, 103, 57, 205)
		GUICtrlSetState($ComboNbRemplace, $GUI_SHOW)
	Else
		GUICtrlSetState($ComboNbRecherche, $GUI_HIDE)
		GUICtrlSetPos($ComboRecherche, 103, 30, 314)
		GUICtrlSetState($ComboNbRemplace, $GUI_HIDE)
		GUICtrlSetPos($ComboRemplace, 103, 57, 314)
	EndIf
	$iCRType = $iNewType
EndFunc

Func ChercherRemplacerAjouterOuNon($sTexte, ByRef $sList)
	Local $i, $iInd = -1
	For $i = 0 To UBound($sList) -1
		If $sTexte = $sList[$i] Then
			$iInd = $i
			ExitLoop
		EndIf
	Next
	If $iInd = -1 Then
		ReDim $sList[UBound($sList) +1]
		$sList[UBound($sList) -1] = $sTexte
		$iInd = UBound($sList) -1
	EndIf
	Return $iInd
EndFunc

Func RechercherRemplacerListeToChaine($sList)
	Local $i, $s
	For $i = 0 To UBound($sList) -2
		$s &= $sList[$i] & $cCarSep
	Next
	Return $s & $sList[UBound($sList) -1]
EndFunc


Func ItemSurvoleSouris()
	If $hListViewActive <> $ListViewImage Then
		$aItemSurvoleInfo = _GUICtrlListView_HitTest(GUICtrlGetHandle($hListViewActive))
		If IsArray($aItemSurvoleInfo) And $aItemSurvoleInfo[0] <> -1 Then
			If $iItemSurvole <> $aItemSurvoleInfo[0] Then
				$iItemSurvole = $aItemSurvoleInfo[0]
				$iItemSurvoleInit = _Timer_Init()
				$bItemSurvoleTip = False
				ToolTip("")
			EndIf
			If $iItemSurvole = $aItemSurvoleInfo[0] Then
				If Not $bItemSurvoleTip Then
					If _Timer_Diff($iItemSurvoleInit) >= $iLapsTempsAvantAffichageItemSurvole Then
						$bItemSurvoleTip = True
						Local $iID = _GUICtrlListView_GetItemText($hListViewActive, $iItemSurvole, 1)
						If $iID > 0 Then
							Local $sTexte = DbItemLireUniquementTexte($iID)
							If $sTexte <> $scPerdu Then
								StringReplace($sTexte, @CR, "*")
								Local $iHauteur = (@extended +1) * 15
								Local $iPosY = MouseGetPos(1) +15
								If ($iPosY + $iHauteur) > $iEspaceBureau[3] Then $iPosY = _Max($iEspaceBureau[3] - $iHauteur, $iEspaceBureau[1])
								ToolTip($sTexte, MouseGetPos(0) +15, $iPosY)
							Else
								$iItemSurvole = -1
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Else
			$iItemSurvole = -1
		EndIf
	EndIf
	If $iItemSurvole = -1 Then ToolTip("")
EndFunc


Func FonctionHotKeyTexte($ListView, $iID)
	ItemValide($ListView, True, WinGetTitle("[ACTIVE]", ""), $iID)
EndFunc


Func FonctionHotKeyScript($ListView, $sTypeAction, $iRefAction)
	Local $i, $sData[11], $ListView2, $iItemIndex2, $iID, $sCouleurOld
	Local  $sTitre = "", $sTexte = "", $sCommentaire = "", $sCouleur = $sCouleurDef, $sProvenance = ""
	If $sTypeAction = "T" Then
		If $bEditeurEstAffiche And ($iItemEnCoursEdition <> 0) Then ; Editeur en mode modif ou cration
			$sData[1] = GUICtrlRead($InputEdTitre)
			$sData[0] = GUICtrlRead($EditEdTexte)
			$sData[3] = GUICtrlRead($InputEdCommentaire)
			$sData[2] = GUICtrlRead($InputEdProvenance)
			$sCouleur = _LireValParamPlus($sValPrpPlus, "BkC", $sCouleurDef)
			If ExecuterScript($iRefAction, $sData[1], $sData[0], $sData[3], $sCouleur, $sData[2]) Then
				GUICtrlSetData($InputEdTitre, $sData[1])
				GUICtrlSetData($EditEdTexte, $sData[0])
				GUICtrlSetData($InputEdCommentaire, $sData[3])
				_CouleurTexteEtFond($InputEdTitre, $sCouleur)
				$sValPrpPlus = _EcrireValParamPlus($sValPrpPlus, "BkC", $sCouleur, $sCouleurDef)
			EndIf
		Else
			If ($iItemActif < 0) Or ($iItemActif >= _GUICtrlListView_GetItemCount($hListViewActive)) Then Return
			$iID = _GUICtrlListView_GetItemText($ListView, $iItemActif, 1)
			If $iID > 0 Then
				$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If $sData[0] = $scPerdu Then Return
			EndIf
			$sCouleur = _LireValParamPlus($sData[9], "BkC", $sCouleurDef)
			$sCouleurOld = $sCouleur
			If ExecuterScript($iRefAction, $sData[1], $sData[0], $sData[3], $sCouleur, $sData[2]) Then
				$sData[9] = _EcrireValParamPlus($sValPrpPlus, "BkC", $sCouleur, $sCouleurDef)
				If Not DbMAJItemTexte($iID, $sData[1], $sData[0], $sData[3], $sData[9]) Then Return False
				; Mettre  jour le titre dans la liste
				_GUICtrlListView_SetItemText($ListView, $iItemActif, $sData[1], 0)
				If $sCouleurOld <> $sCouleur Then
					If $ListView = $ListViewSelection Then
						SelectionGo()
					Else
						DbPeuplerListViewTexte($ListView, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
						ListViewItemFocus($ListView, $iItemActif, False)
					EndIf
				EndIf
				; Mettre  jour dans la liste orginale si on est sur la liste de slection
				If $ListView = $ListViewSelection Then
					$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
					; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
					If $sData[0] = $scPerdu Then Return
					If $sData[7] = 0 Then ; 7=PrpEstFavoris
						$ListView2 = $ListViewTexte
					Else
						$ListView2 = $ListViewFavoris
					EndIf
					For $i = 1 To _GUICtrlListView_GetItemCount($ListView2)
						If $iID = _GUICtrlListView_GetItemText($ListView2, $i, 1) Then
							$iItemIndex2 = $i
							ExitLoop
						EndIf
					Next
					If $sCouleurOld <> $sCouleur Then DbPeuplerListViewTexte($ListView2, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
					If $iItemIndex2 >= 0 Then
						_GUICtrlListView_SetItemText($ListView2, $iItemIndex2, $sData[1], 0)
						ListViewItemFocus($ListView2, $iItemIndex2, False)
					EndIf
				EndIf
				; Mise  jour de l'diteur si en visu
				If $bEditeurEstAffiche And ($iItemEnCoursEdition = 0) Then EditeurAfficherItem($ListView, $iItemActif)
			EndIf
		EndIf
	Else ; $sTypeAction = "C"
		$sProvenance = "Auto-cration"
		$sCouleur = $sCouleurDef
		If ExecuterScript($iRefAction, $sTitre, $sTexte, $sCommentaire, $sCouleur, $sProvenance) Then
			If ItemTexteCreeOuEnPremier($ListViewTexte, $sTexte, $sProvenance, $sTitre, False, _EcrireValParamPlus($sValPrpPlus, "BkC", $sCouleur, $sCouleurDef), True, $sCommentaire) <> -1 Then
				If $bActiverListeTexteInsert Then ; Activer l'onglet Texte
					Environnement("FaireChgTab", $icOngletTexte)
					Environnement("ChgTab", $icOngletTexte)
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc


Func ExecuterScript($iRefAction, ByRef $sTitre, ByRef $sTexte, ByRef $sCommentaire, ByRef $sCouleur, $sProvenance)
	Local $sListParam = DBScriptListeParam($iRefAction)
	If _ExecScript($sListParam, $sTitre, $sTexte, $sCommentaire, $sCouleur, $sProvenance, $scMsgErreur, $FormClipSpirit, $bMajClipBoard) = 1 Then
		TraySecoue("C")
		Return True
	Else
		Return False
	EndIf
EndFunc


Func OuvrirLienInternet($ListView)
	Local $i, $j, $iItemsSelect[1], $iID, $sData, $sTexte = ""
	Local $n, $p, $a, $b, $e, $q, $l
	Local $iNbEleDebut, $iNbEleFin, $iNbAdresse = 0
	; Paramtres
	Local $sChaineDebut = "|http://|https://|www.|" ; Liste des lments de dbut d'adresse spars par des |. Ne pas oublier les | en dbut et fin
	Local $sChaineFin = "| |" & @CR & "|" & @LF & "|" & @TAB & "|" ; Liste des lments en fin d'adresse spars par des |. Ne pas oublier les | en dbut et fin
	; Runion les items slectionns => $sTexte
	$iItemsSelect = ItemsSelectionnes($ListView)
	For $i = 1 To $iItemsSelect[0]
		If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
			$iID = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
			If $iID >= 1 Then
				$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If $sData[0] = $scPerdu Then
					$sTexte = ""
					ExitLoop
				EndIf
				$sTexte &= @CRLF & $sData[0]
			EndIf
		EndIf
	Next
	; Initialisation
	$iNbEleDebut = StringReplace($sChaineDebut, "|", "") ; Nombre d'lments de dbut
	$iNbEleDebut = @Extended -1
	$iNbEleFin = StringReplace($sChaineDebut, "|", "") ; Nombre d'lments de fin
	$iNbEleFin = @Extended -1
	$sTexte = $sTexte & @CR ; Texte analys
	; Parcours de la chane
	For $i = 1 To StringLen($sTexte)
		$n = 0 ; N d'lments de dbut trouv
		$p = StringLen($sTexte) +1 ; Position
		; Recherche des N lements de dbut
		For $j = 0 To ($iNbEleDebut -1)
			; Dcouper pour placer chaque lment dans $e
			$a = StringInStr($sChaineDebut, "|", 0, ($j+1))
			$b = StringInStr($sChaineDebut, "|", 0, ($j+2))
			$e = StringMid($sChaineDebut, ($a +1), ($b - $a -1))
			; L'lment de dbut est-il trouv ?
			$q = StringInStr($sTexte, $e)
			If ($q > 0) And ($q < $p) Then
				$p = $q
				$n = $j +1
			EndIf
		Next
		If $n = 0 Then ExitLoop
		$sTexte = StringMid($sTexte, $p) ;  L'lment de dbut a t trouv en position $p => On coupe le Texte  cette position
		$n = 0 ; N d'lments de fin trouv
		$p = StringLen($sTexte) +1 ; Position
		; Recherche des N lements
		For $j = 0 To ($iNbEleFin -1)
			; Dcouper pour placer chaque lment de fin dans $e
			$a = StringInStr($sChaineFin, "|", 0, ($j+1))
			$b = StringInStr($sChaineFin, "|", 0, ($j+2))
			$e = StringMid($sChaineFin, ($a +1), ($b - $a -1))
			; L'lment de fin est-il trouv ?
			$q = StringInStr($sTexte, $e)
			If ($q > 0) And ($q < $p) Then
				$p = $q
				$n = $j +1
				$l = StringLen($e)
			EndIf
		Next
		If $n = 0 Then
			$sTexte = StringMid($sTexte, 2) ; L'lment de fin n'a pas t trouv => on enlve un caractre de dbut du Texte
		Else
			$iNbAdresse = $iNbAdresse +1 ; Nombre d'adresses Internet trouves
			If $iNbAdresse > 1 Then Sleep(1000)
			ShellExecute(StringLeft($sTexte, ($p -1))) ; L'adresse interne reconnue est ici et lance
			TraySecoue("C")
			$sTexte = StringMid($sTexte, ($p + $l)) ; L'lment de fin a t trouv en position $p  => On coupe le Texte aprs cette position
		EndIf
	Next
	If $iNbAdresse = 0 Then MsgBox(4160, $scMsgInfo, "Aucun lien internet trouv", 0, $FormClipSpirit)
EndFunc


Func CopierLiensFichiers($ListView)
	Local $iItemsSelect, $i, $j, $sLiens = "", $iID, $sData, $sClip, $sSplit, $iNb = 0
	Local $sNull = StringLeft(BinaryToString(0), 1)
	Local Const $sT = " dans le presse-papier de votre explorateur de fichiers Windows"
	$iItemsSelect = ItemsSelectionnes($ListView)
	For $i = 1 To $iItemsSelect[0]
		If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
			$iID = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
			If $iID >= 1 Then
				$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If StringInStr($sData[0], "\") = 0 Then ContinueLoop
				$sSplit = StringSplit($sData[0], @CR)
				For $j = 1 To $sSplit[0]
					If StringInStr($sSplit[$j], "\") = 0 Then ContinueLoop
					$sSplit[$j] = StringReplace($sSplit[$j], @LF, "")
					If Not FileExists($sSplit[$j]) Then ContinueLoop
					If $sLiens <> "" Then $sLiens &= $sNull
					$sLiens &= $sSplit[$j]
					$iNb +=1
				Next
			EndIf
		EndIf
	Next
	If $sLiens = "" Then
		MsgBox(4160, $scMsgInfo, "Aucun lien fichier trouv", 0, $FormClipSpirit)
	Else
		$sClip = Chr(20) & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & $sNull & Chr(1) & $sNull & $sNull & $sNull
		For $i = 1 To StringLen($sLiens)
			$sClip &= StringMid($sLiens, $i, 1) & $sNull
		Next
		$sClip &= $sNull & $sNull & $sNull
		_ClipBoard_SetData($sClip, $CF_HDROP)
		If $iNb = 1 Then
			MsgBox(4160, $scMsgInfo, "Un lien fichier a t plac" & $sT, 0, $FormClipSpirit)
		Else
			MsgBox(4160, $scMsgInfo, $iNb & " liens fichiers ont t placs" & $sT, 0, $FormClipSpirit)
		EndIf
	EndIf
EndFunc


Func FonctionReunirOuSplitter($ListView, $bReunir)
	Local $i, $sData, $iID, $iItemsSelect[1], $ListViewCree, $sTextSplit
	Local $sTexte = "", $bValLue = False, $bFavoris = False, $sPlus = ""
	$iItemsSelect = ItemsSelectionnes($ListView)
	If $bReunir And ($iItemsSelect[0] < 2) Then
		MsgBox(4160, $scMsgInfo, "Vous devez slectionner au moins 2 items !", 0, $FormClipSpirit)
		Return
	EndIf
	For $i = 1 To $iItemsSelect[0]
		If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
			$iID = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
			If $iID >= 1 Then
				$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If $sData[0] = $scPerdu Then
					$sTexte = ""
					ExitLoop
				EndIf
				$sTexte &= $sData[0]
				If $i < $iItemsSelect[0] Then $sTexte &= @CRLF
				If Not $bValLue Then
					$bValLue = True
					$bFavoris = ($sData[7] = 1)
					$sPlus = $sData[9]
				EndIf
			EndIf
		EndIf
	Next
	If StringReplace($sTexte, @CRLF, "") = "" Then
		MsgBox(4160, $scMsgInfo, "Aucun texte  runir", 0, $FormClipSpirit)
		Return
	EndIf
	If $ListView = $ListViewSelection Then
		If $bFavoris Then
			$ListViewCree = $ListViewFavoris
		Else
			$ListViewCree = $ListViewTexte
		EndIf
	Else
		$ListViewCree = $ListView
	EndIf
	$sPlus = _EcrireValParamPlus($sPlus, "HKy", "", "") ; Pas de raccourci pour les runions ni sur les splits
	If $bReunir Then
		ItemTexteCreeOuEnPremier($ListViewCree, $sTexte, "Fonction Runir", TitreParDefaut($sTexte), $bFavoris, $sPlus)
	Else
		GUISetCursor(15, 1, $FormClipSpirit) ; Curseur WAIT
		$sTexte = StringReplace($sTexte, @CRLF, @CR)
		$sTexte = StringReplace($sTexte, @LF, "")
		$sTextSplit = StringSplit($sTexte, @CR)
		For $i = $sTextSplit[0] To 1 Step -1
			If StringStripWS(StringReplace($sTextSplit[$i], @TAB, ""), 8) <> "" Then ItemTexteCreeOuEnPremier($ListViewCree, $sTextSplit[$i], "Fonction Sparer", TitreParDefaut($sTextSplit[$i]), $bFavoris, $sPlus, False)
		Next
		DbPeuplerListViewTexte($ListView, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		ListViewItemFocus($ListView, 0, True)
		GUISetCursor(2) ; Curseur Classique
	EndIf
	If $ListView = $ListViewSelection Then SelectionGo()
EndFunc


Func SelectionGo()
	; Prparation de la requte ---------------------------
	Local $sSql = "SELECT PrpTitre, ROWID, PrpText, PrpCommentaire, PrpProvenance, PrpPlus FROM Texte"
	Local $sTexte = _OterAccentCedille(GUICtrlRead($InputSelectTexte))
	Local $sOrderBy, $sWhere
	Local $bInPrpText = GUICtrlRead($CheckboxSelectPrp) = $GUI_CHECKED
	Local $bInPrpTitre = GUICtrlRead($CheckboxSelectTitre) = $GUI_CHECKED
	Local $bInPrpCommentaire = GUICtrlRead($CheckboxSelectCommentaire) = $GUI_CHECKED
	Local $bInPrpProvenance = GUICtrlRead($CheckboxSelectProvenance) = $GUI_CHECKED
	Local $i, $sCombo, $iCombo
	; Traiter la clause Where
	$sCombo = GUICtrlRead($ComboSelectInfo)
	For $i = 0 To UBound($sListeSelectInfo) -1
		If $sCombo = $sListeSelectInfo[$i] Then
			$iCombo = $i
			ExitLoop
		EndIf
	Next
	Switch $iCombo
		Case 1 ; Cherche Texte uniquement
			$sWhere = " WHERE PrpEstFavoris='0'"
		Case 2 ; Cherche Favoris uniquement
			$sWhere = " WHERE PrpEstFavoris='1'"
		Case 3 ; Uniquement avec Raccourci
			$sWhere = " WHERE PrpPlus LIKE '%|HKy=%'"
		Case Else ; Cherche Texte et Favoris
			$sWhere = ""
	EndSwitch
	$sSql &= $sWhere
	; Traiter l'Order By
	$sCombo = GUICtrlRead($ComboSelectTri)
	For $i = 0 To UBound($sListeSelectTri) -1
		If $sCombo = $sListeSelectTri[$i] Then
			$iCombo = $i
			ExitLoop
		EndIf
	Next
	Switch $iCombo
		Case 1 ; Tri inverse des listes
			$sOrderBy = "PrpDateClassement ASC, PrpRefSynchro ASC"
		Case 2 ; Date d'utilisation Dcroissante
			$sOrderBy = "PrpDateUtilisation DESC"
		Case 3 ; Date d'utilisation Croissante
			$sOrderBy = "PrpDateUtilisation ASC"
		Case 4 ; Titre Croissant
			$sOrderBy = "PrpTitre ASC"
		Case 5 ; Titre Dcroissant
			$sOrderBy = "PrpTitre DESC"
		Case 6 ; Commentaire Croissant
			$sOrderBy = "PrpCommentaire ASC"
		Case 7 ; Commentaire Dcroissant
			$sOrderBy = "PrpCommentaire DESC"
		Case 8 ; Provenance Croissant
			$sOrderBy = "PrpProvenance ASC"
		Case 9 ; Provenance Dcroissant
			$sOrderBy = "PrpProvenance DESC"
		Case 10 ; Contenu Texte Croissant
			$sOrderBy = "PrpText ASC"
		Case 11 ; Contenu Texte Dcroissant
			$sOrderBy = "PrpText DESC"
		Case Else ; Tri comme les listes
			$sOrderBy = "PrpDateClassement DESC, PrpRefSynchro DESC"
	EndSwitch
	$sSql &= " ORDER BY " & $sOrderBy & ";"
	; Excution -------------------------------------------
	Local $hQuery, $sData, $sInSomme
	_GUICtrlListView_BeginUpdate($ListViewSelection)
	_GUICtrlListView_DeleteAllItems($ListViewSelection)
	_SQlite_Query($hDbPrp, $sSql, $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		If $sTexte <> "" Then
			$sInSomme = ""
			If $bInPrpText Then $sInSomme &= $sData[2]
			If $bInPrpTitre Then $sInSomme &= $sData[0]
			If $bInPrpCommentaire Then $sInSomme &= $sData[3]
			If $bInPrpProvenance Then $sInSomme &= $sData[4]
			If StringInStr(_OterAccentCedille($sInSomme), $sTexte) = 0 Then ContinueLoop
		EndIf
		GUICtrlCreateListViewItem($sData[0] & $cCarSep & $sData[1], $ListViewSelection)
		_CouleurTexteEtFond(-1, _LireValParamPlus($sData[5], "BkC", $sCouleurDef))
	WEnd
	_SQLite_QueryFinalize($hQuery)
	_GUICtrlListView_EndUpdate($ListViewSelection)
	_GUICtrlListView_SetColumnWidth($ListViewSelection, 1, 0)
	; Focus
	ListViewItemFocus($ListViewSelection, 0, True)
	GUICtrlSetState($ListViewSelection, $GUI_FOCUS)
EndFunc


Func AccesPreferences()
	If Not _FichierExistant(@ScriptDir & "\" & $scProgPreference) Then
		MsgBox(4112, $scMsgErreur, "Le programme de gestion des prfrences (" & $scProgPreference & ") n'est pas trouv dans le dossier" & @CRLF & @ScriptDir, 0, $FormClipSpirit)
	Else
		GUISetCursor(15, 1, $FormClipSpirit) ; Curseur WAIT
		If Run(@ScriptDir & "\" & $scProgPreference) = 0 Then
			GUISetCursor(2) ; Curseur Classique
			MsgBox(4112, $scMsgErreur, "Le programme de gestion des prfrences (" & $scProgPreference & ") dans le dossier " & @CRLF & @ScriptDir & @CRLF  & " ne peut pas s'excuter !", 0, $FormClipSpirit)
		Else
			GUISetCursor(2) ; Curseur Classique
			AppliMasquer()
		EndIf
	EndIf
EndFunc


Func LancerSynchro($bManuel)
	If Not @Compiled Then Return
	Local $sSilence = "Silence"
	If $bManuel Then $sSilence = ""
	If ProcessExists($scProgSynchro) = 0 Then
		If Not _FichierExistant(@ScriptDir & "\" & $scProgSynchro) Then
			MsgBox(4112, $scMsgErreur, "Le programme de synchronisation (" & $scProgSynchro & ") n'est pas trouv dans le dossier" & @CRLF & @ScriptDir, 0, $FormClipSpirit)
		Else
			If ShellExecute(@ScriptDir & "\" & $scProgSynchro, $sSilence) = 0 Then _
				MsgBox(4112, $scMsgErreur, "Le programme de synchronisation(" & $scProgSynchro & ") dans le dossier " & @CRLF & @ScriptDir & @CRLF  & " ne peut pas s'excuter !", 0, $FormClipSpirit)
		EndIf
	Else
		If $bManuel Then MsgBox(4112, $scMsgErreur, "La synchronisation est dj en cours !", 0, $FormClipSpirit)
	EndIf
EndFunc

Func TrayLancerSynchro()
	LancerSynchro(True)
EndFunc


Func ReafficherApresSynchro($sType) ; T=Texte, F=Favoris, I=Image
	Switch $sType
		Case "T"
			If $iItemEnCoursEdition <> 0 Then Return  ; on ne peut pas mettre  jour si en cours de modif
			DbPeuplerListViewTexte($ListViewTexte, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
			ListViewItemFocus($ListViewTexte, 0, False)
		Case "F"
			If $iItemEnCoursEdition <> 0 Then Return  ; on ne peut pas mettre  jour si en cours de modif
			DbPeuplerListViewTexte($ListViewFavoris, 0, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
			ListViewItemFocus($ListViewFavoris, 0, False)
		Case "I"
			DbPeuplerListViewImage($ListViewImage, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
			ListViewItemFocus($ListViewImage, 0, False, True)
	EndSwitch
EndFunc


Func BackupBase($sModeActu)
	; "Start", "Manual", "", "Day"
	If ($sModeActu = "Day") And (StringInStr($sBackupMode, "Day") > 0) And StringInStr(DbTPLireTexte($sCleBackupTime, "*"), @YEAR & "-" & @MON & "-" & @MDAY & "_") <> 1 Then
		BackupBaseGO($sModeActu)
		Return
	EndIf
	If ($sModeActu = "Start") And (StringInStr($sBackupMode, "Start") > 0) Then
		BackupBaseGO($sModeActu)
		Return
	EndIf
	If ($sModeActu = "Manual") And (StringInStr($sBackupMode, "Manual") > 0) Then
		BackupBaseGO($sModeActu)
		Return
	EndIf
EndFunc

Func BackupBaseGO($sModeActu)
	If $sBackupRepertoire = "" Then $sBackupRepertoire = @ScriptDir
	If StringRight($sBackupRepertoire, 1) <> "\" Then $sBackupRepertoire &= "\"
	Local $sBackup = $sBackupRepertoire
	Local $sVal = _DateHeureJour(2)
	$sBackup &= $sFicDB & "_" & $sVal & ".db"
	If FileCopy($sFicDBComplet, $sBackup, 9) = 0 Then ; Cration du rpertoire et craser si existant
		MsgBox(4144, $scMsgErreur, "Le backup de vos donnes :" & @CRLF & $sFicDBComplet & @CRLF & "vers :" & @CRLF & $sBackup & "n'a pas pu tre ralis", 0, $FormClipSpirit)
	Else
		; Mise  jour des infos Backup
		DbTPMAJTexte($sCleBackupTime, $sVal)
		DbTPMAJTexte($sCleBackupInfo, $sBackup)
		; Trop de copies ?
		If $iBackupMaxNbCopies > 0 Then
			Local $i, $sListFichier[1]
			$sListFichier =_FileListToArray($sBackupRepertoire, $sFicDB & "_*.db", 1)
			If (@error = 0) And ($sListFichier[0] > $iBackupMaxNbCopies) Then
				_ArraySort($sListFichier, 0, 1)
				For $i = 1 To $sListFichier[0] - $iBackupMaxNbCopies
					FileDelete($sBackupRepertoire & $sListFichier[$i])
				Next
			EndIf
		EndIf
		If $sModeActu = "Manual" Then MsgBox(4160, $scMsgInfo, "Sauvegarde effectue" & @CRLF & @CRLF & "Fichier : " & _InfoNomFichier($sBackup, 2) & @CRLF & "Dossier : " & _
																_InfoNomFichier($sBackup, 4) & @CRLF, 0, $FormClipSpirit)
	EndIf
EndFunc


Func AccesAide()
	If Not _FichierExistant($scFichierAide) Then
		MsgBox(4112, $scMsgErreur, "Le fichier d'aide n'est pas trouv dans le dossier "  & @CRLF & @ScriptDir, 0, $FormClipSpirit)
	Else
		If WinExists("Aide " & $scAppliTitreGeneral) Then WinClose("Aide " & $scAppliTitreGeneral)
		If $sAideContexte <> "" Then
			ShellExecute("hh.exe", "mk:@MSITStore:" & StringReplace($scFichierAide, " ", "%20") & "::/" & $sAideContexte & ".html")
		Else
			ShellExecute($scFichierAide)
		EndIf
		Sleep(2000)
	EndIf
EndFunc


Func APropos()
	Local $iDMes, $sTitre = "A Propos de " & $scAppliTitreGeneral
	Local $FormAPropos = GUICreate("A Propos", 321, 224, -1, -1, BitOR($WS_MINIMIZEBOX,$WS_SYSMENU,$WS_CAPTION,$WS_GROUP,$WS_BORDER), $WS_EX_TOOLWINDOW, $FormClipSpirit)
	GUISetBkColor(0xFFFFFF)
	Local $GroupBoxAPropos = GUICtrlCreateGroup("", 8, 8, 305, 180)
	Local $PicAProposLogo = GUICtrlCreatePic(_Ressource("ClipSpiritaPropos.jpg"), 16, 24, 68, 68)
	Local $LabelAProposNom = GUICtrlCreateLabel($scAppliTitreGeneral, 96, 29, 205, 20, BitOR(0x1,$WS_GROUP)) ; $SS_CENTER(0x1)
	GUICtrlSetFont(-1, 12, 800, 0, "Verdana")
	Local $LabelAProposVersion = GUICtrlCreateLabel("Version " & $scVersion, 96, 51, 205, 17, BitOR(0x1,$WS_GROUP)) ; $SS_CENTER(0x1)
	Local $PicAProposTitre = GUICtrlCreatePic(_Ressource("ClipSpiritEsprit.jpg"), 19, 103, 280, 50)
	Local $LabelAuteur = GUICtrlCreateLabel($scAuteur, 96, 72, 205, 17, 0x1) ; $SS_CENTER(0x1)
	GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
	GUICtrlSetColor(-1, 0x000080)
	Local $LabelFree =  GUICtrlCreateLabel("Totalement gratuit pour une utilisation personnelle et professionnelle", 59, 150, 208, 25, 0x1) ; $SS_CENTER(0x1)
	GUICtrlSetFont(-1, 6, 400, 0, "MS Sans Serif")
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	Local $ButtonAProposOK = GUICtrlCreateButton("OK", 123, 194, 75, 25)
	GUISetState(@SW_DISABLE, $FormClipSpirit)
	GUISwitch($FormAPropos)
	GUISetState(@SW_SHOW)
	WinSetOnTop($sTitre, "", 1)
	While 1
		$iDMes = GUIGetMsg()
		Switch $iDMes
			Case $GUI_EVENT_CLOSE, $ButtonAProposOK
				ExitLoop
			Case $LabelAuteur
				GUISetCursor(15, 1, $FormAPropos) ; Curseur WAIT
				ShellExecute($scAdresseSite)
				Sleep(1000)
				GUISetCursor(2) ; Curseur Classique
		EndSwitch
	WEnd
	GUIDelete($FormAPropos)
	GUISetState(@SW_ENABLE, $FormClipSpirit)
EndFunc


Func ActionSynchronisation()
	Local $i, $hFic, $sInfoFic = ""
	; Stopper ou reporter la synchonisation (Action provenant du module de synchronisation)
	If FileExists($scStopSynchro) Then
		$hFic = FileOpen($scStopSynchro, 0)
		If $hFic <> -1 Then
			$sInfoFic = FileReadLine($hFic)
			If StringLeft($sInfoFic, StringLen($scTxtNextSynchro)) = $scTxtNextSynchro Then $sSynchroProchaine = StringMid($sInfoFic, StringLen($scTxtNextSynchro) +1)
		EndIf
		FileClose($hFic)
		FileDelete($scStopSynchro)
		If $sInfoFic = "" Then
			$bSynchronisationTexte = False
			$bSynchronisationImage = False
			$bSynchronisationScript = False
			$sSynchroProchaine = ""
		EndIf
	EndIf
	; Lancer la synchronisation
	If $sSynchroProchaine <> "" Then
		If $sSynchroProchaine < _DateHeureJour(3) Then
			; Si la synchronisation devait avoir lieu il y a plus d'une heure alors on dcalle de 5 minutes (cas de sortie de veille par exemple)
			If _AjouterDate($sSynchroProchaine, 60 * 60 * 1000) < _DateHeureJour(3) Then
				$sSynchroProchaine = _AjouterDate(_DateHeureJour(3), 5 * 60 * 1000)
			Else
				LancerSynchro(False)
			EndIf
		EndIf
	EndIf
	; Rafficher suite  la synchronisation
	If FileExists($scReafFicherIApresSynchro) Then ReafficherApresSynchro("I") ; Image
	If FileExists($scReafFicherFApresSynchro) Then ReafficherApresSynchro("F") ; Favoris
	If FileExists($scReafFicherTApresSynchro) Then ReafficherApresSynchro("T") ; Texte
	; HotKey Changs ?
	If FileExists($scReafHotKeyApresSynchro) Then
		For $i = 1 To $sListeHotKey[0][0]
			If $sListeHotKey[$i][0] <> "" Then HotKeySet($sListeHotKey[$i][0])
		Next
		$sListeHotKey = DbListeHotKey()
		For $i = 1 To $sListeHotKey[0][0]
			HotKeySet($sListeHotKey[$i][0], "ToucheHotKey" & $i)
		Next
		FileDelete($scReafHotKeyApresSynchro)
	EndIf
EndFunc

#EndRegion - Fonctions principales


#Region - Fonctions secondaires

Func CouleurEdTitre()
	Local $iMin, $iNumCouleur = GUICtrlRead($InputEdCouleurNum)
	Local $sCouleurFond, $sCouleurFondOld = _LireValParamPlus($sValPrpPlusOld, "BkC", $sCouleurDef)
	If StringInStr($sChaineCouleur, $sCouleurFondOld) > 0 Then
		$iMin = 1
	Else
		$iMin = 0
	EndIf
	If $iNumCouleur < $iMin Then
		$iNumCouleur = $sTableauCouleurs[0]
	EndIf
	If $iNumCouleur > $sTableauCouleurs[0] Then
		$iNumCouleur = $iMin
	EndIf
	GUICtrlSetData($InputEdCouleurNum, $iNumCouleur)
	If $iNumCouleur = 0 Then
		$sCouleurFond = $sCouleurFondOld
	Else
		$sCouleurFond = $sTableauCouleurs[$iNumCouleur]
	EndIf
	_CouleurTexteEtFond($InputEdTitre, $sCouleurFond)
	$sValPrpPlus = _EcrireValParamPlus($sValPrpPlus, "BkC", $sCouleurFond, $sCouleurDef)
EndFunc


Func Environnement($sOrigine, $iVal)
	Switch $sOrigine
		Case "ChgTab"
			Switch $iVal
				Case 0 ; Texte
					$hListViewActive = $ListViewTexte
					GUICtrlSetState($PicNouveau, $GUI_SHOW)
					GUICtrlSetState($PicFavoris, $GUI_SHOW)
					GUICtrlSetState($PicEditeur, $GUI_SHOW)
					GUICtrlSetState($MenuItem, $GUI_ENABLE)
					GUICtrlSetState($MenuItemNouveau, $GUI_ENABLE)
					GUICtrlSetState($MenuItemFavoris, $GUI_ENABLE)
					GUICtrlSetState($MenuAction, $GUI_ENABLE)
					$sAideContexte = "OngletTexte"
				Case 1 ; Favoris
					$hListViewActive = $ListViewFavoris
					GUICtrlSetState($PicNouveau, $GUI_SHOW)
					GUICtrlSetState($PicFavoris, $GUI_HIDE)
					GUICtrlSetState($PicEditeur, $GUI_SHOW)
					GUICtrlSetState($MenuItem, $GUI_ENABLE)
					GUICtrlSetState($MenuItemNouveau, $GUI_ENABLE)
					GUICtrlSetState($MenuItemFavoris, $GUI_DISABLE)
					GUICtrlSetState($MenuAction, $GUI_ENABLE)
					$sAideContexte = "OngletFavoris"
				Case 2 ; Slection
					$hListViewActive = $ListViewSelection
					GUICtrlSetState($PicNouveau, $GUI_HIDE)
					GUICtrlSetState($PicFavoris, $GUI_SHOW)
					GUICtrlSetState($PicEditeur, $GUI_SHOW)
					GUICtrlSetState($MenuItem, $GUI_ENABLE)
					GUICtrlSetState($MenuItemNouveau, $GUI_DISABLE)
					GUICtrlSetState($MenuItemFavoris, $GUI_ENABLE)
					GUICtrlSetState($MenuAction, $GUI_ENABLE)
					$sAideContexte = "OngletSelection"
				Case 3 ; Image
					If $iNbMaxItemImage > 0 Then
						$hListViewActive = $ListViewImage
						GUICtrlSetState($PicNouveau, $GUI_HIDE)
						GUICtrlSetState($PicFavoris, $GUI_HIDE)
						GUICtrlSetState($PicEditeur, $GUI_HIDE)
						GUICtrlSetState($MenuItem, $GUI_DISABLE)
						GUICtrlSetState($MenuAction, $GUI_DISABLE)
						EditeurAfficherMasquer(0, True)
						$sAideContexte = "OngletImage"
					EndIf
			EndSwitch
			$iTabActifOld = -1
		Case "FaireChgTab"
			Switch $iVal
				Case 0 ; Texte
					GUICtrlSetState($TabSheetTexte, $GUI_SHOW)
					$sAideContexte = "OngletTexte"
				Case 1 ; Favoris
					GUICtrlSetState($TabSheetFavoris, $GUI_SHOW)
					$sAideContexte = "OngletFavoris"
				Case 2 ; Slection
					GUICtrlSetState($TabSheetSelection, $GUI_SHOW)
					$sAideContexte = "OngletSelection"
				Case 3 ; Image
					If $iNbMaxItemImage > 0 Then
						GUICtrlSetState($TabSheetImage, $GUI_SHOW)
						$sAideContexte = "OngletImage"
					EndIf
			EndSwitch
	EndSwitch
EndFunc


Func PowerEVT_SINK_OnObjectReady($wmiObject, $wmiAsyncContext)
	If Not $bSurveillerPressePapier Then Return
    Local $intEvent = $wmiObject.EventType
	If ($intEvent = 7) Or ($intEvent = 10) Then
		SurveillerOuPasPressePapier()
		Sleep(250)
		SurveillerOuPasPressePapier()
	EndIf
EndFunc


Func SurveillerOuPasPressePapier()
	$bSurveillerPressePapier = Not $bSurveillerPressePapier
	If $bSurveillerPressePapier Then
		TrayItemSetText($hTrayEcouter, "Ne plus surveiller le presse-papier")
		TraySetIcon()
		; Initialiser le clipboard viewer
		$hNext = _ClipBoard_SetViewer($FormClipSpirit)
	Else
		TrayItemSetText($hTrayEcouter, "Reprendre la surveillance du presse-papier")
		TraySetIcon(_Ressource("ClipSpirit0.ico"))
		; Fermer clipboard viewer
		_ClipBoard_ChangeChain($FormClipSpirit, $hNext)
	EndIf
	GUICtrlSetState($MenuOptionSurveiller, _CheckedUnchecked($bSurveillerPressePapier))
EndFunc


Func SelectionPlusAfficherMasquer()
	If $bSelectionPlusAffichee Then
		GUICtrlSetPos($ListViewSelection, 3, $icSelectLWTop2, $iFenetreLargeurModeListe -6 , $icSelectLWHauteur2)
		GUICtrlSetData($ButtonSelectPlus, "+")
	Else
		GUICtrlSetPos($ListViewSelection, 3, $icSelectLWTop1, $iFenetreLargeurModeListe -6 , $icSelectLWHauteur1)
		GUICtrlSetData($ButtonSelectPlus, "-")
	EndIf
	$bSelectionPlusAffichee = Not $bSelectionPlusAffichee
	GUICtrlSetState($CheckboxSelectPrp, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($CheckboxSelectTitre, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($CheckboxSelectCommentaire, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($CheckboxSelectProvenance, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($ComboSelectTri, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($ComboSelectInfo, _ShowHide($bSelectionPlusAffichee))
	GUICtrlSetState($ButtonSelect, _ShowHide($bSelectionPlusAffichee))
EndFunc


Func CollerAuto()
	ItemValide($hListViewActive, True, WinGetTitle("[ACTIVE]", ""))
EndFunc


Func AppliAfficherMasquer()
	If $bAppliAffichee Then
		AppliMasquer()
	Else
		AppliAfficher()
	EndIf
EndFunc


Func AppliMasquer()
	ItemAbandonnerEdition()
	$bAppliAffichee = False
	GUISetState(@SW_HIDE, $FormClipSpirit)
	TrayItemSetText($hTrayPressePapier, "Ouvrir " & $scAppliTitreGeneral)
EndFunc


Func AppliAfficher()
	$bAppliAffichee = True
	PositionFenetre()
	GUISetState(@SW_SHOW, $FormClipSpirit)
	AutoItSetOption("MouseCoordMode", 1)
	$iGetPos = MouseGetPos()
	$iGetPosX = $iGetPos[0]
	$iGetPosY = $iGetPos[1]
	TrayItemSetText($hTrayPressePapier, "Masquer " & $scAppliTitreGeneral)
EndFunc


Func WM_CHANGECBCHAIN($hWnd, $iMsg, $iwParam, $ilParam)
	; If the next window is closing, repair the chain
	If $iwParam = $hNext Then
		$hNext = $ilParam
		; Otherwise pass the message to the next viewer
	ElseIf $hNext <> 0 Then
		_SendMessage ($hNext, $WM_CHANGECBCHAIN, $iwParam, $ilParam, 0, "hwnd", "hwnd")
	EndIf
EndFunc


Func WM_DRAWCLIPBOARD($hWnd, $iMsg, $iwParam, $ilParam)
	; Lire le clipboard uniquement si l'appli n'est pas active et que l'appli n'est pas entrain de mettre  jour le clipboard !
	If Not WinActive($sFenetreTitre) And Not $bMajClipBoard And $bSurveillerPressePapier Then LireClipBoard()
	; Pass the message to the next viewer
	If $hNext <> 0 Then _SendMessage($hNext, $WM_DRAWCLIPBOARD, $iwParam, $ilParam)
EndFunc


Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
    Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $ListView, $hWndActu, $tInfo
	If StringLeft($sFenetreControlFocus, 11) = "SysListView" Then
		$hWndActu = $hListViewActive
		$ListView = $hWndActu
		If Not IsHWnd($hWndActu) Then $hWndActu = GUICtrlGetHandle($ListView)
		$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
		$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
		$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
		$iCode = DllStructGetData($tNMHDR, "Code")
		If ($hWndFrom = $hWndActu) Then
			; Les traitements ne sont pas faits ici pour permettre de terminer le WM_NOTIFY
			Switch $iCode
				Case $NM_DBLCLK
					$bDoubleClicItem = True
				Case -109 ; Debut Drag&Drop
					$bDebutDrag = True
			EndSwitch
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc


Func LireClipBoard()
	Local $sPresPap, $hClipOwner, $sOwner
	Local $hClipboardDataEx, $sImage, $sVignette, $aFile, $i, $aSize, $pFileName
	If _ClipBoard_IsFormatAvailable($CF_TEXT) Then
		$sPresPap = _ClipBoard_GetData()
		$hClipOwner = _ClipBoard_GetOwner()
		_ClipBoard_Close()
		If $sPresPap = "" Then Return
		If ItemTexteCreeOuEnPremier($ListViewTexte, $sPresPap, ProvenanceClipBoard($hClipOwner), TitreParDefaut($sPresPap), False, "", True,"", $bScriptAuto) = -1 Then Return
		If $bActiverListeTexteInsert Then ; Activer l'onglet Texte
			Environnement("FaireChgTab", $icOngletTexte)
			Environnement("ChgTab", $icOngletTexte)
		EndIf
	ElseIf _ClipBoard_IsFormatAvailable($CF_HDROP) Then
		If Not _ClipBoard_Open($FormClipSpirit) Then Return
		$hClipboardDataEx = _ClipBoard_GetDataEx($CF_HDROP) ; Handle du clipboard object
		$hClipOwner = _ClipBoard_GetOwner()
		_ClipBoard_Close()
		If $hClipboardDataEx = 0 Then Return
		$aFile = DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $hClipboardDataEx, "int", 0xFFFFFFFF, "ptr", 0, "int", 255) ; Nombre de fichiers
        For $i = 0 To $aFile[0] -1
            $aSize = DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $hClipboardDataEx, "int", $i, "ptr", 0, "int", 0) ; Longueur des noms de fichiers
            $aSize = $aSize[0] +1
            $pFileName = DllStructCreate("char[" & $aSize & "]")
            DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $hClipboardDataEx, "int", $i, "ptr", DllStructGetPtr($pFileName), "int", $aSize)
			If $i > 0 Then $sPresPap &= @CRLF
			$sPresPap &= DllStructGetData($pFileName, 1)
        Next
		If $sPresPap = "" Then Return
		If ItemTexteCreeOuEnPremier($ListViewTexte, $sPresPap, ProvenanceClipBoard($hClipOwner), TitreParDefaut($sPresPap), False, "", True,"", $bScriptAuto) = -1 Then Return
		If $bActiverListeTexteInsert Then ; Activer l'onglet Texte
			Environnement("FaireChgTab", $icOngletTexte)
			Environnement("ChgTab", $icOngletTexte)
		EndIf
	ElseIf (_ClipBoard_IsFormatAvailable($CF_BITMAP)) And ($iNbMaxItemImage > 0) Then
		If Not _ClipBoard_Open($FormClipSpirit) Then Return
		$hClipboardDataEx = _ClipBoard_GetDataEx($CF_BITMAP) ; Handle du clipboard object
		$hClipOwner = _ClipBoard_GetOwner()
		_ClipBoard_Close()
		If $hClipboardDataEx = 0 Then Return
		If Not ValeurImageEtVignette($hClipboardDataEx, $sImage, $sVignette) Then Return
		$sOwner = ProvenanceClipBoard($hClipOwner, True)
		ItemImageCreeOuEnPremier($ListViewImage, $sImage, $sVignette, StringLeft($sOwner, 30) & " " & _DateHeureJour(4), $sOwner)
		If $bActiverListeImageInsert Then ; Activer l'onglet Texte
			Environnement("FaireChgTab", $icOngletImage)
			Environnement("ChgTab", $icOngletImage)
		EndIf
	EndIf
EndFunc


Func ValeurImageEtVignette($hClipboardImage, ByRef $sImage, ByRef $sVignette)
	Local $hBitmap, $hImage
	Local $sCLSID, $hHandle, $sRead, $iHauteur,  $iLargeur, $iNT
	Local $hWnd, $hDC, $hImage1, $hImage2, $iNum
	; ----- Valeur du champ ImgImage
	If Not _GDIPlus_Startup() Then Return False
	$hBitmap = _GDIPlus_BitmapCreateFromHBITMAP($hClipboardImage) ; Handle du Bitmap object
	If $hBitmap = 0 Then Return False
	$hImage = _GDIPlus_ImageGetGraphicsContext($hBitmap) ; Handle du Graphics object
	If $hImage = -1 Then Return False
	FileDelete($scNomCompletTempImage)
	FileDelete($scNomCompletTempVignette)
	$sCLSID = _GDIPlus_EncodersGetCLSID($sClipBoardImageFormat)
	If $sCLSID = "" Then Return False
	If Not _GDIPlus_ImageSaveToFileEx($hBitmap, $scNomCompletTempImage, $sCLSID) Then Return False
	$hHandle = FileOpen($scNomCompletTempImage, 16)
	If $hHandle = -1 Then Return False
	$sRead = FileRead($hHandle)
	If @error = 1 Then Return False
	$sImage = Binary($sRead)
	FileClose($hHandle)
	$iLargeur = _GDIPlus_ImageGetWidth($hBitmap)
	$iHauteur = _GDIPlus_ImageGetHeight($hBitmap)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hImage)
	; ----- Valeur du champ ImgVignette
	$iNT = _ImageNouvelleTaille($iLargeur, $iHauteur, $iVignetteLargeur, $iVignetteHauteur)
	$hWnd = _WinAPI_GetDesktopWindow()
	$hDC = _WinAPI_GetDC($hWnd)
	$hBitmap = _WinAPI_CreateCompatibleBitmap($hDC, $iNT[2], $iNT[3]) ; Handle du Bitmap object
	_WinAPI_ReleaseDC($hWnd, $hDC)
	_GDIPlus_Startup()
	$hImage1 = _GDIPlus_BitmapCreateFromHBITMAP($hBitmap)
	$hImage2 = _GDIPlus_ImageLoadFromFile($scNomCompletTempImage)
	$hImage = _GDIPlus_ImageGetGraphicsContext($hImage1)
	_GDIPLus_GraphicsDrawImageRect($hImage, $hImage2, 0, 0, $iNT[2], $iNT[3])
	If Not _GDIPlus_ImageSaveToFileEx($hImage1, $scNomCompletTempVignette, $sCLSID) Then Return False
	_GDIPlus_ImageDispose($hImage1)
	_GDIPlus_ImageDispose($hImage2)
	_GDIPlus_GraphicsDispose ($hImage)
	_WinAPI_DeleteObject($hBitmap)
	_GDIPlus_Shutdown()
	$hHandle = FileOpen($scNomCompletTempVignette, 16)
	If $hHandle = -1 Then Return False
	$sRead = FileRead($hHandle)
	If @error = 1 Then Return False
	$sVignette = Binary($sRead)
	FileClose($hHandle)
	;
	FileDelete($scNomCompletTempImage)
	FileDelete($scNomCompletTempVignette)
	;
	Return True
EndFunc


Func ProvenanceClipBoard($hClipOwner, $bImage = False)
	Local $hPID, $hPID, $s1, $s2
    _WinAPI_GetWindowThreadProcessId($hClipOwner, $hPID)
	$s1 = _ProcessGetName($hPID)
	If StringRight($s1, 4) = ".exe" Then $s1 = StringMid($s1, 1, StringInStr($s1, ".exe") -1)
	If ($s1 = "") And $bImage Then $s1 = "Impression Ecran"
	Switch $s1
		Case "iexplore"
			$s1 = "Windows Internet Explorer"
		Case "WINWORD"
			$s1 = "Microsoft Word"
		Case "NOTEPAD"
			$s1 = "Bloc-notes"
		Case Else
			If StringUpper($s1) == $s1 Then $s1 = StringMid($s1, 1, 1) & StringLower(StringMid($s1, 2))
			If StringLower($s1) == $s1 Then $s1 = StringUpper(StringMid($s1, 1, 1)) & StringMid($s1, 2)
	EndSwitch
	$s2 = WinGetTitle(_WinAPI_GetAncestor($hClipOwner, $GA_ROOTOWNER))
	If ($s2 <> "") And ($s1 <> "") Then
		If StringInStr($s2, $s1) Then
			Return $s2
		Else
			Return $s1 & " - " & $s2
		EndIf
	ElseIf $s2 <> "" Then
		Return $s2
	Else
		Return $s1
	EndIf
EndFunc


; OUT -1 Le Texte est revenu vide du script Automatique
Func ItemTexteCreeOuEnPremier($ListView, $sPresPap, $sOwner, $sTitre, $bFavoris, $sPlus = "", $bReafficherListe = True, $Commentaire = "", $bActiverScriptAuto = False)
	Local $sCommentaire, $sCouleur, $iReturn = 1
	Local $iID = DbIDDuTexte($sPresPap, $bFavoris)
	If $iID > 0 Then
		ListViewDeplacerItemEnPremier($ListView, $iID, False, $bReafficherListe)
		TraySecoue("B")
	Else
		$iID = DbInsererNouveauTexte($sPresPap, $sOwner, $bFavoris, $sTitre, $sPlus, $Commentaire)
		If $bReafficherListe Then
			If $bActiverScriptAuto Then
				$sCouleur = _LireValParamPlus($sPlus, "BkC", $sCouleurDef)
				If _ExecScript($sScriptAuto, $sTitre, $sPresPap, $sCommentaire, $sCouleur, $sOwner, $scMsgErreur, $FormClipSpirit, $bMajClipBoard) = 1 Then
					If $sCouleur <> $sCouleurDef Then $sPlus = _EcrireValParamPlus($sPlus, "BkC", $sCouleur, $sCouleurDef)
					If $sPresPap = "" Then
						If _LireValParamPlus($sPlus, "HKy", "") Then _SupprimerHotKeyTxt($iID) ; Supprimer le raccourci
						DbDeleteItem($iID, $bSynchronisationTexte)
						$iReturn = -1
					Else
						DbMAJItemTexte($iID, $sTitre, $sPresPap, $sCommentaire, $sPlus)
					EndIf
				EndIf
			EndIf
			If $iReturn <> -1 Then
				DbPeuplerListViewTexte($ListView, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
				ListViewItemFocus($ListView, 0, True)
			EndIf
		EndIf
		If $iReturn <> -1 Then TraySecoue("A")
	EndIf
	Return $iReturn
EndFunc


Func ItemImageCreeOuEnPremier($ListView, $sImage, $sVignette, $sTitre, $sOwner)
	Local $iID = DbIDImage($sImage)
	If $iID > 0 Then
		TraySecoue("B")
		ListViewDeplacerItemEnPremier($ListView, $iID, True)
	Else
		TraySecoue("A")
		$iID = DbInsererNouvelleImage($sImage, $sVignette, $sTitre, $sOwner)
		DbPeuplerListViewImage($ListView, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
		ListViewItemFocus($ListView, 0, True)
	EndIf
EndFunc


Func ItemDragDrop($bDrop)
	If Not $bDrop Then
		$iItemDrag = ItemActif($hListViewActive)
	Else
		If $iItemDrag < 0 Then Return
		Local $iItemDrop = _GUICtrlListView_GetHotItem($hListViewActive)
		Local $iNbItem = _GUICtrlListView_GetItemCount($hListViewActive)
		If ($iItemDrop < 0) Or ($iItemDrop >= $iNbItem) Then
			$iItemDrag = -1
			Return
		EndIf
		Local $i, $iIndices[1]
		$iIndices = ItemsSelectionnes($hListViewActive)
		; Les N drags dans le mme drop
		For $i = 1 To $iIndices[0]
			If $iIndices[$i] = $iItemDrop Then
				$iIndices[0] = -1
				ExitLoop
			EndIf
		Next
		If $iIndices[0] = -1 Then Return
		; MAJ des PrpDateClassement et PrpDateModification
		Local $vRetour = DbDateClassementEtRefSynchro(_GUICtrlListView_GetItemText($hListViewActive, $iItemDrop, 1))
		Local $sDateClassementDrop = $vRetour[0]
		Local $sDateClassementAvant = DbClassementAvant($sDateClassementDrop, ($hListViewActive = $ListViewFavoris))
		Local $sDateClassementNew, $iDateStep
		Local $iDeltaDate = _DiffDateMilliSecondes($sDateClassementDrop, $sDateClassementAvant)
		If ($iDeltaDate / 1000) < ($iIndices[0] +2) Then
			$iDateStep = Int($iDeltaDate / ($iIndices[0] +1))
			$sDateClassementNew = $sDateClassementDrop
		Else
			$iDateStep = 1000
			$sDateClassementNew = _AjouterDate($sDateClassementDrop, (($iDeltaDate - (1000 * ($iIndices[0] +1))) / 2))
		EndIf
		For $i = $iIndices[0] To 1 Step -1
			$sDateClassementNew = _AjouterDate($sDateClassementNew, $iDateStep)
			DbMAJDateClassement(_GUICtrlListView_GetItemText($hListViewActive, $iIndices[$i], 1), $sDateClassementNew)
		Next
		; Modifier l'ordre visuellement
		DbPeuplerListViewTexte($hListViewActive, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		If  $iItemDrag < $iItemDrop Then
			ListViewItemFocus($hListViewActive, _Max(($iItemDrop -1), 0), True)
		Else
			ListViewItemFocus($hListViewActive, $iItemDrop, True)
		EndIf
		$iItemDrag = -1
	EndIf
EndFunc


Func TraySecoue($sLettre)
	Local $i
	For $i = 1 To 3
		TraySetIcon(_Ressource("ClipSpirit" & $sLettre & $i & ".ico"))
		Sleep(50)
	Next
	TraySetIcon()
EndFunc


Func ItemSaisieNouveau($ListView)
	Local $i, $iIndices[1]
	ItemAbandonnerEdition()
	EditeurAfficherMasquer(1)
	; Dslection
	$iIndices = _GUICtrlListView_GetSelectedIndices($ListView, True)
	For $i = 1 To $iIndices[0]
		_GUICtrlListView_SetItemSelected($ListView, $iIndices[$i], False)
	Next
	; Editer en mode nouveau
	ItemEditer(2)
EndFunc


Func ItemActif($ListView)
	Local $i, $iIndices[1], $iActif = -1
	$iIndices = ItemsSelectionnes($ListView)
	For $i = 1 To $iIndices[0]
		If _GUICtrlListView_GetItemFocused($ListView, $iIndices[$i]) Then
			$iActif = $iIndices[$i]
			ExitLoop
		EndIf
	Next
	Return $iActif
EndFunc


Func ItemsSelectionnes($ListView)
	Local $iItemsSelect[1]
	$iItemsSelect = _GUICtrlListView_GetSelectedIndices($ListView, True)
	_ArraySort($iItemsSelect, 0, 1)
	Return $iItemsSelect
EndFunc


Func ItemValide($ListView, $bSendV = True, $sTitreFenetreAppelante = "", $iID = -1)
	If $ListView = $ListViewImage Then
		ItemValideImage($ListView, $bSendV)
	Else
		ItemValideTexte($ListView, $bSendV, $sTitreFenetreAppelante, $iID)
	EndIf
EndFunc


Func ItemValideImage($ListView, $bSendV = True, $sTitreFenetreAppelante = "")
	Local $iNbLigne = 0, $hQuery, $sData, $fOpen, $hImage, $hBmp, $hBitmap
	_SQlite_Query($hDbPrp, "SELECT ImgImage, RowID FROM Image ORDER BY ImgDateClassement DESC, ImgRefSynchro DESC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		If $iItemActif = $iNbLigne Then
			; Cration de la vignette
			$fOpen = FileOpen($scNomCompletImageReCree, 2)
			FileWrite($fOpen, Binary($sData[0]))
			FileClose($fOpen)
			; Passer l'image dans clipboard (Merci UEZ)
			_GDIPlus_Startup ()
			$hImage = _GDIPlus_ImageLoadFromFile($scNomCompletImageReCree)
			$hBmp = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
			$hBitmap = _WinAPI_CopyImage($hBmp, 0, 0, 0, 0x000C) ; $LR_COPYDELETEORG (0x0008) + $LR_COPYRETURNORG (0x0004)
			_ClipBoard_Open(0)
			_ClipBoard_Empty()
			$bMajClipBoard = True
			_ClipBoard_SetDataEx($hBitmap, $CF_BITMAP)
			_ClipBoard_Close()
			$bMajClipBoard = False
			_GDIPlus_ImageDispose($hImage)
			_GDIPlus_Shutdown()
			AppliMasquer()
			If $bSendV Then
				If $sTitreFenetreAppelante <> "" Then WinActivate($sTitreFenetreAppelante)
				If $iPauseAvantSendV > 0 Then Sleep($iPauseAvantSendV)
				Send("^v")
				If $iPauseApresSendV > 0 Then Sleep($iPauseApresSendV)
			EndIf
			; Mise  jour de la date d'utilisation et ventuellement passer en premier dans la liste
			If $bItemImageChoisiPasseEnPremier Then
				DbPlacerItemEnPremier($sData[1], True)
			Else
				DbMAJDateUtilisation($sData[1], True)
			EndIf
			DbPeuplerListViewImage($ListView, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
			ListViewItemFocus($ListViewFavoris, 0, False, True)
			FileDelete($scNomCompletImageReCree)
			ExitLoop
		EndIf
		$iNbLigne += 1
	WEnd
	_SQLite_QueryFinalize($hQuery)
EndFunc


Func ItemValideTexte($ListView, $bSendV = True, $sTitreFenetreAppelante = "", $iIDUnique = -1)
	Local $i, $sTexte = "", $sData, $iNbPrp = 0, $iNbFavoris = 0
	Local $iID[1], $iItemsSelect[1], $iFavoris[1]
	If $iIDUnique <> -1 Then
		$iItemsSelect[0] = 1
		ReDim $iID[2]
		ReDim $iFavoris[2]
		$iID[1] = $iIDUnique
		$sData = DbItemTexteLireComplet($iID[1], $FormClipSpirit)
		; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
		If $sData[0] <> $scPerdu Then
			$iFavoris[1] = $sData[7]
			$sTexte = $sData[0]
		EndIf
	Else
		$iItemsSelect = ItemsSelectionnes($ListView)
		ReDim $iID[UBound($iItemsSelect) +1]
		ReDim $iFavoris[UBound($iItemsSelect) +1]
		For $i = 1 To $iItemsSelect[0]
			If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
				$iID[$i] = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
				If $iID[$i] >= 1 Then
					$sData = DbItemTexteLireComplet($iID[$i], $FormClipSpirit)
					; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
					If $sData[0] = $scPerdu Then
						$sTexte = ""
						ExitLoop
					EndIf
					$iFavoris[$i] = $sData[7]
					$sTexte &= $sData[0]
					If $i < $iItemsSelect[0] Then $sTexte &= $sCaracteresAjoutesMultiSelectItems
				EndIf
			EndIf
		Next
	EndIf
	If $sTexte = "" Then Return
	$bMajClipBoard = True
	_ClipBoard_SetData($sTexte)
	$bMajClipBoard = False
	AppliMasquer()
	If $bSendV Then
		If $sTitreFenetreAppelante <> "" Then WinActivate($sTitreFenetreAppelante)
		If $iPauseAvantSendV > 0 Then Sleep($iPauseAvantSendV)
		Send("^v")
		If $iPauseApresSendV > 0 Then Sleep($iPauseApresSendV)
	EndIf
	For $i = $iItemsSelect[0] To 1 Step -1
		Switch TexteEnPremierOuMAJDate($iID[$i], ($iFavoris[$i] = 1))
			Case 1
				$iNbFavoris += 1
			Case 2
				$iNbPrp += 1
		EndSwitch
	Next
	If $iNbPrp > 0 Then
		DbPeuplerListViewTexte($ListViewTexte, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		ListViewItemFocus($ListViewTexte, 0, False)
	EndIf
	If $iNbFavoris > 0 Then
		DbPeuplerListViewTexte($ListViewFavoris, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		ListViewItemFocus($ListViewFavoris, 0, False)
	EndIf
	Switch $ListView
		Case $ListViewTexte
			If $iNbPrp > 0 Then ListViewItemFocus($ListView, 0, True)
		Case $ListViewFavoris
			If $iNbFavoris > 0 Then ListViewItemFocus($ListView, 0, True)
		Case $ListViewSelection
			If ($iNbPrp > 0) Or ($iNbFavoris > 0) Then SelectionGo()
	EndSwitch
EndFunc


Func TexteEnPremierOuMAJDate($iIDItem, $bFavoris)
	If $bFavoris Then
		If $bItemFavorisChoisiPasseEnPremier Then
			DbPlacerItemEnPremier($iIDItem)
			Return 1
		Else
			DbMAJDateUtilisation($iIDItem)
			Return 0
		EndIf
	Else
		If $bItemTexteChoisiPasseEnPremier Then
			DbPlacerItemEnPremier($iIDItem)
			Return 2
		Else
			DbMAJDateUtilisation($iIDItem)
			Return 0
		EndIf
	EndIf
EndFunc


Func ItemCopierFavoris($ListView, $iItemIndex)
	Local $sData, $iID1, $iID2, $iItemsSelect[1], $ListView2, $iItemIndex2
	Local $i, $sHKy, $iNbPrp = 0, $iNbDelPrp = 0, $iNbFavoris = 0
	ItemAbandonnerEdition()
	$iItemsSelect = ItemsSelectionnes($ListView)
	For $i = $iItemsSelect[0] To 1 Step -1
		If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
			$iID1 = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
			If $iID1 >= 1 Then
				$sData = DbItemTexteLireComplet($iID1, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If $sData[0] = $scPerdu Then
					$iNbPrp = 0
					$iNbFavoris = 0
					ExitLoop
				EndIf
				$iID2 = DbIDDuTexte($sData[0], True)
				If $iID2 > 0 Then ; C'est dj un favoris
					If $bItemFavorisChoisiPasseEnPremier Then DbPlacerItemEnPremier($iID2) ; Eventuellement le placer en premier
				Else
					$sHKy = _LireValParamPlus($sData[9], "HKy", "") ; Raccourci de l'item de type Texte (non favoris)
					$iID2 = DbInsererNouveauTexte($sData[0], $sData[2], True, $sData[1], $sData[9]) ; Cration du favoris
				EndIf
				If $sData[7] = 1 Then ; Est-ce un favoris
					$iNbFavoris += 1
				Else
					$iNbPrp += 1
					If $sHKy <> "" Then ; Si l'item texte initial contient un raccourci, dans tous les cas le supprimer et le transfrer sur l'item favoris
						_SupprimerHotKeyTxt($iId1)
						_AjouterHotKeyTxt($iId2, $sHKy)
					EndIf
					If $bItemSuppSiDeplacerFavoris Then ; Soit on supprime l'item original, soit on l'update pour supprimer le raccourci
						$iNbDelPrp += 1
						DbDeleteItem($iID1, $bSynchronisationTexte)
					Else
						If $sHKy <> "" Then
							$sData[9] = _EcrireValParamPlus($sData[9], "HKy", "", "")
							DbMAJItemTexte($iID1, $sData[1], $sData[0], $sData[3], $sData[9])
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	If ($iNbPrp > 0) Or ($iNbFavoris > 0) Then
		IconeFlip($PicFavoris, "Favoris")
		DbPeuplerListViewTexte($ListViewFavoris, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		If $iNbDelPrp > 0 Then DbPeuplerListViewTexte($ListViewTexte, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		If $ListView = $ListViewSelection Then SelectionGo()
	EndIf
	ListViewItemFocus($ListViewFavoris, 0, False)
	ListViewItemFocus($ListView, $iItemIndex, True)
EndFunc


Func ItemSupprimer($ListView, $iItemIndex)
	If $ListView = $ListviewImage Then
		ItemImageSupprimer($ListView, $iItemIndex)
	Else
		ItemTexteSupprimer($ListView, $iItemIndex)
	EndIf
EndFunc


Func ItemImageSupprimer($ListView, $iItemIndex)
	Local $iNbLigne = 0, $hQuery, $sData, $sDateCreation, $iRefSynchro
	If $bConfirmSuppImageMono Then
		If MsgBox(8228, $scMsgConfirm, "Confirmez-vous la suppression de l'image slectionne ?", 0, $FormClipSpirit) = 7 Then Return
	EndIf
	_SQlite_Query($hDbPrp, "SELECT ImgDateCreation, ImgRefSynchro FROM Image ORDER BY ImgDateClassement DESC, ImgRefSynchro DESC;", $hQuery)
	While _SQLite_FetchData($hQuery, $sData) = $SQLITE_OK
		If $iItemIndex = $iNbLigne Then
			$sDateCreation = $sData[0]
			$iRefSynchro = Number($sData[1])
			ExitLoop
		EndIf
		$iNbLigne += 1
	WEnd
	_SQLite_QueryFinalize($hQuery)
	If $sDateCreation <> "" Then
		If _SQLite_Exec($hDbPrp, "DELETE FROM Image WHERE ImgDateCreation='" & $sDateCreation & "' AND ImgRefSynchro='" & $iRefSynchro & "';") = $SQLITE_OK Then
			If $bSynchronisationImage Then DbAjoutHistoSuppr("I", $sDateCreation, $iRefSynchro)
			IconeFlip($PicPoubelle, "Poubelle")
			DbPeuplerListViewImage($ListView, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
			ListViewItemFocus($ListViewFavoris, $iItemIndex, False, True)
		EndIf
	EndIf
EndFunc


Func ItemTexteSupprimer($ListView, $iItemIndex)
	Local $i, $j, $sData, $iID, $iItemsSelect[1], $iNb = 0, $ListView2, $iItemIndex2, $bConfirm
	ItemAbandonnerEdition()
	$iItemsSelect = ItemsSelectionnes($ListView)
	If $iItemsSelect[0] = 0 Then Return
	Switch $ListView
		Case $ListViewTexte
			$bConfirm = $bConfirmSuppTexteMono
			If $iItemsSelect[0] > 1 Then $bConfirm = $bConfirmSuppTexteMulti
		Case $ListViewFavoris
			$bConfirm = $bConfirmSuppFavorisMono
			If $iItemsSelect[0] > 1 Then $bConfirm = $bConfirmSuppFavorisMulti
		Case $ListViewSelection
			$bConfirm = $bConfirmSuppSelectMono
			If $iItemsSelect[0] > 1 Then $bConfirm = $bConfirmSuppSelectMulti
	EndSwitch
	If $bConfirm Then
		If $iItemsSelect[0] = 1 Then
			If MsgBox(8228, $scMsgConfirm, "Confirmez-vous la suppression de l'item slectionn ?", 0, $FormClipSpirit) = 7 Then Return
		Else
			If MsgBox(8228, $scMsgConfirm, "Confirmez-vous la suppression des " & $iItemsSelect[0] & " items slectionns ?", 0, $FormClipSpirit) = 7 Then Return
		EndIf
	EndIf
	For $i = $iItemsSelect[0] To 1 Step -1
		If ($iItemsSelect[$i] >= 0) And ($iItemsSelect[$i] < _GUICtrlListView_GetItemCount($ListView)) Then
			$iID = _GUICtrlListView_GetItemText($ListView, $iItemsSelect[$i], 1)
			If $iID >= 1 Then
				$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
				; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
				If $sData[0] = $scPerdu Then ExitLoop
				If DbDeleteItem($iID, $bSynchronisationTexte) Then
					$iNb += 1
					; Supprimer le raccourci
					If _LireValParamPlus($sData[9], "HKy", "") Then _SupprimerHotKeyTxt($iID)
					; Mettre  jour dans la liste "appelante"
					_GUICtrlListView_DeleteItem($ListView, $iItemsSelect[$i])
					; Mettre  jour dans la liste orginale si on est sur la liste de slection
					If $ListView = $ListViewSelection Then
						If $sData[7] = 0 Then ; 7=PrpEstFavoris
							$ListView2 = $ListViewTexte
						Else
							$ListView2 = $ListViewFavoris
						EndIf
						$iItemIndex2 = 0
						For $j = 1 To _GUICtrlListView_GetItemCount($ListView2)
							If $iID = _GUICtrlListView_GetItemText($ListView2, $j, 1) Then
								$iItemIndex2 = $j
								ExitLoop
							EndIf
						Next
						If $iItemIndex2 >= 0 Then _GUICtrlListView_DeleteItem($ListView2, $iItemIndex2)
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	ListViewItemFocus($ListView, $iItemIndex, True)
	If $iNb > 0 Then IconeFlip($PicPoubelle, "Poubelle")
EndFunc


Func ListViewDeplacerItemEnPremier($ListView, $iID, $bImage = False, $bReafficherListe = False)
	; Modifier l'ordre en base de donnes
	If Not DbPlacerItemEnPremier($iID, $bImage) Then Return
	If $bReafficherListe Then
		; modifier l'ordre visuellement
		If $bImage Then
			DbPeuplerListViewImage($ListView, $iNbMaxItemImage, $iVignetteLargeur, $iVignetteHauteur, $scNomCompletTempVignette, $bSynchronisationImage)
		Else
			DbPeuplerListViewTexte($ListView, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
		EndIf
		ListViewItemFocus($ListView, 0, True)
	EndIf
EndFunc


Func ListViewItemFocus($ListView, $iIndiceItem, $bAfficherEditeur, $bImage = False)
	Local $i, $iIndices[1]
	If Not $bImage Then
		; Dslection
		$iIndices = _GUICtrlListView_GetSelectedIndices($ListView, True)
		For $i = 1 To $iIndices[0]
			If $iIndices[$i] <> $iIndiceItem Then _GUICtrlListView_SetItemSelected($ListView, $iIndices[$i], False)
		Next
		; Slection
		_GUICtrlListView_EnsureVisible($ListView, $iIndiceItem)
		_GUICtrlListView_SetItemSelected($ListView, $iIndiceItem, True, True)
		; Afficher l'diteur
		If $bAfficherEditeur Then EditeurAfficherItem($hListViewActive, $iItemActif)
	EndIf
EndFunc


Func EditeurAfficherMasquer($iMode, $bForcer = False) ; $iMode : -1=Switcher, 0=Masquer, 1=Afficher
	Local $bMode, $iPos
	If $bAffichagerItemSurvole Then ToolTip("") ; Effacer l'ventuelle infoBulle
	GUICtrlSetData($ButtonEdRemplacer, $scCRLibBouton)
	Switch $iMode
		Case -1
			$bMode = Not $bEditeurEstAffiche
		Case 0
			$bMode = False
		Case 1
			$bMode = True
	EndSwitch
	If ($bMode <> $bEditeurEstAffiche) Or $bForcer Then
		$bEditeurEstAffiche = $bMode
		GUICtrlSetImage($PicEditeur, _Ressource("Editeur" & Number($bEditeurEstAffiche) & ".jpg"))
		If $bEditeurEstAffiche Then
			$iPos = WinGetPos($sFenetreTitre)
			If $iPos[0] + $icFenetreLargeurModeListeEtEditeur > $iEspaceBureau[2] Then $iPos[0] = $iEspaceBureau[2] - $icFenetreLargeurModeListeEtEditeur
			WinMove($sFenetreTitre, "", $iPos[0], Default, $icFenetreLargeurModeListeEtEditeur, Default)
			EditeurAfficherItem($hListViewActive, $iItemActif)
		Else
			ItemAbandonnerEdition()
			WinMove($sFenetreTitre, "", Default, Default, $iFenetreLargeurModeListe +12, Default)
		EndIf
		GUICtrlSetState($MenuItemVoirEditeur, _CheckedUnchecked($bEditeurEstAffiche))
	EndIf
EndFunc


Func EditeurAfficherItem($ListView, $iIndiceItem)
	Local $sData[11] = ['', '', '', '', '', '', '', Number($hListViewActive = $ListViewFavoris), '', '','']
	If Not $bEditeurEstAffiche Then Return
	If ($iIndiceItem < 0) Or ($iIndiceItem >= _GUICtrlListView_GetItemCount($ListView)) Then
		EditeurAfficherData("", $sData)
	Else
		Local $iID = _GUICtrlListView_GetItemText($ListView, $iIndiceItem, 1)
		If $iID > 0 Then
			$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
			; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
			If $sData[0] = $scPerdu Then Return False
		EndIf
		EditeurAfficherData($iID, $sData)
	EndIf
	; Couleur
	Local $sColor = _LireValParamPlus($sValPrpPlus, "BkC", "")
	If $iItemEnCoursEdition = 2 Then $sColor = $sCouleurDef
	If $sColor = "" Then
		_CouleurTexteEtFond($InputEdTitre, "F0F0F0", "6D6D6D")
	Else
		_CouleurTexteEtFond($InputEdTitre, $sColor, "6D6D6D")
	EndIf
	Return True
EndFunc


;0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
Func EditeurAfficherData($iID, $sData)
	Local $i, $s, $iIndCouleur = 0
	Local $sCouleurFond = _LireValParamPlus($sValPrpPlusOld, "BkC", $sCouleurDef)
	Local Const $sChecked[2] = [$GUI_UNCHECKED, $GUI_CHECKED]
	GUICtrlSetData($InputEdTitre, $sData[1])
	GUICtrlSetData($EditEdTexte, $sData[0])
	GUICtrlSetData($InputEdCommentaire, $sData[3])
	GUICtrlSetData($InputEdProvenance, $sData[2])
	GUICtrlSetData($InputEdCree, FormatDateHeure($sData[4]))
	GUICtrlSetData($InputEdModifie, FormatDateHeure($sData[5]))
	If $sData[7] = 1 Then
		GUICtrlSetData($LabelEdEtoile, "*")
	Else
		GUICtrlSetData($LabelEdEtoile, "")
	EndIf
	GUICtrlSetData($InputEdUtilise, FormatDateHeure($sData[8]))
	$sValPrpPlus = $sData[9]
	$sValPrpPlusOld = $sValPrpPlus
	; Couleur
	For $i = 1 To $sTableauCouleurs[0]
		If $sCouleurFond = $sTableauCouleurs[$i] Then
			$iIndCouleur = $i
			ExitLoop
		EndIf
	Next
	GUICtrlSetData($InputEdCouleurNum, $iIndCouleur)
	; Raccourci
	$s = _LireValParamPlus($sValPrpPlusOld, "HKy", "")
	GUICtrlSetState($CheckboxRaccourciShift, $sChecked[Number(StringInStr($s, "+") > 0)])
	GUICtrlSetState($CheckboxRaccourciCtrl, $sChecked[Number(StringInStr($s, "^") > 0)])
	GUICtrlSetState($CheckboxRaccourciAlt, $sChecked[Number(StringInStr($s, "!") > 0)])
	GUICtrlSetState($CheckboxRaccourciWin, $sChecked[Number(StringInStr($s, "#") > 0)])
	$s = StringReplace($s, "+", "")
	$s = StringReplace($s, "^", "")
	$s = StringReplace($s, "!", "")
	$s = StringReplace($s, "#", "")
	For $i = 0 To UBound($sListRaccourciCode) - 1
		If $s == $sListRaccourciCode[$i] Then
			_GUICtrlComboBox_SetCurSel($ComboRaccourci, $i)
			ExitLoop
		EndIf
	Next
EndFunc


Func ModifierValiderItem($bToPP) ; $bToPP=A passer dans le presse-papier ou pas
	If $iItemEnCoursEdition = 0 Then
		If ($iItemActif < 0) Or ($iItemActif >= _GUICtrlListView_GetItemCount($hListViewActive)) Then Return
		EditeurAfficherMasquer(1, True)
	EndIf
	Switch $iItemEnCoursEdition ; 0=Non, 1=Item modifi, 2=Nouvelle item (cration)
		Case 0
			ItemEditer(1)
		Case 1
			If ItemValiderEdition(1, $bToPP) Then EditeurAfficherItem($hListViewActive, $iItemActif)
		Case 2
			ItemValiderEdition(2, $bToPP)
	EndSwitch
EndFunc


Func ItemEditer($iMode) ; 1=Item modifi, 2=Nouvelle item (cration)
	$iItemEnCoursEdition = $iMode
	ItemEnableDisable(True)
	If $iItemEnCoursEdition = 1 Then
		GUICtrlSetData($GroupEd, " Modification de l'item ")
	Else
		GUICtrlSetData($GroupEd, " Cration d'un nouvel item ")
	EndIf
	GUICtrlSetState($EditEdTexte, $GUI_FOCUS)
	; Couleur
	Local $sColor = _LireValParamPlus($sValPrpPlus, "BkC", "")
	If $sColor = "" Then
		_CouleurTexteEtFond($InputEdTitre, $sCouleurDef)
	Else
		_CouleurTexteEtFond($InputEdTitre, $sColor)
	EndIf
EndFunc


Func ItemSortirEdition()
	If ($hListViewActive = $ListViewSelection) And (_GUICtrlListView_GetItemCount($ListViewSelection) = 0) Then
		GUICtrlSetState($InputSelectTexte, $GUI_FOCUS)
	Else
		GUICtrlSetState($hListViewActive, $GUI_FOCUS)
	EndIf
	GUICtrlSetData($GroupEd, " Dtail de l'item  ")
	$iItemEnCoursEdition = 0
	ItemEnableDisable(False)
EndFunc


Func ItemValiderEdition($iMode, $bToPP) ; $iMode:1=Item modifi, 2=Nouvelle item (cration), $bToPP : A mettre dans le presse papier
	Local $iID, $sData, $i, $s, $ListView2, $iItemIndex2 = -1
	Local $sTitre = GUICtrlRead($InputEdTitre)
	Local $sTexte = GUICtrlRead($EditEdTexte)
	Local $sCommentaire = GUICtrlRead($InputEdCommentaire)
	Local $bChangeCouleur = False, $bFavoris = False
	If $iMode = 1 Then
		$iID = _GUICtrlListView_GetItemText($hListViewActive, $iItemActif, 1)
		If $iID <= 0 Then Return False
	EndIf
	; Tester que le Titre le Texte ne soit pas vide
	If $sTexte = "" Then
		MsgBox(4144, $scMsgErreur, "Le texte du presse-papier ne peut pas tre vide !", 0, $FormClipSpirit)
		Return False
	EndIf
	If $sTitre = "" Then
		$sTitre = TitreParDefaut($sTexte)
		GUICtrlSetData($InputEdTitre, $sTitre)
	EndIf
	; Le raccourci
	$s = ""
	$i = _GUICtrlComboBox_GetCurSel($ComboRaccourci)
	If ($i > 0) And ($i < UBound($sListRaccourciLibelle)) Then
		If GUICtrlRead($CheckboxRaccourciShift) = $GUI_CHECKED Then $s &= "+"
		If GUICtrlRead($CheckboxRaccourciCtrl) = $GUI_CHECKED Then $s &= "^"
		If GUICtrlRead($CheckboxRaccourciAlt) = $GUI_CHECKED Then $s &= "!"
		If GUICtrlRead($CheckboxRaccourciWin) = $GUI_CHECKED Then $s &= "#"
		$s &= $sListRaccourciCode[$i]
	EndIf
	$sValPrpPlus = _EcrireValParamPlus($sValPrpPlus, "HKy", $s, "")
	$s = _LireValParamPlus($sValPrpPlus, "HKy", "")
	If $s <> _LireValParamPlus($sValPrpPlusOld, "HKy", "") Then
		If _LireValParamPlus($sValPrpPlusOld, "HKy", "") <> "" Then _SupprimerHotKeyTxt($iId)
		If $s <> "" Then _AjouterHotKeyTxt($iId, $s)
	EndIf
	; 1=Mise  jour, 2=Cration
	If $iMode = 1 Then
		If Not DbMAJItemTexte($iID, $sTitre, $sTexte, GUICtrlRead($InputEdCommentaire), $sValPrpPlus) Then Return False
		; Mettre  jour le titre dans la liste
		_GUICtrlListView_SetItemText($hListViewActive, $iItemActif, $sTitre, 0)
		; Mettre ventuellement  jour les couleurs
		If _LireValParamPlus($sValPrpPlus, "BkC", $sCouleurDef) <> _LireValParamPlus($sValPrpPlusOld, "BkC", $sCouleurDef) Then
			$bChangeCouleur = True
			If $hListViewActive = $ListViewSelection Then
				SelectionGo()
			Else
				DbPeuplerListViewTexte($hListViewActive, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
				ListViewItemFocus($hListViewActive, $iItemActif, False)
			EndIf
		EndIf
		; Mettre  jour dans la liste orginale si on est sur la liste de slection
		If $hListViewActive = $ListViewSelection Then
			$sData = DbItemTexteLireComplet($iID, $FormClipSpirit)
			; 0=PrpText, 1=PrpTitre, 2=PrpProvenance, 3=PrpCommentaire, 4=PrpDateCreation, 5=PrpDateModification, 6=PrpDateClassement, 7=PrpEstFavoris 8=PrpDateUtilisation, 9=PrpPlus, 10=PrpRefSynchro
			If $sData[0] = $scPerdu Then
				ItemSortirEdition()
				Return False
			EndIf
			$bFavoris = ($sData[7] <> 0) ; 7=PrpEstFavoris
			If $bFavoris Then
				$ListView2 = $ListViewFavoris
			Else
				$ListView2 = $ListViewTexte
			EndIf
			For $i = 1 To _GUICtrlListView_GetItemCount($ListView2)
				If $iID = _GUICtrlListView_GetItemText($ListView2, $i, 1) Then
					$iItemIndex2 = $i
					ExitLoop
				EndIf
			Next
			If $iItemIndex2 >= 0 Then
				_GUICtrlListView_SetItemText($ListView2, $iItemIndex2, $sTitre, 0)
				If $bChangeCouleur Then DbPeuplerListViewTexte($ListView2, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
				ListViewItemFocus($ListView2, $iItemIndex2, False)
			EndIf
		ElseIf $hListViewActive = $ListViewFavoris Then
			$bFavoris = True
		EndIf
	Else
		ItemTexteCreeOuEnPremier($hListViewActive, $sTexte, "Cration dans " & $scAppliTitreGeneral, $sTitre, ($hListViewActive = $ListViewFavoris), $sValPrpPlus, True, $sCommentaire)
	EndIf
	If $bToPP Then
		$bMajClipBoard = True
		_ClipBoard_SetData($sTexte)
		$bMajClipBoard = False
		If $iMode = 1 Then
			Switch TexteEnPremierOuMAJDate($iID, $bFavoris)
				Case 1
					DbPeuplerListViewTexte($ListViewFavoris, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
					ListViewItemFocus($ListViewFavoris, 0, True)
				Case 2
					DbPeuplerListViewTexte($ListViewTexte, $iNbMaxItemTexte, $ListViewTexte, $ListViewFavoris, $bSynchronisationTexte)
					ListViewItemFocus($ListViewTexte, 0, True)
			EndSwitch
		EndIf
	EndIf
	; Sortir de l'dition
	ItemSortirEdition()
	Return True
EndFunc


Func ItemAbandonnerEdition()
	ItemSortirEdition()
	EditeurAfficherItem($hListViewActive, $iItemActif)
EndFunc


Func ItemEnableDisable($bEnable)
	Local $iEnable = $GUI_ENABLE
	_ChampModifiable($InputEdTitre, $bEnable)
	_ChampModifiable($InputEdCommentaire, $bEnable)
	_ChampModifiable($EditEdTexte, $bEnable)
	If $bEnable Then
		GUICtrlSetState($ButtonEdRemplacer, $GUI_SHOW)
		GUICtrlSetData($ButtonEdEdiValider, "Valider+Copier")
		GUICtrlSetState($ButtonEdEnregistrer, $GUI_SHOW)
		GUICtrlSetState($ButtonEdAbandonner, $GUI_SHOW)
		If $sChaineCouleur <> "" Then GUICtrlSetState($UpDownEdCouleurNum, $GUI_ENABLE)
		GUICtrlSetState($MenuItemModifier, _CheckedUnchecked(True))
	Else
		GUICtrlSetState($ButtonEdRemplacer, $GUI_HIDE)
		GUICtrlSetData($ButtonEdEdiValider, "Modifier")
		GUICtrlSetState($ButtonEdEnregistrer, $GUI_HIDE)
		GUICtrlSetState($ButtonEdAbandonner, $GUI_HIDE)
		GUICtrlSetState($UpDownEdCouleurNum, $GUI_DISABLE)
		GUICtrlSetState($MenuItemModifier, _CheckedUnchecked(False))
		$iEnable = $GUI_DISABLE
	EndIf
	GUICtrlSetState($CheckboxRaccourciShift, $iEnable)
	GUICtrlSetState($CheckboxRaccourciCtrl, $iEnable)
	GUICtrlSetState($CheckboxRaccourciAlt, $iEnable)
	GUICtrlSetState($CheckboxRaccourciWin, $iEnable)
	GUICtrlSetState($ComboRaccourci, $iEnable)
EndFunc


Func PositionFenetre()
	If Not $bDeplacerFenetrePresCurseur Then Return
	Local $iLargeur = $iFenetreLargeurModeListe
	If $bEditeurEstAffiche Then $iLargeur = $icFenetreLargeurModeListeEtEditeur
	$iGetPos = _CaretPosCuseur()
	If @error = 1 Then Return
	$iGetPos[0] += $icEcartFenetreCurseur
	$iGetPos[1] = $iGetPos[1] - ($icFenetreHauteur / 2)
	If $iGetPos[0] < $iEspaceBureau[0] Then $iGetPos[0] = $iEspaceBureau[0]
	If ($iGetPos[0] + $iLargeur) > $iEspaceBureau[2] Then
		$iGetPos[0] = $iGetPos[0] - (2 * $icEcartFenetreCurseur) - $iLargeur
		If ($iGetPos[0] + $iLargeur) > $iEspaceBureau[2] Then $iGetPos[0] = $iEspaceBureau[2] - (2 * $icEcartFenetreCurseur) - $iLargeur
	EndIf
	If $iGetPos[1] < $iEspaceBureau[1] Then $iGetPos[1] = $iEspaceBureau[1]
	If ($iGetPos[1] + $icFenetreHauteur) > $iEspaceBureau[3] Then $iGetPos[1] = $iEspaceBureau[3] - $icFenetreHauteur - (2 * $icEcartFenetreCurseur)
	WinMove($FormClipSpirit, "", $iGetPos[0], $iGetPos[1])
EndFunc


Func _CaretPosCuseur() ; cf.  Glyph - http://www.autoitscript.com/forum/index.php?showtopic=38291
	Opt("CaretCoordMode", 0) ; relative mode
	Local $c = WinGetCaretPos() ; relative caret coords
	Local $w = WinGetPos("") ; window's coords
	Local $f = ControlGetFocus("","") ; text region "handle"
	Local $e = ControlGetPos("", "", $f) ; text region coords
	Local $t[2]
	If IsArray($c) and IsArray($w) and IsArray($e) Then
		$t[0] = $c[0] + $w[0] + $e[0]
		$t[1] = $c[1] + $w[1] + $e[1]
		Return $t ; absolute screen coords of caret cursor
	Else
		SetError(1)
	EndIf
EndFunc


; IN AAAA-MM-JJ HH:MM:SS
; OUT JJ-MM-AAAA HH:MM
Func FormatDateHeure($sDH)
	If $sDH = "" Then Return ""
	Return StringMid($sDH, 9, 2) & "-" & StringMid($sDH, 6, 2) & "-" & StringMid($sDH, 1, 4) & " " & StringMid($sDH, 12, 5)
EndFunc


Func IconeFlip($Pic, $sIcone)
	Local $i
	For $i = 1 To 2
		GUICtrlSetImage($Pic, _Ressource($sIcone & "1.jpg"))
		Sleep(100)
		GUICtrlSetImage($Pic, _Ressource($sIcone & "0.jpg"))
		Sleep(100)
	Next
EndFunc


Func TitreParDefaut($sTitre) ; idem  ClipSpiritExec.au3
	$sTitre = StringReplace($sTitre, @CR, " ")
	$sTitre = StringReplace($sTitre, @LF, "")
	$sTitre = StringReplace($sTitre, @TAB, " ")
	Return StringLeft($sTitre, $icLongMaxTitre)
EndFunc


Func _IsFocused($hControl)
    Return (ControlGetHandle($FormClipSpirit, '', $hControl) = ControlGetHandle($FormClipSpirit, '', ControlGetFocus($FormClipSpirit)))
EndFunc


Func TabPress()
	Send("^{TAB}")
EndFunc


Func MenuCheckedUnchecked($hMenu, $sCle, ByRef $bVar, $bForcerEnregistrer = False)
	$bVar = Not $bVar
	GUICtrlSetState($hMenu, _CheckedUnchecked($bVar))
	If $bForcerEnregistrer Then DbParamMAJBoolean($sCle, $bVar)
EndFunc


Func ConvertirCarAjout($sCar) ; Reconnu : CR, LF, TAB
	Local $sC = $sCar
	$sCar = StringReplace($sCar, "CR", @CR)
	$sCar = StringReplace($sCar, "LF", @LF)
	$sCar = StringReplace($sCar, "TAB", @TAB)
	Return $sCar
EndFunc


;===============================================================================
; Function Name:   _WinAPI_CopyImage
; Description:: Copies an image, also makes GDIPlus-HBITMAP to GDI32-BITMAP
; Parameter(s): $hImg -> HBITMAP Object, GDI or GDIPlus
; Requirement(s):  WinAPI.au3
; Return Value(s): Succes: Handle to new Bitmap, Error: 0
; Author(s):    Prog@ndy
; http://www.autoitscript.com/forum/topic/...images-and-the-clipboard/page_
;===============================================================================
Func _WinAPI_CopyImage($hImg, $uType = 0 ,$x = 0, $y = 0, $flags = 0)
    Local $aResult
    $aResult = DllCall("User32.dll", "hwnd", "CopyImage", "hwnd", $hImg, "UINT", $uType, "int", $x, "int", $y,"UINT", $flags)
    Return $aResult[0]
EndFunc   ;==>_WinAPI_CopyIcon



Func ToucheHotKey($iIndice)
	If $sListeHotKey[$iIndice][2] = "Txt" Then
		FonctionHotKeyTexte($hListViewActive, $sListeHotKey[$iIndice][1])
	Else
		FonctionHotKeyScript($hListViewActive, $sListeHotKey[$iIndice][2], $sListeHotKey[$iIndice][1])
	EndIf
EndFunc

Func ToucheHotKey1()
	ToucheHotKey(1)
EndFunc
Func ToucheHotKey2()
	ToucheHotKey(2)
EndFunc
Func ToucheHotKey3()
	ToucheHotKey(3)
EndFunc
Func ToucheHotKey4()
	ToucheHotKey(4)
EndFunc
Func ToucheHotKey5()
	ToucheHotKey(5)
EndFunc
Func ToucheHotKey6()
	ToucheHotKey(6)
EndFunc
Func ToucheHotKey7()
	ToucheHotKey(7)
EndFunc
Func ToucheHotKey8()
	ToucheHotKey(8)
EndFunc
Func ToucheHotKey9()
	ToucheHotKey(9)
EndFunc
Func ToucheHotKey10()
	ToucheHotKey(10)
EndFunc
Func ToucheHotKey11()
	ToucheHotKey(11)
EndFunc
Func ToucheHotKey12()
	ToucheHotKey(12)
EndFunc
Func ToucheHotKey13()
	ToucheHotKey(13)
EndFunc
Func ToucheHotKey14()
	ToucheHotKey(14)
EndFunc
Func ToucheHotKey15()
	ToucheHotKey(15)
EndFunc
Func ToucheHotKey16()
	ToucheHotKey(16)
EndFunc
Func ToucheHotKey17()
	ToucheHotKey(17)
EndFunc
Func ToucheHotKey18()
	ToucheHotKey(18)
EndFunc
Func ToucheHotKey19()
	ToucheHotKey(19)
EndFunc
Func ToucheHotKey20()
	ToucheHotKey(20)
EndFunc
Func ToucheHotKey21()
	ToucheHotKey(21)
EndFunc
Func ToucheHotKey22()
	ToucheHotKey(22)
EndFunc
Func ToucheHotKey23()
	ToucheHotKey(23)
EndFunc
Func ToucheHotKey24()
	ToucheHotKey(24)
EndFunc
Func ToucheHotKey25()
	ToucheHotKey(25)
EndFunc
Func ToucheHotKey26()
	ToucheHotKey(26)
EndFunc
Func ToucheHotKey27()
	ToucheHotKey(27)
EndFunc
Func ToucheHotKey28()
	ToucheHotKey(28)
EndFunc
Func ToucheHotKey29()
	ToucheHotKey(29)
EndFunc
Func ToucheHotKey30()
	ToucheHotKey(30)
EndFunc
Func ToucheHotKey31()
	ToucheHotKey(31)
EndFunc
Func ToucheHotKey32()
	ToucheHotKey(32)
EndFunc
Func ToucheHotKey33()
	ToucheHotKey(33)
EndFunc
Func ToucheHotKey34()
	ToucheHotKey(34)
EndFunc
Func ToucheHotKey35()
	ToucheHotKey(35)
EndFunc
Func ToucheHotKey36()
	ToucheHotKey(36)
EndFunc
Func ToucheHotKey37()
	ToucheHotKey(37)
EndFunc
Func ToucheHotKey38()
	ToucheHotKey(38)
EndFunc
Func ToucheHotKey39()
	ToucheHotKey(39)
EndFunc
Func ToucheHotKey40()
	ToucheHotKey(40)
EndFunc
Func ToucheHotKey41()
	ToucheHotKey(41)
EndFunc
Func ToucheHotKey42()
	ToucheHotKey(42)
EndFunc
Func ToucheHotKey43()
	ToucheHotKey(43)
EndFunc
Func ToucheHotKey44()
	ToucheHotKey(44)
EndFunc
Func ToucheHotKey45()
	ToucheHotKey(45)
EndFunc
Func ToucheHotKey46()
	ToucheHotKey(46)
EndFunc
Func ToucheHotKey47()
	ToucheHotKey(47)
EndFunc
Func ToucheHotKey48()
	ToucheHotKey(48)
EndFunc
Func ToucheHotKey49()
	ToucheHotKey(49)
EndFunc
Func ToucheHotKey50()
	ToucheHotKey(50)
EndFunc

#EndRegion - Fonctions secondaires
